#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

###
#
# admin_sku.cgi
#
###

###
#
# Version 0.9.11 GF 20000525 
#
#
###

## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om/admin,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$siteshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $siteshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $siteshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

$relpath .= "/../$siteshortname";

use DBI;
require "$relpath/lib/conversions.pm";
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/login.pm";
require "$relpath/conf/site.pm";
require "$relpath/lib/validate.pm";

## establish site-specific parameters
#
$site=setsite();

## get form data, if any was submitted
#
%FORM=();
&ReadParse();

$om_render_lang=$FORM{'OM_UI_LANGUAGE'};
$om_render_lang=$site->{'om_locale_lang_def'} if ( ! $om_render_lang);
$om_render_lang="eng" if ( !$om_render_lang );

## load messages
#
%script_msg=();          # user interaction messages
$script=( split /\./, $scriptname )[0];
&message;

$sid=$FORM{'sid'};


## done with pull-from-file bits, rest of global settings...
#
$x= (split /\?/, $ENV{'REQUEST_URI'})[0];   # strip get stuff
@temp=split /\//, $x;

@temp=("cgi-bin","test","admin_sku.cgi") if (! $ENV{'REQUEST_URI'} );

$n= $#temp - 1;
$scriptpath = join "/", ( @temp[0..$n] );

## path of where admin_sku templates live/also path of where selects live
#
$skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin";
$selskeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/html/sel";

## filled in with time/context variable info
#
$nicedt=nicedatetime();

## establish connection to database
#
$q = "$site->{'db_site_config'}";
$dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});            
## start the replacements hash 
#
%NVP=();
$NVP{'sitename'}=$site->{'sitename'};

@skuvars=();       # array of hashrefs for holding sku variants
@skulinks=();      # array of hashrefs for holding linkages


## catch inbounds lacking mode - homepage default
#
if (! $FORM{'mode'}) {
   $FORM{'mode'}="home";
}

## login control
#
$FORM{'sid_ok'} = check_login($script,$FORM{'mode'},$FORM{'sid'}); #in login.pm

if ( $FORM{'sid_ok'} ) {
   if ( $FORM{'sid_ok'} =~ /^ERROR/ ) {
      ## hard error, redirected to login page
      exit 0 ; 
   } elsif ( $FORM{'sid_ok'} =~ /^Error/ ) {
      ## soft error, send to default mode
      $FORM{'mode'}="home";
      $NVP{'__PAGE_ERROR_MSG__'}=$FORM{'sid_ok'};
   } else {
      ## welcome to the page...
   }   
   print "Content-type: text/html\n\n";

} else {
   ## unknown why sid_ok not populated with some string...
   #
   print "Content-type: text/html\n\n";
   print "<HTML><HEAD></HEAD><BODY>\n";
   print "$FORM{'sid'} $script_msg{1} $FORM{'sid_ok'} \n";
   exit 0;
}

open ERLOG, ">/tmp/admin_sku";
 
print ERLOG " admin_sku.cgi \n";  

print ERLOG " here i  am \n";


## Define first entries in %NVP based on mode, sid, etc...
#
$NVP{'sid'}=$FORM{'sid'};
$NVP{'lastmode'}=$FORM{'mode'};
$NVP{'script'}="$scriptpath/$scriptname";
$NVP{'datetime'}=$nicedt;
$NVP{'scriptpath'}=$scriptpath;


## now have established acceptable session id
#  proceed to display the appropriate form
#
# PREPROCESS form modes are:
#   findobject - perform a search based on 'skuskel' and
#         change mode afterwards depending upon results:
#         --> listskus (more than one found)
#         --> editsku (only one found)
#         --> home (none found, set error message)
#
# REAL form modes as follow (submode is blank,error,edit):
#   home - homepage, allows creation and editing of skus
#   editsku   - edit a sku (kind?)
#   showsku   - display a sku with linkage to variant and link admin
#
########################################################

###
# Preprocess Certain Modes prior to display
#    (the mode parameter changes based on the outcome
#    of the preprocessing).
#
# check to see if the homepage is simply clearing the form


if (($FORM{'searchclear'}) and ($FORM{'mode'} eq "findobject")) {
   $FORM{'mode'}="home";
} #

# real preprocessing
#

## variants mode, big chunk, variants is handled separately from the flow of the
#  other editskus b/c etc, etc,  -- it's almost it's own script within admin_sku
#  NOT just variants is handled here, also prices
#  again, variants does NOT go through writeskutodb, loadskufromdb, etc, etc.
#  this is both PRE and process and POST 
###

if ($FORM{'mode'} eq "variants") {

    #load primary permute hash values
    #

    $NVP{'pagetitle'}="$script_msg{2} $FORM{SKU} \n";
    $NVP{'select1'}="&nbsp;";
    $NVP{'select2'}="&nbsp;";
    $NVP{'select3'}="&nbsp;";
    $NVP{'select4'}="&nbsp;";

    ## retrieve appropriate variant encodings of the sku and generate appropriate
    #  variant selects 
    #

    $q="select AXISNAMES from things where SKU='$FORM{SKU}'"; #axisnames later
    $sth=$dbh->prepare($q);
    $sth->execute;
    $num=$sth->rows;
    for (1..$num) {
	$axesnames = $sth->fetchrow;
	@axes= split /:/, $axesnames;
	for ($i=0; $i <= $#axes; $i++) {
	    $k=$axes[$i];
	    $j=$i+1;
            $newk="AXIS".$j;
	    $newkt=$newk."_SELECT";
            open(FH, "<$selskeletonpath/$k.sel");
            @raw=<FH>;
            chomp @raw;
            close(FH);
	    $newx=$newk."_inp";
	    $newkpre=$newk."_pre";
	    $v=3;
	    $select="select".$j;
	    $NVP{$newkt}= myhomegen_select( $FORM{$newx},$v,@raw);
	    $NVP{$select}.=" <input type=hidden name=$newkpre value=$newkpre>";
	    $NVP{$select}.=" <SELECT NAME=$newx> $NVP{$newkt} </SELECT> ";

       } # done with new/existing pulldown choice
   }
    

  # $NVP{'pagetitle'}.=" variant sku is $axesnames ";   # does not use
  ##extracts and strings together all the vcode selections
  #

  #$vcode=$FORM{AXIS1_inp}.":".$FORM{AXIS2_inp}.":".$FORM{AXIS3_inp}.":".$FORM{AXIS4_inp};

  $vcode=$FORM{AXIS1_inp} if $FORM{AXIS1_inp};
  $vcode.=":".$FORM{AXIS2_inp} if $FORM{AXIS2_inp};
  $vcode.=":".$FORM{AXIS3_inp} if $FORM{AXIS3_inp};
  $vcode.=":".$FORM{AXIS4_inp} if $FORM{AXIS4_inp};  

    $nothing="";
  #  $vcode=~ s/:::/$nothing/g;


  if ($axesnames eq "" || $vcode eq ":::" ) {$vcode=""};  # no vcode 

  $q="select * from variants where sku='$FORM{SKU}' and vcode='$vcode'";

  $sth=$dbh->prepare($q);
  $sth->execute;
  $num=$sth->rows;
    
  if ($num == 0) {  
      $q2="INSERT into variants (sku, vcode, isbn, weight, ship_dim) values('$FORM{SKU}','$vcode','$FORM{ISBN_inp}','$FORM{WEIGHT_inp}','$FORM{SHIP_DIM_inp}' ) ";
  } elsif ($num == 1 ) {

      $wow=$sth->fetchrow_hashref;
    
      if (!$FORM{ISBN_inp}) {$FORM{ISBN_inp}=$wow->{'ISBN'};}
      if (!$FORM{SHIP_DIM_inp}) {$FORM{SHIP_DIM_inp}=$wow->{'SHIP_DIM'};}
      if (!$FORM{WEIGHT_inp}) {$FORM{WEIGHT_inp}=$wow->{'WEIGHT_inp'};}

      $q2=" UPDATE variants SET vcode='$vcode', isbn='$FORM{ISBN_inp}', weight='$FORM{WEIGHT_inp}', ship_dim='$FORM{SHIP_DIM_inp}' where sku='$FORM{SKU}' and vcode='$vcode' ";
     
  }
  $sth2=$dbh->prepare($q2);
  $sth2->execute;

  for ($i=1; $i <= 9; $i++) {  #really crappy hack of prices, will change later-soch
     $unitpr = "unitpr".$i."_inp";
     $unitct = "unitct".$i."_inp";
     $groupid = "groupid".$i."_inp";
     $pkflag = "pkflag".$i."_inp";
     $status = "STATUS".$i."_INP";
     $id = "select * from prices where sku='$FORM{SKU}' and vcode='$vcode' and prid='$i' ";
     $sthid=$dbh->prepare($id);
     $sthid->execute;
     $numid=$sthid->rows;
    
     if ($numid == 0) {
	$p="INSERT into prices (unitpr, unitct, groupid, pkflag, prid, sku, vcode, status) values('$FORM{$unitpr}', '$FORM{$unitct}', '$FORM{$groupid}', '$FORM{$pkflag}','$i', '$FORM{SKU}', '$vcode', '$FORM{$status}' ) ";
     } else {
	$p="UPDATE prices SET unitct='$FORM{$unitct}', unitpr='$FORM{$unitpr}', groupid='$FORM{$groupid}', pkflag='$FORM{$pkflag}', status='$FORM{$status}' where sku='$FORM{SKU}' and vcode='$vcode' and prid='$i'"; 
     }
     
     $unitctpre = "unitct".$i."_pre";
     if ($FORM{$unitct}) {
	$stp=$dbh->prepare($p);
        $stp->execute; 
     }

  }

  $end="delete from variants where vcode='--' or vcode=':::' or vcode like '%: ::%' ";
  $ste=$dbh->prepare($end);
  $ste->execute;

  $NVP{'variants'}="";
    
  $q="select vcode, ISBN, weight, ship_dim from variants where sku='$FORM{SKU}' ";
  $sth=$dbh->prepare($q);
  $sth->execute;
  $num=$sth->rows;

  for (1..$num) {
     ($vcode, $isbn, $weight, $ship_dim)= $sth->fetchrow;
if (!$isbn) {$isbn="";}

     if (!$vcode) {$vcode="";}

    next if ($num > 1 && $vcode eq "") ; 


###### this needs to be put into a cell and permute  (todogf)
#

    $NVP{'variants'}.="  VCODE = $vcode $script_msg{3} # = $isbn -- $script_msg{4} = $weight  -- <A HREF=\"inventory.cgi\?mode=findsku&sid=$FORM{'sid'}&skuskel=$FORM{SKU}\"> $script_msg{5} </a> <BR> ";

#
#######

     $qP=" select unitpr, unitct, groupid, pkflag, prid, status from prices where sku='$FORM{SKU}' and vcode='$vcode' ";
        
     $sthP=$dbh->prepare($qP);
     $sthP->execute;
     $numP=$sthP->rows;
     for (1..$numP) {
	($unitpr, $unitct, $groupid, $pkflag, $prid, $status)=$sthP->fetchrow;

##### also put into cell and permute (todogf)
#

#$NVP{'variants'}.= "unitct=$unitct unitpr=$unitpr groupid=$groupid pkflag=$pkflag prid=$prid status=$status <BR> ";

$NVP{'variants'}.= "unitct=$unitct unitpr=$unitpr prid=$prid status=$status <BR> ";

#
####

     }

#### put into cell ##########

     $NVP{'variants'}.=" <BR> ";

############################

   }

   foreach ( 'BRAND|8', 'PRICESTATUS|2') {
      local($k,$v,$x,@raw);
      ( $k,$v) = split /\|/, $_;
      open(FH, "<$selskeletonpath/$k.sel");
      @raw=<FH>;
      chomp @raw;
      close(FH);
      $x=$k."_inp";
      $kt=$k."_SELECT";
      $NVP{$kt}= gen_select( "",$v,@raw );
   }
   &checkformbits();
   &writetonvp();

$FORM{ISBN_pre}=$FORM{ISBN_inp};   
$FORM{WEIGHT_pre}=$FORM{WEIGHT_inp};
$FORM{SHIP_DIM_pre}=$FORM{SHIP_DIM_inp};
    
    $NVP{unitpr1_pre}="";
    $NVP{unitct1_pre}="";
    $NVP{unitpr2_pre}="";
    $NVP{unitct2_pre}="";

   $v="os_allcommerce-admin_sku-editskuZ";
   $l = loadtemplate ( $v, $skeletonpath );
   $l = permutebit( $l, \%NVP );
   $l = permutebit( $l, $site ); # JN inserting the whole hash in

   $l=~ s/<\!--#include virtual=\"openmerchant-admin_sku-spine.html\"-->/$spine/gms;
   $l=~ s/__BRAND_SELECT__/$NVP{'BRAND_SELECT'}/gms;  
   $l=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG__'}/gms;
   $l=~ s/__script__/$scriptpath\/$script.cgi/gms;
   $l=~ s/__sid__/$sid/gms;
   $l=~ s/__mode__/$FORM{'mode'}/gms;
   $l = permuteclean($l);
   print $l;
   $already="yes";

} ## END variants nightmare, HAVE to rewrite later--soch


###preprocess findobject mode
#
if ($FORM{'mode'} eq "findobject") {
   # perform a search against the database
   #
   ## cleanup submitted data
  
   chomp $FORM{'objskel'};
   chomp $FORM{'keyword'};
   chomp $FORM{'brand'};
   $x=length($FORM{'objskel'});
   $x+=length($FORM{'keyword'});
   $x+=length($FORM{'brand'});

print ERLOG " in findobject \n";

print ERLOG "x is $x \n";

# glenn

   if ($x>=2) {  #minimum search is a storecode and a number, i.e. i0

      $query = "SELECT objid,msku,repl_by,title,brief,objtype,";
      $query .="objclass,keywords from things ";
      $query .="WHERE ";
      $flag=0;

      if ( length($FORM{'objskel'})>1 ) {
         $query .="( objid LIKE '\%$FORM{'objskel'}\%' OR ";
         #$query .="msku LIKE '\%$FORM{'objskel'}\%' OR ";
         $query .="repl_by LIKE '\%$FORM{'objskel'}\%' )";
         $flag=1;
      } #/done length of objskel

      if ( length($FORM{'keyword'})>1 ) {
         if ($flag) {
            $query .= " AND ";
         }

         $query.="( title LIKE '%$FORM{'keyword'}%' OR ";
         $query.="brief LIKE '%$FORM{'keyword'}%' OR ";
         $query.="keywords LIKE '%$FORM{'keyword'}%' ) ";
         $flag=1;

      } #/done length of keyword 

      if ( length($FORM{'brand'})>1 ) {
         if ($flag) {
            $query .= " AND ";
         }
         $query.="( objtype='$FORM{'brand'}' ";
         $query.="OR objid='$FORM{'brand'}' ) ";
         $flag=1;
      } 

print ERLOG " $query \n";

      $query .=" ORDER BY TITLE ";
      $sth = $dbh->prepare( $query );
      $sth->execute;
      $num = $sth->rows;
      $num=0 if (! $num);      #interesting
      $num=0 if ($num < 0);    #even more interesting--paranoia

      print ERLOG " $num \n";

                                    # the query returned nothing, 
                                    # default to home mode      
 
      if ( ! $num ) {
         $FORM{'mode'}='home';

         ## push error message into page error message 
         #
         $errm=$script_msg{6};  
         $NVP{'PAGE_ERROR_MSG'}=$errm;
         $NVP{'skuskel_prev'}=$FORM{'skuskel'};

      } elsif ( $num==1 ) {
         ## exactly one row returned
         # --> send directly to appropriate editor routine

         @row=$sth->fetchrow;
         $FORM{'mode'}="editsku"; 
         $FORM{'loadfrom'}="db";    
         $NVP{'objskel_prev'}=$FORM{'objskel'};
         $NVP{'objid'}=$row[0];
         $FORM{'objid'}=$row[0];

print ERLOG " how do i get out of here \n";
print ERLOG " $FORM{'objid'} \n";


# ferby

      } else {
         # more than one row returned, show list of skus
         # and allow selection based on that
         #
         # read out skus and stash relevant bits in array
         #
         $FORM{'mode'}="searchlist";
         $FORM{'query'}=$query;
      }
      $sth->finish;

   } else {
      #mode default to home
      #
      $FORM{'mode'}="home";
      $NVP{'skuskel_prev'}=$FORM{'skuskel'};
      $errm="$script_msg{7} $FORM{'skuskel'} $script_msg{8} <BR> $script_msg{9}";
      $NVP{'PAGE_ERROR_MSG'}=$errm;
   }
} 

print ERLOG " what is the mode, $FORM{'mode'}\n";

##preprocess editsku mode
#
if ($FORM{'mode'} eq "editsku" ) {

# glenn3
   
 print ERLOG " preprocessing editsku mode \n";

 print ERLOG " loadfrom is $FORM{'loadfrom'} \n";

   ## 
   # 
   $FORM{'loadfrom'}="def" if (! $FORM{'loadfrom'}); 

   ## load sku data into the "_inp" hash entries 
   #
 
   if ( $FORM{'loadfrom'} eq "db" ) {

print ERLOG "\n  Before loadskufromdb \n ";
print ERLOG "$FORM{'mode'} \n";

      ## load the data from the tables for this sku
      #
      &loadskufromdb($FORM{'objid'});

# glennf

print ERLOG "$FORM{'mode'} \n";
print ERLOG "\n  After loadskufromdb \n ";

# glenn

   
   } elsif ( $FORM{'loadfrom'} eq "form" ) {
 
      ## load the data from the submitted form elements
      #
      ## cannonicalize brand authors to lowercase
 
      if ( $FORM{'objtype'} eq "47004-A" || "47005-A" ) {
         $FORM{'sku_skel_inp'}=~tr/A-Z/a-z/ ;
         $FORM{'brand_inp'}=$FORM{'objtype'};
      } # done, otherwise leave alone 
 
      &checkformbits();

   } else {
      # this is the defaults for a new sku
 
      &loadskufromdef();
     
   }
 
   ## done loading data into the %FORM hash
   #  now run through error checking

print ERLOG " validate field \n";

   $okdata=validatefields();
   
print ERLOG " done checking validation, are we ok,  $okdata \n";
print ERLOG " rv is $okdata \n";


   ## now run decision trees based on 'loadfrom' and $okdata
   #
   if ( $okdata ) {               # no errors checking data

print ERLOG "loadfrom is $FORM{'loadfrom'} \n ";

      if ( $FORM{'loadfrom'} eq "form" ) {           # this is a form submission, 
                                                     # data can be written

         # glenn

         print ERLOG "Before write to db \n";

         $x=writeskutodb();

         print ERLOG "After write to db \n x is $x";
         print ERLOG "formmode is $FORM{'mode'}\n";

if ( $x ) {

        $FORM{'mode'}="editsku";
        $FORM{'brand_err'}=$x;

} else {

  ## change mode to display sku
  #
  $skulink="<A HREF=admin_sku.cgi";
  $skulink.="\?\&mode=findobject&objskel=$objid&sid=$FORM{'sid'}\>$objid</A> Sucessfully.";
  $skulinks=" Edit <A HREF=linkage.cgi";
  $skulinks.="\?\&mode=editlink&obj1=$objid&sid=$FORM{'sid'}&loadfrom=db>Links</A>";
	
         if ( $FORM{'newflag'} =~ /y/i ) {
           # $NVP{'lastaction'}="$skulink $script_msg{10} $skulinks<BR>";
            $NVP{'lastaction'}="Created $skulink $skulinks<BR>";

         } else {

print ERLOG "objid is $objid \n";
print ERLOG "------------------ $skulink is skulink ------------ \n ";
            $NVP{'lastaction'}="$script_msg{11} $skulink - $skulinks<BR>";
         }

         if ($FORM{'skukind'} eq "P") {
	        $variants="<A HREF=admin_sku.cgi";
            $variants.="\?\&mode=variants&SKU=$FORM{'SKU'}&sid=$FORM{'sid'}&skukind=Z>";
            $variants.="$FORM{'SKU'}</A>";
            $NVP{'lastaction'}.=" $script_msg{12} $variants  <BR> ";
         }
    
  #       $FORM{'mode'}="editsku" if ( $x );

} #/done with x

     } #/done with okdata

   } else {

print ERLOG "$rv here \n";

      # there is no else 
   } #end of if okdata

} # /editsku preprocessing


print ERLOG "$targ \n";

## Define the target file for processing ( note .html or more filename needed )
#

$targ="os_allcommerce-".$script."-".$FORM{'mode'};

print ERLOG "$targ \n";


########################################################
## Primary Display Mode Handling

if ($FORM{'mode'} eq "searchlist") {
    &printsearch; 

} elsif ( $FORM{'mode'} eq "editsku" ) {

print ERLOG " In primary display handling \n";

   # the form displayed will depend upon the kind
   # of thing that the sku is - sellable, display, other
   # 2 vars determine form used:
   #     - is it a new creation or editing 
   #     - what kind of sku is it?   
   #
   &writetonvp;          # push the form data to %NVP
   %sku_name = (


      "45000-A" => "$script_msg{13}",
      "47001-A" => "$script_msg{14}",
      "E" => "$script_msg{15}",
      "47000-A" => "$script_msg{16}",
      "47004-A" => "$script_msg{17}",
      "47005-A" => "$script_msg{32}",
      "V" => "$script_msg{18}",
      "C" => "$script_msg{19}",
      "Z" => "$script_msg{20}",
      "X" => "$script_msg{21}" 
   );

   # title the page suitably
   $k=$FORM{'objtype'};
   $v=$sku_name{$k};
   $NVP{'objtype'}=$FORM{'objtype'};

print ERLOG " k is $k, v is $v nvpobjid is $NVP{'objtype'}\n";
print ERLOG "formnewflag is $FORM{'newflag'} \n";

   if ( $FORM{'newflag'} eq "Y" ) {

print ERLOG "in newflag \n";

      $pagetitle="$script_msg{22} $v $objid";
      $NVP{'newflag'}="Y";

print ERLOG "$pagetitle \n";

   } else {
      $pagetitle="$script_msg{23} $v $script_msg{24} ObjectID $FORM{'objid'} ";
   }

#ferby

   $NVP{'pagetitle'}=$pagetitle;

print ERLOG "$NVP{'pagetitle'} \n";

   $NVP{'loadfrom'}="form";

   ## html-safe encode all of %NVP before pulldown generation
   #
   foreach ( keys %NVP ) {
      $NVP{$_} = string_tohtml( $NVP{$_} );     #in formtools.pm
   }
   
   ## Generate the Select Pulldowns 
   #
   foreach ( 'CATEGORY|2','SUB_CATEGORY|8', 'MFG_SELECT|2', 'VENDOR_SELECT|2', 'BRAND|8', 'WEIGHTING|2','BEHAVIOR|2','STATUS|2','PAGESTYLE|8', 'AXIS1|3', 'AXIS2|3', 'AXIS3|3', 'AXIS4|3' ) {
      local($k,$v,$x,@raw);
      ( $k,$v) = split /\|/, $_;
      open(FH, "<$selskeletonpath/$k.sel");
      @raw=<FH>;
      chomp @raw;
      close(FH);
      $x=$k."_inp";
      $kt=$k."_SELECT";
      if (( ! $FORM{'newflag'} ) and ( $k eq "BRAND" )) {  ##need to get this back in
         $NVP{$kt}= gen_safeselect( $FORM{$x},$v,@raw );   
      } else {
         $NVP{$kt}= gen_select( $FORM{$x},$v,@raw );
      } # done with new/existing pulldown choice
   }

print ERLOG " here I am \n";

# process the template file and dump to stdout

if (!$NVP{'lastaction'}) {  

                              # set the target name for 
                              # the page template used

print ERLOG " am I a dumb ass,  $FORM{'objtype'} \n";


   if ( $FORM{'objtype'} eq '45000-A' ) {
      $v=$targ."-"."product"; 

   } elsif ( $FORM{'objtype'} eq '47004-A' ) {
      $v=$targ."-"."brand";

   } elsif ( $FORM{'objtype'} eq '47005-A' ) {
      $v=$targ."-"."prodline";     

   } elsif ( $FORM{'objtype'} eq '47001-A' ) {
      $v=$targ."-"."article";

   } elsif ( $FORM{'objtype'} eq '47000-A' ) {
      $v=$targ."-"."internal";

   }

  $l = loadtemplate ( $v, $skeletonpath );
  $l = permutebit( $l, \%NVP );
  $l = permutebit( $l, $site ); # JN inserting the whole has in

  $l=~ s/<\!--#include virtual=\"openmerchant-admin_sku-spine.html\"-->/$spine/gms;
  $l=~ s/__BRAND_SELECT__/$NVP{'BRAND_SELECT'}/gms;  
  $l=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG__'}/gms;
  $l=~ s/__script__/$scriptpath\/$script.cgi/gms;
  $l=~ s/__sid__/$sid/gms;
  $l=~ s/__mode__/$FORM{'mode'}/gms;
  $l = permuteclean($l);
  if (!$already) { print $l;} }

} else {
  
print ERLOG " again \n";

   ## Generate the Select Pulldowns 
   #
   foreach ( 'BRAND|8') {                   #NEED to move these genselects to beginning
      local($k,$v,$x,@raw);                 #so won't need to keep repeating stupid 
      ( $k,$v) = split /\|/, $_;            #code 
      open(FH, "<$selskeletonpath/$k.sel");
      @raw=<FH>;
      chomp @raw;
      close(FH);
      $x=$k."_inp";
      $kt=$k."_SELECT";
      $NVP{$kt}= gen_select( "",$v,@raw );
   }

print ERLOG "\n\n here I am \n";

print ERLOG "$targ \n"; 
  
   $spine=loadtemplate("openmerchant-admin_sku-homespine", $skeletonpath);
   $NVP{'script_version'}=$script_version;
   $l = loadtemplate( $targ , $skeletonpath );
   $l = permutebit( $l, \%NVP );
   $l = permutebit( $l, $site );

   $l=~ s/<\!--#include virtual=\"openmerchant-admin_sku-homespine.html\"-->/$spine/gms;
   $l=~ s/__script__/$scriptpath\/$script.cgi/gms; 
   $l=~ s/__BRAND_SELECT__/$NVP{'BRAND_SELECT'}/gms;
   $l=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG'}/gms;
   $l=~ s/__sid__/$sid/gms;
   $l=~ s/__mode__/$FORM{'mode'}/gms;         ##gotta be a better way to subs--later
   $l = permuteclean($l);
   if (!$already) { print $l}; 
}


####only generate select temps if variant encoding, system encoding or brand was added
##
#

if ($FORM{'SKU'} =~ /xev/ || $FORM{'SKU'} =~ /xec/ || $FORM{'SKU'} =~ /xbr/ ) {

`$site->{'fsrootcron'}/generate_temps.pl $site->{'siteshortname'} $FORM{'SKU'}`;

}

if ($NVP{'lastaction'}) {   ###Do I really need this??

   foreach ( 'BRAND|8') {                   #NEED to move these genselects to beginning
      local($k,$v,$x,@raw);                 #so won't need to keep repeating stupid
      ( $k,$v) = split /\|/, $_;            #code
      open(FH, "<$selskeletonpath/$k.sel");
      @raw=<FH>;
      chomp @raw;
      close(FH);
      $x=$k."_inp";
      $kt=$k."_SELECT";
      $NVP{$kt}= gen_select( "",$v,@raw );
   }

   $NVP{'script'} = "/cgi-bin/om/admin/admin_sku.cgi";
   $targ="os_allcommerce-admin_sku-home";
   $l = loadtemplate($targ, $skeletonpath);
   $l = permutebit($l, \%NVP);
   $l = permutebit($l, $site ); # JN

   $spine=loadtemplate("openmerchant-admin_sku-homespine", $skeletonpath);
   $l=~ s/<\!--#include virtual=\"openmerchant-admin_sku-homespine.html\"-->/$spine/gms;
   $l=~ s/__BRAND_SELECT__/$NVP{'BRAND_SELECT'}/gms;
   $l=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG'}/gms;
   $l=~ s/__script__/$scriptpath\/$script.cgi/gms;
   $l=~ s/__sid__/$sid/gms;
   $l=~ s/__mode__/$FORM{'mode'}/gms;
   $l = permuteclean($l);
   if (!$already) {print $l};
}

$dbh->disconnect if ( $dbh );


######################################################
## subroutines
##
######################################################

##### validatefields
#        takes all %FORM entries, seeks _inp entries, and 
#        performs field-by-field validation, with 
#        generation of _err error messages in %FORM as needed
#     returns 1 for OK, 0 for errors
#        - run after checkformbits
#        - does not need explicit fieldlist
#     Version 1 RF 981123

sub validatefields {
   # reads global %FORM
   my(@keys,$k,$e,$rv);
   $rv=1;                  # default OK, to 0 if error
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      next if ( $k !~ /_inp$/ );
      $kt = $k;
      $kt =~ s/_inp$// ;

   #  next if ( $kt =~ /[a-z]/ );   # fields are all lowercase 

      $e=validatefield( $kt,$FORM{$k}, \%FORM );

      if ($e) {
         $rv=0;           # there was an error returned
         $kt.="_err";
         $FORM{$kt}=$e;   # emplace the error message 
      } # done checking for a returned error
   } # done running through form keys 
   return $rv;
} #/validatefields


##### checkformbits - checks population of _inp, does not touch
#        NVP hash
#

sub checkformbits {
   # goes through global %FORM
   #
   my($k,$kt,@keys);
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      next if ( $k =~ /_ini$/ );   # nothing to do with ini
      if ( $k =~ /_pre$/ ) {

         # check to see if the inp key exists
         # if it doesn't exist, then create and set to _pre
         $kt=$k;
         $kt =~ s/_pre$/_inp/ ;
         $FORM{$kt}=$FORM{$k} if ( ! exists($FORM{$kt}) );
      } # only really concerned with _pre/_inp pairs
   } # done with all keys


   ## special case - objtype 
   #
  
   if ((! $FORM{'objtype'} ) and ( $FORM{'objtype_inp'} )) {
      $FORM{'objtype'}=$FORM{'objtype_inp'};   
   }

   if (( $FORM{'objtype'} ) and (! $FORM{'objtype_inp'} )) {
      $FORM{'objtype_inp'}=$FORM{'objtype'};   
   } # end of filling in objtype

   return 1;

} #/checkformbits

##### writetonvp - write form data to NVP hash
sub writetonvp {
   # could rewrite to take a hashref
   my(@keys,$k,$kt);
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      $kt = $k;
      $kt =~ s/(_ini|_inp|_pre|_err)$// ;
      if ( $k =~ /_inp$/ ) {           # _inp -> _pre
         $kt.="_pre";
         $NVP{$kt}=$FORM{$k};
      } elsif ( $k =~ /_ini$/ ) {      # _ini -> _ini
         $NVP{$k}=$FORM{$k};
      } elsif ( $k =~ /_err$/ ) {      # _err -> _err
         $NVP{$k}=$FORM{$k};
      } elsif ( $k eq $kt ) {          # X -> X
         if (( $kt !~ /[a-z]/ ) and ( ! exists($NVP{$kt}) )) {
            # this looks like a fieldname and is not yet set
            $NVP{$kt}=$FORM{$kt} if ( $FORM{$kt} );
         }
      } # any other inheritance modes?
   } # done running through form keys
   ## special cases
   #
   $NVP{'skukind'}=$FORM{'SKUKIND_inp'} if (( ! $NVP{'skukind'} ) and ( $FORM{'SKUKIND_inp'} ));
   return 1; 
} #/writetonvp

##### LoadSkuFromDb
#
#
sub loadskufromdb {

   # it is not a new sku, fields have values
   # load information from table

   $q = 'SELECT * from things';
   $q.= " WHERE objid='$FORM{'objid'}' ";
   $sth = $dbh->prepare( $q );
   $sth->execute;
   $num = $sth->rows;

print ERLOG "In loadskufromdb \n";

print ERLOG "q is $q \n";
print ERLOG "num is $num \n";

   if ( $num==1 ) {
      # query returned exactly one record
      $h = $sth->fetchrow_hashref;

      ## set one default
      #
      $FORM{'objtype'}=$h->{'objtype'};

      $objid=$h->{'objid'};

print ERLOG "formobjid is $FORM{'objtype'} \n";

      foreach (keys %{$h} ) {
         $x = string_exdbi($h->{$_});
         $kt=$_."_inp";
         $FORM{$kt}=$x if ( ! exists($FORM{$kt}) );
      } 
       
      ## now dig out the DESCRIPTION and other extracopy fields
      #
      $q ="SELECT objid,fieldname,body from extraprop ";
      $q.=" WHERE objid LIKE '$FORM{'objid'}%' ";
      $sth = $dbh->prepare( $q );
      $sth->execute;
      $num = $sth->rows;

print ERLOG "q is $q \n";
print ERLOG "num is $num \n"; 

      while ($num) {
         ( $x,$i,$k ) = $sth->fetchrow;

         $k=string_exdbi($k);
         $kt=$i."_inp";        
         $FORM{$kt}=string_tohtml($k) if ( ! $FORM{$kt} );
        
         ## added population of _pre fields 0.7.3 RF 990821
         #  long time ago done by pushing _inp -> _pre in validation
         #
         $kt=$i."_pre";        
         $FORM{$kt}=string_tohtml($k) if ( ! $FORM{$kt} );

         $num--;
      }

#      ## now get variant data, if appropriate and extant
#      #
#      $q='SELECT * from variants where ';
#      $q.=" SKU='$FORM{'SKU'}' ";
#      $sth=$dbh->prepare($q);
#      $sth->execute;
#      $num=$sth->rows;
#      while ($num) {
#         push @skuvars, $sth->fetchrow_hashref;
#         $num--; 
#      } # done loading variants

   } else {
      # there was an error!
      # send back to homepage with error message
      $FORM{'mode'}="home";
   }

   $sth->finish;
   return 1;
} #/loadskufromdb

##### WriteSKUtoDB
#        version 3 - 20000525 GF
#        version 2 - 981123
#        takes sku data from %FORM{_inp|X} entries
#        need to change logical name of prod and extracopy to things and extraprop
#        but later
########

sub writeskutodb {
   ## see whether passed enough data
   #
   my($rv,$sku,$fields_prod,$fields_var,$fields_extra,$nsku);
   my(%product,%variant,%extracopy,$q,$sth);

print ERLOG " In writeskutodb \n";

   $rv="";      # return value, blank is good
   $nsku=0;
   $nsku=1 if ( $FORM{'newflag'} =~ /[Yy]/ );
 
   $now=time();
 
   $sku="";
   $sku=$FORM{'msku'} if ( ! $nsku ); 

print ERLOG " Do we have a sku? $sku \n";

   if ( ! validatesku($sku) ) {     # no error message is OK
       # have a good sku in $sku

       $objid=$FORM{'objid'};    # set an objid
       
print ERLOG "\n\n\n weh have a good sku \n ";
print ERLOG "$objid is $FORM{'objid'} \n";


   } else {

print ERLOG "In Else in writeskutodb \n nsku is $nsku ";

      # need a sku, or have a bad one
      #
      if ( $nsku ) {

print ERLOG " Brand input is $FORM{'brand_inp'} \n";

         if ( ! validatebrand($FORM{'brand_inp'}) ) {  # useable brand

        #    $q="SELECT AUTHOR,SKU from things ";

            $q="SELECT body,objid,fieldname from extraprop ";
            $q.=" where objid='$FORM{'brand_inp'}' and fieldname='sku_skel' ";
            $sth = $dbh->prepare( $q );
            $sth->execute;

print ERLOG " in Brand and row in db is $sth->rows \n";
print ERLOG "$q \n"; 

          if ( $sth->rows ) {        # got at least one row
             $skel = ( $sth->fetchrow )[0];

             print ERLOG " skel is $skel \n";

             $skel =~ tr/ //d ;

             # check the length of what we have and see 
             # if it the ample sku length

          if ( $site->{'site_sku_prelen'} == length($skel) ) {

             print ERLOG "sku lengths match \n";

             # now get the next value for this sku

             print ERLOG " before nextskuinseries \n";

             $sku=nextskuinseries($skel);

             print ERLOG " $sku \n";

             if ( length($sku)!= $site->{'site_sku_totlen'} ) {
                     $rv="$script_msg{25} ";
                     $rv.=" matching $skel";

print ERLOG " in if and  length($sku) is not equal to
$site->{'site_sku_totlen'}\n";


             } else {        # this matches the value for 
                             # site_sku_totlen set in site.pm
   
print ERLOG " creating an event \n";

                                                   # create an objid
 
                  $dvalue="$sid\t Create ObjID";
 
                  $q="INSERT into levents (dtable,dvalue,cdate,series) values ";
                  $q.=" ('things','$dvalue','$now','$site->{'series'}') ";
                  $dbh->do($q);
 
                  $q="SELECT event,series from levents where dtable='things' ";
                  $q.= " and dvalue='$dvalue' and cdate='$now' ";
                  $sth=$dbh->prepare($q);
                  $sth->execute;
                  ($event, $series)=$sth->fetchrow;
                  $objid=$event."-".$series;
 
                  print ERLOG "Created objid: $objid\n";       

                  ## make an entry for this object sku in things 
                  #
                  $q="INSERT INTO things (objid,msku,cdate) VALUES ";
                  $q.=" ('$objid','$sku','$now') ";
                  $dbh->do($q);
                  $FORM{'msku'}=$sku;

                  } #/done examining new sku's length

           } else { 
              $rv="$script_msg{26} $skel $script_msg{27}";
           } #/done examining skeleton length
 
         } else {          # if no rows
            $rv="$script_msg{28} ";
            $rv.=" $FORM{'brand_inp'} $script_msg{29}";
         } #/done seeing if the brand has a record
 
      } else {                              # not useable brand
         $rv="$script_msg{30} $FORM{'brand_inp'} $script_msg{29}";
      } #/end of brand useable or not       
 
   } else {
       $rv="$script_msg{31} $sku $script_msg{29}";
   } # end of new vs. bad sku
 
} #/end of sku validation or assignment  

   ## now have a valid sku in $sku if ! $rv
   #
   if ( ! $rv ) {
      ## get fields in products
      #
      $q="SELECT * from things ";
      $sth=$dbh->prepare( $q );
      $sth->execute;
      $num=$sth->rows;

print ERLOG " I am in !rv \n num is $num\n ";

      if ($num > 0) {
         $h = $sth->fetchrow_hashref;

      } else {
         $h={};
      }

      $fields_prod = join ',', ( keys %{$h} );

#      ## get fields in variants
#      #
#      $q='SELECT * from variants ';
#      $sth = $dbh->prepare( $q );
#      $sth->execute;
#      $num = $sth->rows;
#
#      if ($num>0) {
#         $h = $sth->fetchrow_hashref;
#      } else {
#         $h={};
#      }
#      $fields_var = join ',', ( keys %{$h} );
#      ## all other fields are extra_copy
#      #

# glenn now here

      ## go through the form fields and push them into products
      #
      %product=();
      %extracopy=();

      foreach ( keys %FORM ) {
         next if ( $_ !~ /_inp$/ );
         next if ( $_ =~ /^msku$/ );
         $k=$_;    
         $kt=$k;
         $kt=~ s/_inp$// ;
#         next if ( $kt =~ /[a-z]/ );          # no lowercase in fields



         if ( $fields_prod =~ /$kt/ ) {      # product field
            $product{$kt} = $FORM{$k};

#         } elsif ( $fields_var =~ /$kt/ ) {  # variant field
#            $variant{$kt} = $FORM{$k};

         } else {                            # assume extracopy field 
            $extracopy{$kt}=$FORM{$k}; 
         }

      }

      ## now have fields split out into target tables
      #

      # update products first
      $q="";

      foreach ( keys %product ) {
         $q.="," if ( $q );
         $q.=$_."='".string_todbi($product{$_})."'";
      }

      if ($q) {
         $q.=",mdate='$now'";     # add a timestamp 
         $q = "UPDATE things SET $q WHERE msku='$sku' and objid='$objid'";
         $dbh->do( $q );  
      }

print ERLOG "$q\n";

#      # update variants next
#      $q="";
#      foreach ( keys %variant ) {
#	 $q.="," if ($q);
#         $q.=$_."='".string_todbi($variant{$_})."'";
#      }

      ## now remainder goes to extracopy

      $x=( keys %extracopy );
      foreach ( keys %extracopy ) {
         $qq = 'SELECT * from extraprop ';
         $qq.= "where objid='$objid' and fieldname='$_' ";
         $sth=$dbh->prepare( $qq );
         $sth->execute;
         $k=$sth->rows;

         if ( $k==1 ) {         # one row, update it
            $q = "UPDATE extraprop SET ";
            $q.= "body='".string_todbi($extracopy{$_})."',mdate='$now' ";
            $q.= "where objid='$objid' and fieldname='$_' ";
            $dbh->do( $q );

         } elsif ( ! $k ) {     # no rows, insert
            $q = "INSERT INTO extraprop ";
            $q.= "(objid,fieldname,body,cdate,mdate) ";
            $q.= " VALUES ('$objid','$_',";
            $q.= "'".string_todbi($extracopy{$_})."',$now,$now) ";

            $dbh->do( $q );

         } #/end of sensible actions on extracopy 
      } #/end of processing each extracopy key
   } #/end of write cycle

   return $rv;

} #/writeskutodb

##### LoadSKUfromDef
sub loadskufromdef {
   # sets the defaults for a new sku
   local($i,$y);

   if ($FORM{'skukind'} eq "V") { #variants

   }

   if ( $FORM{'objtype'} eq "42000-A" ) {         # object is Merchadise
    
      ## default stock behavior is saleable irrespective of stock       
      #
      $FORM{'behavior_inp'}="90006-A";

      ## default status is display normally
      #
      $FORM{'status_inp'}="95000-A"; 

   } elsif ( $FORM{'objtype'} eq "47004-A" ) {    # Brand SKU

      ## default stock behavior is saleable irrespective of stock
      #
      $FORM{'behavior_inp'}="90006-A";
 
      ## default status is display normally
      #
      $FORM{'status_inp'}="95000-A";             







      $FORM{'brand_inp'}="xbr".$site->{'sitecode'}."0000";     # brand name entries
      $FORM{'BEHAVIOR_inp'}="na";                     # stockless item - not applicable
      $FORM{'STATUS_inp'}="nd";                       # non-display

  } elsif ( $FORM{'skukind'} eq "E" ) {               # Editorial or Intermediate Page
      # intermediate page
      $FORM{'brand_inp'} ="xbr".$site->{'sitecode'}."0004"; 
      $FORM{'BEHAVIOR_inp'}="na";                     # stockless item - not applicable
      $FORM{'STATUS_inp'}="pn";                       # normal display

   } elsif ( $FORM{'skukind'} eq "C" ) {              # System EnCoding Schemes
      # encodings 
      $FORM{'brand_inp'}="xbr".$site->{'sitecode'}."0002";
      $FORM{'BEHAVIOR_inp'}="na";                     # not applicable - stockless item
      $FORM{'STATUS_inp'}="nd";                       # non-display
      $FORM{'DESCRIPT_inp'}="";                       # long descrip preload with codes
      for ( $i=0; $i<36; $i++) { 
         $FORM{'DESCRIPT_inp'}.=substr("abcdefghijklmnopqrstuvwxyz0123456789",$i,1).":\n";
      } # done pre-loading long description

   }  elsif ( $FORM{'skukind'} eq "V" ) {             # Variant EnCoding Schemes
      # encodings 
      $FORM{'brand_inp'}="xbr".$site->{'sitecode'}."0003"; 
      $FORM{'BEHAVIOR_inp'}="na";                     # not applicable - stockless item
      $FORM{'STATUS_inp'}="nd";                       # non-display
      $FORM{'DESCRIPT_inp'}="";                       # long descrip preload with codes
      for ( $i=0; $i<36; $i++) { 
         $FORM{'DESCRIPT_inp'}.=substr("abcdefghijklmnopqrstuvwxyz0123456789",$i,1).":\n";
      } # done pre-loading long description

   } elsif ( $FORM{'skukind'} eq "D" ) {              # Documents
      # internal documents
       $FORM{'brand_inp'} ="xbr".$site->{'sitecode'}."0001";
      $FORM{'BEHAVIOR_inp'}="dp";                     # not applicable - stockless item
      $FORM{'STATUS_inp'}="nd";                       # non-display 

   } elsif ( $FORM{'skukind'} eq "A" ) {              # Articles
      # article sku
     $FORM{'brand_inp'} ="xbr".$site->{'sitecode'}."0005";

     $FORM{'BEHAVIOR_inp'}="na";                      # always display-stock irrelevant
     $FORM{'STATUS_inp'}="pn";                        # normal display

   } else {
      # internal or something else
      #
   } 
   # prime the form
   foreach ( keys %FORM ) {
      $y=$_;
      next if ( $y !~ /_inp$/ );
      $y=~ s/_inp//;
      $y="__".$y."_pre__";
      $NVP{$y}=$FORM{$_};
   }

   return 1;
}
# /loadskufromdef

##### nextskuinseries - takes 4 char code, returns next sku in
#        the series of skus
#
sub nextskuinseries {
   # takes skuskel, returns next sku in series
   my($skel,$q,$sth,$x,$xn,$n,$num,$rv);
   $rv="";
   $sk=$_[0];

print ERLOG "\n\n\n In nextskuinseries \n";

print ERLOG "sk is $sk \n";

   if ( $site->{'site_sku_prelen'} == length($sk) ) { 

      $q="SELECT msku from things where msku LIKE ";
      $q.=" '$sk%' ORDER BY msku DESC ";
      $sth = $dbh->prepare( $q );
      $sth->execute;
      $num = $sth->rows;

print ERLOG "$q \n";

      if ( $num>0 ) { 
      # not the first in this series

print ERLOG "$num \n";

         ($x) = $sth->fetchrow;


print ERLOG " x is $x \n";

# glenn

$sitesku=( $site->{'site_sku_prelen'} + length($site->{'sitecode'}) );
 
    #  $x = substr($x,4,4);
    
  $x = substr($x,$sitesku,$site->{'site_sku_numlen'});

         $xn=$x+1;
         $xn="$xn";

print ERLOG "xn is $xn \n";

      } else {
         # first sku in this series
print ERLOG "first sku in series \n";

         $xn = "1";
      }

print ERLOG "xn is $xn \n";


      $n=$site->{'site_sku_numlen'} - length($xn);

print ERLOG "n is $n \n";

      $rv=$sk.$site->{'sitecode'} ;

print ERLOG "rv is $rv \n";

      while ( 0<$n ) {
         $rv.="0";
         $n--;
      }
      $rv.=$xn;

print ERLOG "return $rv \n";

   } # done with "if skuskel legal length

   return $rv;

} #/nextskuinseries    


##### PrintSearch
##
# NEED to rewrite separate from search
#

sub printsearch {


print ERLOG " In search and form brand is $FORM{'objid'} \n";    

    $z="SELECT TITLE from things where objid='$FORM{'objid'}'";
#    $z="SELECT TITLE from things where SKU='$FORM{'brand'}'";
    $sthZ=$dbh->prepare($z);
    $sthZ->execute;
    $num=$sthZ->rows;

print ERLOG "$objid is objid \n";

    foreach (1..$num) {
	($z2)=$sthZ->fetchrow;
    }
    if ($z2) {$FORM{'sochbrandtype'}=$z2;}

    $z="SELECT TITLE from things where SKU='$FORM{'sochbrandtype'}'";
    $sthZ=$dbh->prepare($z);
    $sthZ->execute;
    $num=$sthZ->rows;
    foreach (1..$num) {
	($z2)=$sthZ->fetchrow;
    }
    if ($z2) {$FORM{'sochbrandtype'}=$z2;}

   $query = $FORM{'query'};
   $sth = $dbh->prepare ( $query );
   $sth->execute;
   $num = $sth->rows;

   ## get the bits
   #
   %FORM=();
   &ReadParse;

   ## parse out the template
   # 
   $FORM{'sitename'}=$site->{'sitename'};
   $FORM{'lastmode'}=$FORM{'mode'};
   $FORM{'scriptname'}="$scriptname";
   $FORM{'scriptpath'}="$scriptpath";
   $FORM{'row_admin_sku_search'}="";

   foreach ( 'BRAND|8') {
      local($k,$v,$x,@raw);
      ( $k,$v) = split /\|/, $_;
      open(FH, "<$selskeletonpath/$k.sel");
      @raw=<FH>;
      chomp @raw;
      close(FH);
      $x=$k."_inp";
      $kt=$k."_SELECT";
      $NVP{$kt}= gen_select( "",$v,@raw );
   } 

   ## put session data in $v for GET URL construction
   #
 
   $v="&sid=$sid&mode=editsku&loadfrom=db";
   $v2="&sid=$sid&mode=editlink&loadfrom=db";
   $v3="&sid=$sid&mode=variants&loadfrom=db";

   $old="old";
   $isbnstring="";

   while ($num > 0 ) {
      
      $y={};

      %row=%{$sth->fetchrow_hashref};

      $row{'title'}=string_exdbi($row{'title'});
      $k="objid=$row{'objid'}";
      $k2="obj1=$row{'objid'}";
      $outlink=$row{'objid'}.".shtml";

      ## construct ISBN string here
      $isbnstring=$row{'title'};
      $qi="SELECT ISBN,VCODE from variants where SKU='$row{'SKU'}'";
      $stqi=$dbh->prepare( $qi );
      $stqi->execute;
      $qinum = $stqi->rows;

      foreach ( 1..$qinum ) {
         $qih=$stqi->fetchrow_hashref;
         $isbnstring.=", " if ( $isbnstring );  # comma and space if adding to list
         $isbnstring.="($qih->{'VCODE'}) $qih->{'ISBN'}";   # this variant and part no
      } # done with building list of variants

      $y->{'title'}=$isbnstring;

	  $y->{'SKULINK'}="<A HREF=\"$scriptname\?$v&$k\">$row{'objid'}</A>"; 
	  $y->{'PAGE'}="<A HREF=\/html\/$outlink>page</A>";
	  $y->{'LINKS'}="<A HREF=\"linkage.cgi\?$v2&$k2\">Links</A>";
	  $y->{'VARIANTS'}="<A HREF=\"$scriptname\?$v3&$k\">Variants</A>";

	  $rowtemplate=loadtemplate("row_admin_sku_search","/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin");
	  $isbnstring="";

	  $FORM{'row_admin_sku_search'}.= permutebit($rowtemplate, $y);
      $num--;
      $old=$row{'objid'};
   }
   
     $FORM{'script'}="admin_sku.cgi";

    $thispage=loadtemplate($targ,$skeletonpath);
    $thispage = permutebit( $thispage, \%FORM );
    $thispage = permutebit( $thispage, $site );
    $thispage=~ s/<\!--#include virtual=\"openmerchant-admin_sku-spine.html\"-->/$spine/gms;
    $thispage=~ s/__BRAND_SELECT__/$NVP{'BRAND_SELECT'}/gms;
    $thispage=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG'}/gms;
    $thispage=~ s/__script__/$FORM{'script'}/gms; 
    $thispage=~ s/__sid__/$sid/gms;
    $thispage=~ s/__mode__/$FORM{'mode'}/gms;
    $thispage = permuteclean ( $thispage );
    print $thispage;
    $sth->finish;
    return 1;
} 







sub message {
   # check the language that is being used and open appropriate
   # message language file or get messages below
   if ($om_render_lang eq "eng" ) {
      $script_msg{1}="evaluates as";
      $script_msg{2}="Editing Variants and Pricing for ObjectId";
      $script_msg{3}="MFG part";
      $script_msg{4}="weight";
      $script_msg{5}="Edit Inventory";
      $script_msg{6}="Nothing found! Please try another search";
      $script_msg{7}="Error - your search for";
      $script_msg{8}="returned no skus"; 
      $script_msg{9}="Try searching on a smaller portion of the sku";
      $script_msg{10}="Created Sucessfully!"; 
      $script_msg{11}="Submitted changes to";
      $script_msg{12}="Variants and Pricing";
      $script_msg{13}="Product";
      $script_msg{14}="Article";
      $script_msg{15}="Intermediate Page";
      $script_msg{16}="Internal Document";
      $script_msg{17}="Brand";
      $script_msg{18}="Variants";
      $script_msg{19}="Pulldown Or Menu";
      $script_msg{20}="Variants of Products";
      $script_msg{21}="Internal Series Header";
      $script_msg{22}="Creation of a New";
      $script_msg{23}="Editing";
      $script_msg{24}="for";
      $script_msg{25}="Error - unable to obtain new sku";
      $script_msg{26}="Error - sku skeleton";
      $script_msg{27}="wrong length!";
      $script_msg{28}="Error - new sku and rows but brand";
      $script_msg{29}="not valid!";
      $script_msg{30}="Error - new sku but brand";
      $script_msg{31}="Error - sku";
      $script_msg{32}="Product Line";
   } else {
      open( EM, "<$relpath/bits/$om_render_lang/system/$script.messages");
      while(<EM>) {
         chomp;
         next if /^\#/;
         next if (! $_);
         @temp=split /\t/;
         $script_msg{$temp[0]}=$temp[1];
      }
      close(EM);
   }
}

1;
