#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
###
#
# inventory.cgi
#
###
###
# Version 0.9.7 TG 20000601
#     added single variance
#     fixed search results
# Version 0.9.6 IB 20000531
#    added custom-lib.pm
# Version 0.9.5 IB 20000531
#    corrected the output for nonexistent item (set $findcount to 0)
# Version 0.9.4 GF 20000529
#    cleaned up formatiing issues
# Version 0.9.3 SC 20000524
#    Display only a few rows from findsku
# Version 0.9.2 SC 20000523
#    complete overhaul to 1.0 table structure.  Moved init stuff to subs.
# Version 0.9.1 IB 20000502
#    introduced variable $script
# Version 0.7.20 IB 20000420
#    insert->INSERT, update->UPDATE, set->SET
# Version 0.7.19 JC 20000411
#    $om_render_lang update
# Version 0.7.18 JC 20000410
#    multilingual messages
# Version 0.7.17 IB 20000402
#    new directory structure
# Version 0.7.16 JC 20000330
#    changed connect statement
# Version 0.7.15 JC 20000329
#    changed DBI prepare/connect
# Version 0.7.14 IB 20000327
#    corrected $relpath
# Version 0.7.13 IB 20000324
#    changed the way site.pm is obtained (multiple stores)
# Version 0.7.12 IB 20000302
#    updated copyright and removed -w
# Version 0.7.11 IB 20000228
#    changed store to site
# Version 0.7.9 IB 991201
#    converted ref to $sochbrandtype to $FORM{'sochbrandtype'}
# Version 0.7.8 IB 991127
#    fixing of header
# Version 0.7.7 IB 991126
#    fixing of a comment statement
# Version 0.7.6 IB 991124
#    fixed a database call
# Version 0.7.5 IB 991121
#    corrected bits/sel to bits/site/sel
# Version 0.7.4 IB 991109
#    removing of HACKS, and correcting of relpath 
# Version 0.7.3 IB 991102
#    general cleanup
# Version 1 SH 990708
#
##

# Version 0.9.7 
$debug = 1;
if ($debug) {
    open INV_ERLOG,  ">/tmp/inventory";
    print INV_ERLOG "Debugging inventory.cgi...\n";
}

&initpath();
&initsite();

## start the replacements hash
#
%NVP=();
$NVP{'sitename'}=$site->{'sitename'};
@skuvars=();       # array of hashrefs for holding sku variants
@skulinks=();      # array of hashrefs for holding linkages

$spine=loadtemplate("openmerchant-inventory-spine",$skeletonpath);

## catch inbounds lacking mode - homepage default
#
# the following names will be changed later, promise

#mode handling

if (! $FORM{'mode'}) {
    $FORM{'mode'}="home";
}
if ($FORM{'mode'} eq "main") {
    $FORM{'mode'} = "home"; }
## login control
#
$FORM{'sid_ok'} = check_login($script,$FORM{'mode'},$FORM{'sid'});

if ( $FORM{'sid_ok'} ) {
    if ( $FORM{'sid_ok'} =~ /^ERROR/ ) {
	## hard error, redirected to login page
	exit 0 ; 
    } elsif ( $FORM{'sid_ok'} =~ /^Error/ ) {
	## soft error, send to default mode
	$FORM{'mode'}="home";
	$NVP{'__page_error_msg__'}=$FORM{'sid_ok'};
    } else {
	## welcome to the page...
    }   
    print "Content-type: text/html\n\n";
} else {
    ## unknown why sid_ok not populated with some string...
    #
    print "Content-type: text/html\n\n";
    print "<HTML><HEAD></HEAD><BODY>\n";
    print "$FORM{'sid'} sid $script_msg{1} $FORM{'sid_ok'} \n";
    exit 0;
}


## Define first entries in %NVP based on mode, sid, etc...
#
$NVP{'sid'}=$FORM{'sid'};
$NVP{'lastmode'}=$FORM{'mode'};
$NVP{'script'}="$scriptpath/$scriptname";
$NVP{'datetime'}=$nicedt;
$NVP{'scriptpath'}=$scriptpath;


# check to see if the homepage is simply clearing the form
if (($FORM{'searchclear'}) and ($FORM{'mode'} eq "findsku")) {
    $FORM{'mode'}="home";
} 
# real preprocessing

if ($FORM{'mode'} eq "findsku") {
    &printsearch();
    exit;
} 

########################################################
## Primary Display Mode Handling

if ($FORM{'mode'} eq "searchlist") {
    &printsearch;
    
} elsif ( $FORM{'mode'} eq "editsku" ) {
    &getEditObjectPage($FORM{objid});
} elsif ($FORM{'mode'} eq "home") {
    
    foreach ( 'brand|8','STATUS|2', 'warehouse|2') {
	local($k,$v,$x,@raw);
	( $k,$v) = split /\|/, $_;
	if ($debug) {
	    print INV_ERLOG "Trying to find $selskeletonpath/$k.sel\n";
	}
	open(FH, "<$selskeletonpath/$k.sel");
	@raw=<FH>;
	chomp @raw;
	close(FH);
	$x=$k."_inp";
	$kt=$k."_select";
	
	
	$NVP{$kt}= gen_select( "",$v,@raw );
	if ($debug) {
	    print INV_ERLOG "The _inp --> $x, the _select --> $kt\n";
	    print INV_ERLOG "Createing select for $v!\n";
	    print INV_ERLOG "The select code is: $NVP{$kt}\n";
	}
    }
    
    $v="os_allcommerce-inventory-home";
    $l = loadtemplate ( $v, $skeletonpath );
    $l = permutebit( $l, \%NVP );
    $spine=loadtemplate("os_allcommerce-inventory-homespine",$skeletonpath);
    $l=~ s/<\!--#include virtual=\"os_allcommerce-inventory-homespine.html\"-->/$spine/gms;
    $l=~ s/__brand_select__/$NVP{'brand_select'}/gms;  
    $l=~ s/__warehouse_select__/$NVP{'warehouse_select'}/gms;
    $l=~ s/__warehouse__/$NVP{'warehouse'}/gms;
    $l=~ s/__page_error_msg__/$NVP{'page_error_msg__'}/gms;
    $l=~ s/__script__/$scriptpath\/$script.cgi/gms;
    $l=~ s/__sitename__/$site->{'sitename'}/gms;
    $l=~ s/__sid__/$sid/gms;
    $l=~ s/__mode__/$FORM{'mode'}/gms;
    
    $l = permuteclean($l);
    print $l;
    
}


$dbh->disconnect if ( $dbh ) ;

open (FH, ">>/tmp/$scriptname");
foreach ( sort keys %FORM ) { print FH "  $_ is $FORM{$_}\n";}
print FH "NVP data is: \n";
foreach ( sort keys %NVP ) { print FH "  $_ is $NVP{$_}\n";}
close(FH);

######################################################
## subroutines
##
######################################################

##### validatefields
#        takes all %FORM entries, seeks _inp entries, and 
#        performs field-by-field validation, with 
#        generation of _err error messages in %FORM as needed
#     returns 1 for OK, 0 for errors
#        - run after checkformbits
#        - does not need explicit fieldlist
#     Version 1 RF 981123
sub validatefields {
    # reads global %FORM
    my(@keys,$k,$e,$rv);
    $rv=1;                  # default OK, to 0 if error
    @keys = keys %FORM;
    while (@keys) {
	$k=shift @keys;
	next if ( $k !~ /_inp$/ );
	$kt = $k;
	$kt =~ s/_inp$// ;
	next if ( $kt =~ /[a-z]/ );   # fields are all uppercase
	$e=validatefield( $kt,$FORM{$k}, \%FORM );
	if ($e) {
	    $rv=0;           # there was an error returned
	    $kt.="_err";
	    $FORM{$kt}=$e;   # emplace the error message 
	} # done checking for a returned error
    } # done running through form keys 
    return $rv;
} #/validatefields


##### checkformbits - checks population of _inp, does not touch
#        NVP hash
#
sub checkformbits {
    # goes through global %FORM
    #
    my($k,$kt,@keys);
    @keys = keys %FORM;
    while (@keys) {
	$k=shift @keys;
	next if ( $k =~ /_ini$/ );   # nothing to do with ini
	if ( $k =~ /_pre$/ ) {
	    # check to see if the inp key exists
	    # if it doesn't exist, then create and set to _pre
	    $kt=$k;
	    $kt =~ s/_pre$/_inp/ ;
	    $FORM{$kt}=$FORM{$k} if ( ! exists($FORM{$kt}) );
	} # only really concerned with _pre/_inp pairs
    } # done with all keys
    
    ## special case - objclass
    #
    
    if ((! $FORM{'objclass'} ) and ( $FORM{'objclass_inp'} )) {
	$FORM{'objclass'}=$FORM{'objclass_inp'};   
    }
    if (( $FORM{'objclass'} ) and (! $FORM{'objclass_inp'} )) {
	$FORM{'objclass_inp'}=$FORM{'objclass'};   
    } # end of objclass fillin
    return 1;
} #/checkformbits

##### writetonvp - write form data to NVP hash
sub writetonvp {
    # could rewrite to take a hashref
    my(@keys,$k,$kt);
    @keys = keys %FORM;
    while (@keys) {
	$k=shift @keys;
	$kt = $k;
	$kt =~ s/(_ini|_inp|_pre|_err)$// ;
	if ( $k =~ /_inp$/ ) {           # _inp -> _pre
	    $kt.="_pre";
	    $NVP{$kt}=$FORM{$k};
	} elsif ( $k =~ /_ini$/ ) {      # _ini -> _ini
	    $NVP{$k}=$FORM{$k};
	} elsif ( $k =~ /_err$/ ) {      # _err -> _err
	    $NVP{$k}=$FORM{$k};
	} elsif ( $k eq $kt ) {          # X -> X
	    if (( $kt !~ /[a-z]/ ) and ( ! exists($NVP{$kt}) )) {
		# this looks like a fieldname and is not yet set
		$NVP{$kt}=$FORM{$kt} if ( $FORM{$kt} );
	    }
	} # any other inheritance modes?
    } # done running through form keys
    ## special cases
    #
    $NVP{'objclass'}=$FORM{'objclass_inp'} if (( ! $NVP{'objclass'} ) and ( $FORM{'objclass_inp'} ));
    return 1; 
} #/writetonvp


##### PrintSearch
sub printsearch {
   #system 6
    my ($sth, $stc, $q, $num, $thisobjid, $maxrows);
    $maxrows = 10;

    if ($FORM{maxrows} ne "") {
	$maxrows = $FORM{maxrows}; }
    if ($maxrows > 200) { $maxrows = 200; }
    my $startrow;
    if ($FORM{startrow} ne "") {
	$startrow = $FORM{startrow};
    } else {
	$startrow = 0;
    }
    
    $q="SELECT objid, title from things where objid=\'$FORM{'skuskel'}\' and objclass=\'134-A\'";
    $sth=$dbh->prepare($q);
    $sth->execute;
    if ($debug) {
	print INV_ERLOG "In printsearch1 --> $q\n";
    }
    $num=$sth->rows;
    $foundcount += $num;
    if ($debug) {
	print INV_ERLOG "Found count += ==> $foundcount\n";
    }
    if ($num == 1) {
	
	($thisobjid, $thistitle) = $sth->fetchrow;
	
	if ($debug) {
	    print INV_ERLOG "...$thisobjid...,\n ...$thistitle...\n";
	}
	
	$invrow = &getInventoryData($thisobjid, $FORM{'warehouse_inp'}, $FORM{'STATUS_inp'});
	if ($invrow->{wh} ne "") { 
	    $foundcount++;
	    if ($debug) {
		print INV_ERLOG "Found count ++ ==> $foundcount\n";
	    }
	    &getEditObjectPage($thisobjid); 
	} else {
	    $foundcount--;
	    if ($debug) {
		print INV_ERLOG "Found count -- ==> $foundcount\n";
	    }
	}
    } else {
	$q="SELECT objid, title from things where title like \'\%$FORM{'skuskel'}\%\' and objclass=\'134-A\'";
	
	$sth=$dbh->prepare($q);
	if ($debug) {
	    print INV_ERLOG "In printsearch2 --> $q\n";
	}
	$sth->execute;
	$num=$sth->rows;
	if ($num == 1) {
	    ($thisobjid, $thistitle) = $sth->fetchrow;
	    &getEditObjectPage($thisobjid);
	}
	
	if ($debug) {
	    print INV_ERLOG "Going into for loop with $num!\n";
	}
	
	foreach (1..$num) {
	    ($thisobjid, $thistitle) = $sth->fetchrow;
	    if ($debug) {
		print INV_ERLOG ",,,$thisobjid,,,,\n ,,,$thistitle,,,\n";
	    }
	    $invrow = &getInventoryData($thisobjid, $FORM{'warehouse_inp'}, $FORM{'STATUS_inp'});
	    
	    # Version 0.9.7 - Changed to be > 0 since was == 0 before, and caused all rows to be returned!
	    if (($invrow->{wh} ne "") || ($invrow->{rowsfound} > 0)) { 
		if ($debug) {
		    print INV_ERLOG "Found $invrow->{rowsfound} rows, and adding $thisobjid!\n";
		}
		$foundobjids{$thisobjid}++;
		
		$objtitles{$thisobjid} = $thistitle; 
		if ($debug) {
		    print INV_ERLOG "Werehouse: $invrow->{wh}, Rows: $invrow->{rowsfound}\n";
		    print INV_ERLOG "Set title to --> Title: $objtitles{$thisobjid} = $thistitle\n";
		}
	    }
	}
	foreach (1..$num) {
	    ($thisobjid, $thistitle) = $sth->fetchrow;
	    $invrow = &getInventoryData($thisobjid, $FORM{'warehouse_inp'}, $FORM{'STATUS_inp'});
	    if ($invrow->{wh} ne ""){ 
		if ($debug) {
		    print INV_ERLOG "Found $invrow->{rowsfound} rows, and adding $thisobjid!\n";
		}
		$foundobjids{$thisobjid}++;
		$title = &get_fields_and_title("","",$thisobjid, $dbh);
		if ($title->{'numrows'} > 0) {
		    $objtitles{$thisobjid} = $title->{'title'}; 
		}
		if ($debug) {
		    print INV_ERLOG "Setting title to: $objtitles{$thisobjid}\n";
		}
	    }
	}
    }
    foreach $keyval (keys(%foundobjids)) {
	$foundcount++;
	if ($debug) {
	    print INV_ERLOG "Found count, $keyval FOR LOOP ==> $foundcount\n";
	}
    }
    
    $expand1="";
    $expand2="";
    $expand3="";
    $expand4="";
    
    ## parse out the template
    # 
    $FORM{'sitename'}=$site->{'sitename'};
    $FORM{'searchnum'}=$foundcount;
    $FORM{'sochname'}=$find;
    $FORM{'searchres'}="$glenn";
    $FORM{'lastmode'}=$FORM{'mode'};
    $FORM{'scriptname'}="$scriptname";
    $FORM{'scriptpath'}="$scriptpath";
    
    # $FORM{'sochbrandtype'}=$z2;
    
    
    ## call out page and cell templates
    #
    
    foreach ( 'brand|8', 'warehouse|2', 'STATUS|2') {
	local($k,$v,$x,@raw);
	( $k,$v) = split /\|/, $_;
	open(FH, "<$selskeletonpath/$k.sel");
	@raw=<FH>;
	chomp @raw;
	close(FH);
	$x=$k."_inp";
	$kt=$k."_select";
	if ($debug) {
	    print INV_ERLOG "Getting select for $kt\n";
	    print INV_ERLOG "v = $v\n";
	}
	$NVP{$kt}= gen_select( "",$v,@raw );
	if ($debug) {
	    print INV_ERLOG "SELECT CODE: $NVP{$kt}\n";
	}
    } 
    
    $targ="os_allcommerce-inventory-searchlist";
    $thispage=loadtemplate($targ,$skeletonpath);
    
    
    
    ## output the file
    #
    
    
    ## put session data in $v for GET URL construction
    #
    $v="&sid=$sid&mode=editsku&loadfrom=db";
    
    my $rowctr = 0;
    $lastrow = $startrow + $maxrows;
    if ($lastrow > $foundcount) {
	$lastrow = $foundcount; }
    
    my $titles;
    
    foreach $objidval (keys(%foundobjids)) {
	
	if (($rowctr >= $startrow) && ($rowctr < $lastrow)) {
            # Version 0.9.7 does extra query...
	    $titles = &get_fields_and_title("","",$objidval, $dbh);
	    if ($titles->{'numrows'} > 0) {
		$title = $titles->{'title'}; 
	    }
	    
	    if ($debug) {
		print INV_ERLOG "Title is set to: $title\n";
	    }
	    
	    $k="objid=$objidval";
	    $whtoken = "warehouse_inp=$FORM{warehouse_inp}";
	    $expand1.="\n<TR><TD NOWRAP>";
	    $expand1.="<A HREF=\"$scriptname\?$v&$k&$whtoken\"><FONT FACE=\"arial,helvetica\" SIZE=\"-1\"><B>$objidval</B></FONT></A><BR></TD>"; 
	    $expand1.="\n\t<TD align=left NOWRAP><FONT FACE=\"arial,helvetica\" SIZE=\"-1\">$title</TD>";
	    
	    if ($debug) {
		print INV_ERLOG ".$objidval.\n";
	    }
	    $invrow = &getInventoryData($objidval, $FORM{'warehouse_inp'}, $FORM{'STATUS_inp'});
	    
	    $expand1.="\n\t<TD align=center NOWRAP><FONT FACE=\"arial,helvetica\" SIZE=\"-1\">$invrow->{'wh'}</FONT></TD>";
	    $expand1.="\n\t<TD align=center NOWRAP><FONT FACE=\"arial,helvetica\ SIZE=\"-1\">$invrow->{'status'}</FONT></TD>";
	    $expand1.="\n\t<TD align=center NOWRAP><FONT FACE=\"arial,helvetica\" SIZE=\"-1\">$invrow->{'lstock'}</FONT></TD>";
	    $expand1.="\n</TR><TR><TD COLSPAN=5><img src=\"/images/eng/os_allcommerce/admin/general/clear.gif\""; 
	    $expand1.=" width=1 height=5 border=0></TD></TR> \n";
	    
	}
	$rowctr++;
    }	
    if ($foundcount == 0) {
	$firstrecord = 0; } else {
	    $firstrecord = $startrow+1; }
    
    $expand1.="<TR><TD COLSPAN=5>&nbsp;</TD></TR>\n";
    $expand1.="\n<TR><TD COLSPAN=5 VALIGN=BOTTOM HEIGHT=20><FONT SIZE=-1 FACE=\"arial,helvetica\">";
    $expand1.="Displaying records " . ($firstrecord) . " to $lastrow of $foundcount total records</FONT></TD></TR>\n";
    $expand1.="<TR><TD COLSPAN=5>&nbsp;</TD></TR>\n"; 
    $expand1.="\n\n<TR><TD ALIGN=LEFT>";
    
    if ($startrow > 0) {
	$startrow = $lastrow - $maxrows - 1;
	if ($startrow < 0) {
	    $startrow = 0; }
	$expand1.="<A HREF=\"$scriptpath/$scriptname\?sid=$sid&mode=findsku&skuskel=$FORM{skuskel}";
	$expand1.="&warehouse_inp=$FORM{warehouse_inp}&startrow=$startrow\"><FONT FACE=\"arial,helvetica\" SIZE=\"-1\">Back</FONT></A>&nbsp;&nbsp;"; 
    }
    
    $expand1.="</TD><TD COLSPAN=3>&nbsp;</TD><TD ALIGN=RIGHT>";
    
    if ($lastrow < $foundcount) {
	$startrow = $lastrow;
	$expand1.="\n\n<A HREF=\"$scriptpath/$scriptname\?sid=$sid&mode=findsku&skuskel=$FORM{skuskel}";
	$expand1.="&warehouse_inp=$FORM{warehouse_inp}&startrow=$startrow\"><FONT FACE=\"arial,helvetica\" SIZE=\"-1\">Next</FONT></A>"; 
    }
    $expand1.="</TD></TR>";
    
    $FORM{'row_inventory_searchlist'}=$expand1;
    
    $FORM{'script'}="inventory.cgi";
    
    $thispage = permutebit( $thispage, \%FORM );
    $thispage=~ s/<\!--#include virtual=\"openmerchant-inventory-spine.html\"-->/$spine/gms;
    $thispage=~ s/__brand_select__/$NVP{'brand_select'}/gms;
    $thispage=~ s/__warehouse_select__/$NVP{'warehouse_select'}/gms;
    $thispage=~ s/__STATUS_select__/$NVP{'STATUS_select'}/gms;
    $thispage=~ s/__page_error_msg__/$NVP{'page_error_msg'}/gms;
    $thispage=~ s/__script__/$FORM{'script'}/gms; 
    $thispage=~ s/__sitename__/$site->{'sitename'}/gms;
    $thispage=~ s/__sid__/$sid/gms;
    $thispage=~ s/__mode__/$FORM{'mode'}/gms;
    
    $thispage = permuteclean ( $thispage );
    print $thispage;
    
    $sth->finish;
    return 1;
} 


sub getEditObjectPage {
my $rv = "";
my $objid = $_[0];
   $NVP{'variants'}="";
    
#   $p="select title from things where objid='$objid' ";
#   $sth=$dbh->prepare($p);
#   $sth->execute;

# Version 0.9.7 added for variant titles
$res = &get_fields_and_title("","",$objid, $dbh);
$product = $res->{'title'};

if ($debug) {
    print INV_ERLOG "Product is: ...$product...\n";
}
 
   $NVP{'pagetitle'}="$script_msg{5} $objid \($product\)\n";
   $NVP{'sitename'}=$site->{'sitename'};
   $NVP{'searchnum'}=1;
   $NVPM{'lastmode'}=$FORM{'mode'};
   $NVP{'scriptname'}="$scriptname";
   $NVP{'scriptpath'}="$scriptpath";

   $NVP{'select1'}="&nbsp;";
   $NVP{'select2'}="&nbsp;";
   $NVP{'select3'}="&nbsp;";
   $NVP{'select4'}="&nbsp;";
   $NVP{'objid'} = $objid;

   foreach ( 'brand|8', 'STATUS|2', 'warehouse|2') {
      local($k,$v,$x,@raw);
      ( $k,$v) = split /\|/, $_;
      open(FH, "<$selskeletonpath/$k.sel");
      @raw=<FH>;
      chomp @raw;
      close(FH);
      $x=$k."_inp";
      $kt=$k."_select";
      if ($debug) {
	  print INV_ERLOG "Getting General Selection for $kt\n";
	  print INV_ERLOG "creating pull down for $v\n";

      }
      $NVP{$kt}= gen_select( "",$v,@raw );
      if ($debug) {
	  print INV_ERLOG "SELECT CODE: $NVP{$kt}\n";
      }
   }
   
   $numVariants = &getVariants($objid , $dbh, \@variants);
   if ($numVariants > 0) {
       $newk = "axis1";
       $newx=$newk."_inp";
       $newkpre=$newk."_pre";
       $select="select1";
       $NVP{$newkt}= gen_variant_sel($FORM{'$newx'}, 3, $numVariants, @variants);
       $NVP{$select}.=" <P><FONT FACE=\"arial, helvetica\">$script_msg{10}</FONT></P>";
       $NVP{$select}.=" <SELECT NAME=\"axis1_inp\"> $NVP{$newkt} </SELECT>";
       if ($debug) {
	   print INV_ERLOG "Variant pulldown is: $NVP{$newkt}\n";
	   print INV_ERLOG "Select is: $NVP{$select}\n";
       }
   }

   &updateInventoryRecord();

   # Only print out the stock info if this is NOT a master record, as you cannot modify master record inventory
   if ($numVariants == 0) {
      $NVP{'stockinfo'}.="<FONT FACE=\"arial, helvetica\">Current Stock Info:</FONT><BR>";
      $NVP{'stockinfo'}.="<TABLE BORDER=0 WIDTH=100% CELLPADDING=3> \n";      
      $NVP{'stockinfo'}.="<TR><TD><FONT FACE=\"arial, helvetica\" SIZE=\"-1\"><U>Objectid</U></FONT></TD>";
      $NVP{'stockinfo'}.="<TD><FONT FACE=\"arial, helvetica\" SIZE=\"-1\"><U>Title</U></FONT></TD> \n";
      $NVP{'stockinfo'}.="<TD ALIGN=CENTER><FONT FACE=\"arial, helvetica\" SIZE=\"-1\"><U>Warehouse</U></FONT></TD> \n";
      
      $NVP{'stockinfo'}.="<TD ALIGN=CENTER><FONT FACE=\"arial, helvetica\" SIZE=\"-1\"><U>Status</U></FONT></TD> \n";
      
      $NVP{'stockinfo'}.="<TD ALIGN=CENTER><FONT FACE=\"arial, helvetica\" SIZE=\"-1\"><U>LStock</U></FONT></TD></TR>";
      $NVP{'stockinfo'}.="<TR><TD NOWRAP>";
      $NVP{'stockinfo'}.="<FONT FACE=\"arial, Helvetica\" SIZE=\"-1\"><B>$objid</B></FONT></TD>"; 
      $NVP{'stockinfo'}.="<TD align=left NOWRAP><FONT FACE=\"Arial, Helvetica\" SIZE=\"-1\">$product</TD>";
      
      $invrow = &getInventoryData($objid, $FORM{'warehouse_inp'}, $FORM{'STATUS_inp'});
      
      $NVP{'stockinfo'}.="<TD align=center NOWRAP><FONT FACE=\"arial, Helvetica\" SIZE=\"-1\">$invrow->{'wh'}</FONT>&nbsp;</TD>";
      $NVP{'stockinfo'}.="<TD align=center NOWRAP><FONT FACE=\"arial, Helvetica\" SIZE=\"-1\">$invrow->{'status'}</FONT>&nbsp;</TD>";
      $NVP{'stockinfo'}.="<TD align=center NOWRAP><FONT FACE=\"arial, Helvetica\" SIZE=\"-1\">$invrow->{'lstock'}</FONT>&nbsp;</TD>";
      $NVP{'stockinfo'}.="</TR>";
      $NVP{'stockinfo'}.="</TABLE>";
   }
   # Set the title to be Master product
   else {
       $NVP{'pagetitle'}="Master Product $objid \($product\)\n";
   }

   $num = &getVariants($objid, $dbh, \@variants);
   #  Only set up variants table if it exists!
   if ($num > 0) {
      #----------- Setup Table
      $NVP{'variants'}.="<P><FONT FACE=\"arial, helvetica\">$script_msg{11}</FONT></P>";
      $NVP{'variants'}.="<TABLE BORDER=0 WIDTH=100% CELLPADDING=3> \n";      
      $NVP{'variants'}.="<TR><TD><FONT FACE=\"arial, helvetica\" SIZE=\"-1\"><U>Objectid</U></FONT></TD>";
      $NVP{'variants'}.="<TD><FONT FACE=\"arial, helvetica\" SIZE=\"-1\"><U>Title</U></FONT></TD> \n";
      $NVP{'variants'}.="<TD ALIGN=CENTER><FONT FACE=\"arial, helvetica\" SIZE=\"-1\"><U>Warehouse</U></FONT></TD> \n";
      $NVP{'variants'}.="<TD ALIGN=CENTER><FONT FACE=\"arial, helvetica\" SIZE=\"-1\"><U>Status</U></FONT></TD> \n";
      $NVP{'variants'}.="<TD ALIGN=CENTER><FONT FACE=\"arial, helvetica\" SIZE=\"-1\"><U>LStock</U></FONT></TD></TR> \n";
      #------------ End of Setup table 
      
      for ($i = 0; $i < $num; $i++) {
	  if ($debug) {
	      print INV_ERLOG "Variants are: $variants[$i][0] --> $variants[$i][1]\n";
	  }
	  $NVP{'variants'}.="<TR><TD NOWRAP>\n";
	  $NVP{'variants'}.="<FONT FACE=\"arial, Helvetica\" SIZE=\"-1\"><B>$variants[$i][0]</B></FONT></TD>\n"; 
	  $NVP{'variants'}.="<TD align=left NOWRAP><FONT FACE=\"Arial, Helvetica\" SIZE=\"-1\">$variants[$i][1]</TD>\n";
	  $invrow = &getInventoryData($variants[$i][0], $FORM{'warehouse_inp'}, $FORM{'STATUS_inp'});
	  $NVP{'variants'}.="<TD align=center NOWRAP><FONT FACE=\"arial, Helvetica\" SIZE=\"-1\">$invrow->{'wh'}</FONT>&nbsp;</TD>\n";
	  $NVP{'variants'}.="<TD align=center NOWRAP><FONT FACE=\"arial, Helvetica\" SIZE=\"-1\">$invrow->{'status'}</FONT>&nbsp;</TD>\n";
	  $NVP{'variants'}.="<TD align=center NOWRAP><FONT FACE=\"arial, Helvetica\" SIZE=\"-1\">$invrow->{'lstock'}</FONT>&nbsp;</TD>\n";
	  $NVP{'variants'}.="</TR>\n";
      }
      $NVP{'variants'}.="</TABLE>\n";
      $NVP{'variants'}.=" <BR> \n";
  }
  &checkformbits();
  &writetonvp();
  $v="os_allcommerce-inventory-editskuP";
  $l = loadtemplate ( $v, $skeletonpath );
  $l = permutebit( $l, \%NVP );

  $l=~ s/<\!--#include virtual=\"openmerchant-inventory-spine.html\"-->/$spine/gms;
  $l=~ s/__brand_select__/$NVP{'brand_select'}/gms;  
  if ($debug) {
      print INV_ERLOG "Replacing __STATUS_select__ with $NVP{'STATUS_select'}\n";
  }
      $l=~ s/__STATUS_select__/$NVP{'STATUS_select'}/gms;
      $l=~s/__warehouse_select__/$NVP{'warehouse_select'}/gms;
      $l=~ s/__page_error_msg__/$NVP{'page_error_msg__'}/gms;
      $l=~ s/__script__/$scriptpath\/$script.cgi/gms;
      $l=~ s/__sitename__/$site->{'sitename'}/gms;
      $l=~ s/__sid__/$sid/gms;
      $l=~ s/__mode__/editsku/gms;

      $l = permuteclean($l);
      print $l;
	exit;
}

sub message {
   # check the language that is being used and open appropriate
   # message language file or get messages below
   if ($om_render_lang eq "eng" ) {
      $script_msg{1}="evaluates as";
      $script_msg{2}="Nothing found! Please try a simpler search";
      $script_msg{3}="Error - your search returned nothing";
      $script_msg{4}="Try again";
      $script_msg{5}="Product";
      $script_msg{6}="mfg part";
      $script_msg{7}="stock";
      $script_msg{8}="wherehouse";   
      $script_msg{9}="status";  
      $script_msg{10} = "Please select a variant to modify the inventory:";
      $script_msg{11} = "Current Stock Info:";
   } else {
      open( EM, "<$relpath/bits/$om_render_lang/system/$script.messages");
      while(<EM>) {
         chomp;
         next if /^\#/;
         next if (! $_);
         @temp=split /\t/;
         $script_msg{$temp[0]}=$temp[1];
      }
      close(EM);
   }
}







sub getInventoryData {
my $objid = $_[0];
my $wh = $_[1];
my $status = $_[2];
if ($status =~ /Not Specified/ig) {  # Ignore Parameter if "Not Specified"
$status = ""; }

my $sth;
my $num;
my $q;

$q="SELECT * from inventory where objid=\'$objid\' and status like \'\%$status\%\'";

if ($wh ne "") {
$q .= " and wh=\'$wh\'";
}

if ($debug) {
    print INV_ERLOG "In getInventoryData --> $q\n";
}
   $sth=$dbh->prepare($q);
   $sth->execute;
   $num=$sth->rows;

 if ($num > 0) {
   $invdata = $sth->fetchrow_hashref;
   if ($debug) {
       print INV_ERLOG "\tIn getInventoryData: Found $num rows!\n";
   }
 } else {
 	return; }

return($invdata);
}



sub updateInventoryRecord {
my $q;
my $sth;
my $stu;
my $num;
my $flag;
my $stock;
if ($FORM{'STATUS_inp'} =~ /Not Specified/ig) {  # Ignore Parameter if "Not Specified"
$FORM{'STATUS_inp'} = ""; }

if ($FORM{axis1_inp}) {
      $q="select lstock, wh from inventory where objid='$FORM{axis1_inp}'";
  }
else {
      $q="select lstock, wh from inventory where objid='$FORM{objid}'";
  }
if ($debug) {
    print INV_ERLOG "In updateInventoryRecord --> $q\n";
}
      $sth=$dbh->prepare($q);
      $sth->execute;
      $num=$sth->rows;
      $flag=0;


      if (($FORM{'warehouse_inp'} eq "") || ($FORM{'STATUS_inp'} eq "")) {
	  if ($debug) {
	      print INV_ERLOG "In updateInventoryRecord, returning because warehouse --> $FORM{'warehouse_inp'}, status --> $FORM{'STATUS_inp'}\n"
	      }
      	return; }
      	
      for (1..$num) {
         ($stock, $warehouse) = $sth->fetchrow;
         
      
         $stock=$stock + $FORM{'increment_inp'} - $FORM{'decrement_inp'};
	 if ($debug) {
	     print INV_ERLOG "Stock is $stock\n";
	 }

         if ($warehouse eq $FORM{'warehouse_inp'}) {
	     if ($debug) {
		 print INV_ERLOG "Is there any variants?  $FORM{'axis1_inp'}\n";
	     }

	     # Update only the variant portion
	     if ($FORM{'axis1_inp'}) {
	    $q="UPDATE inventory SET status='$FORM{'STATUS_inp'}', lstock='$stock' where objid='$FORM{axis1_inp}' and wh='$FORM{'warehouse_inp'}'  "; 
	     }
	     else {
		 $q="UPDATE inventory SET status='$FORM{'STATUS_inp'}', lstock='$stock' where objid='$FORM{objid}' and wh='$FORM{'warehouse_inp'}'  "; 
	     }
	    if ($debug) {
		print INV_ERLOG "DEBUG ---> $FORM{'axis1_inp'}, $FORM{'axis1_sel'}\n";
	    }

            $flag=1;
         }
      }
      if ($flag == 0) {
         $stock=$FORM{'increment_inp'} - $FORM{'decrement_inp'};
	 if ($FORM{'axis1_inp'}) {
	     $q="INSERT into inventory (objid, lstock, wh, status) values('$FORM{axis1_inp}', '$stock', \'$FORM{'warehouse_inp'}\', \'$FORM{'STATUS_inp'}\' ) ";
	 }
	 else {
	     $q="INSERT into inventory (objid, lstock, wh, status) values('$FORM{objid}', '$stock', \'$FORM{'warehouse_inp'}\', \'$FORM{'STATUS_inp'}\' ) ";
	 }
      }

if ($debug) {
    print INV_ERLOG "In updateInventoryRecord --> $q\n";
}
      $stu=$dbh->prepare($q);
      $stu->execute;
return($stu->rows);
}

### INITIALIZATION SUBROUTINES ###

sub initpath {
## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om/admin,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$siteshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $siteshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $siteshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

$relpath .= "/../$siteshortname";

}


sub initsite {

use DBI;
# Version 0.9.7
require "$relpath/lib/variant.pm";
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/conversions.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/login.pm";
require "$relpath/lib/validate.pm";
require "$relpath/conf/site.pm";
require "$relpath/lib/custom-lib.pm";

## establish site-specific parameters
#
$site=setsite();

## get form data, if any was submitted
#
%FORM=();
&ReadParse();

$sid=$FORM{'sid'}; 

$find=$FORM{'skuskel'};
if (!$find) {$find=$FORM{'keyword'};}
$brandtype=$FORM{'brand'}; 

$om_render_lang=$FORM{'om_ui_language'};
$om_render_lang=$site->{'om_locale_lang_def'} if ( !$om_render_lang);
$om_render_lang="eng" if ( ! $om_render_lang );

## load messages
%script_msg=();  	# user interaction messages
$script=( split /\./, $scriptname )[0];
&message;

## done with pull-from-file bits, rest of global settings...
#
$x= (split /\?/, $ENV{'REQUEST_URI'})[0];   # strip get stuff
@temp=split /\//, $x;
@temp=("cgi-bin","test","inventory.cgi") if (! $ENV{'REQUEST_URI'} );

$script=( split /\./, $scriptname )[0];
$n= $#temp - 1;
$scriptpath = join "/", ( @temp[0..$n] );
$skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin";
$selskeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/html/sel";

## filled in with time/context variable info
$nicedt=nicedatetime();

## construct some shorthands
$script_html = join "-", ($site->{'siteshortname'},$script,"");

## connect to database
# system 6 database state, products, and customer tables are collapsed
#
$q = "$site->{'db_site_config'}"; 
$dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'}); 

}





1;
