#!/usr/bin/perl 
############################################################################
#    Copyright (C) 1999-2000 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

#####
# linkage.cgi
#
# RF 981106 to manage linkages
#####

$script_version="Version 0.9.7 - 20000531";

#####
# Version 0.9.7 TG 20000531
#   fixed validate objid for the linked object 
#   fixed cell linkage problems
#   fixed linkage entries to include status
#   fixed levents to add the series
#   added variant support for linkage
#   put debug in with debug flag
# Version 0.9.2 GF 20000524
#    check_login commented out
# Version 0.9.1 IB 20000502
#    introduced $script variable
# Version 0.7.21 IB 20000420
#    set->SET
# Version 0.7.20 IB 20000411
#    eliminated ERLOK (probably misspelled ERLOG)
# Version 0.7.19 JC 20000410
#    multilingual messages
# Version 0.7.18 IB 20000402
#    new directory structure
# Version 0.7.17 IB 20000330
#    changed connect statement
# Version 0.7.16 JC 20000329
#    changed DBI prepare/connect
# Version 0.7.15 20000327
#    corrected $relpath
# Version 0.7.14 20000324
#    changed the way site.pm is obtained (multiple stores)
# Version 0.7.13 20000302
#    updated copyright
# Version 0.7.12 20000228
#    changed store to site
# Version 0.7.11 20000124 KMS
#    addes storename NVI to Merchandise Manger template routine.
# Version 0.7.10 991202 IB\GF
#    fixed problem regarding CELLSTYLE sel
# Version 0.7.9 991201 IB
#    fixed global names
# Version 0.7.8 991126 IB
#    fixed script version number
# Version 0.7.7 991121 IB
#    corrected bits to bits/site/sel
# Version 0.7.6 991112 IB
#    corrected the determining of a relpath
#    removed foreach
#    corrected $scriptname
# Version 0.7.5 991109 IB
#    removing of HACKS, and correcting of relpath
# Version 0.7.4 991107 IB
#    removed redundant statement
# Version 0.7.3 991103 IB
#    general cleanup
# Version 0.7.1 990713 GF
#    revised for system 6 structure
#
#####

##### To Be Done and Bugs
#        - enhance homepage - better search options
#        - autopopulation of defaultable fields
#        - resorting of links by cellwidth, weight

##### Setup and Initialization

## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om/admin,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#

$debug = 1;           # set to 0 for no debug

if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$siteshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $siteshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $siteshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

$relpath .= "/../$siteshortname";

use DBI;

require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/conversions.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/login.pm";
require "$relpath/conf/site.pm";
require "$relpath/lib/validate.pm";

if ($debug) {
  open ERLOG, ">/tmp/linkage";
}


## establish site-specific parameters
#
$site=setsite();

## get form data if any was submitted
#

%FORM=();
&ReadParse;

$om_render_lang=$FORM{'OM_UI_LANGUAGE'};
$om_render_lang="eng" if ( ! $om_render_lang );

## load messages
%script_msg=();		# user interaction messages
$script=( split /\./, $scriptname )[0];
&message;

$q = ( split /\?/, $ENV{'REQUEST_URI'} )[0];
@temp=split /\//, $q;
@temp=("cgi-bin","test","linkage.cgi") if (! $ENV{'REQUEST_URI'} );

$script=( split /\./, $scriptname )[0];
$n= $#temp - 1;
$scriptpath = join "/", ( @temp[0..$n] );
$skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin";
$selskeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/html";

## filled in with time
$nicedt=nicedatetime();

## blankrows are the number of new linkage rows to 
#     display at bottom of a linkage editing page
$blankrows=3; 

## database connection
#
$q="$site->{'db_site_config'}";
$dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

## session id
#
$sid=$FORM{'sid'};

if ($FORM{'obj1'} && $FORM{'obj1'} ne "__obj1_pre__" ) {
   $FORM{'obj1_pre'}=$FORM{'obj1'};} else {$FORM{'obj1_pre'}="";
}

$NVP{'obj1_pre'}=$FORM{'obj1_pre'};

if (! $FORM{'mode'}) {
   $FORM{'mode'}="home";
}

## login control
#
$FORM{'sid_ok'} = check_login($script,$FORM{'mode'},$FORM{'sid'});

if ($debug) {
    print ERLOG " after check_login and $FORM{'sid_ok'} \n";
    print ERLOG " form mode is $FORM{'mode'} \n";
}


if ( $FORM{'sid_ok'} ) {
   if ( $FORM{'sid_ok'} =~ /^ERROR/ ) {
      ## hard error, redirected to login page
      exit 0 ;

   } elsif ( $FORM{'sid_ok'} =~ /^Error/ ) {
      ## soft error, send to default mode
      $FORM{'mode'}="home";
      $NVP{'__PAGE_ERROR_MSG__'}=$FORM{'sid_ok'};

   } else {
      # welcome to the page
   }

   ## script outputs to html
   #
   print "Content-type: text/html\n\n";
}         

if ($debug) {
    print ERLOG " form mode is now $FORM{'mode'} \n";
}

if ($FORM{'mode'} eq "submitlink" ) {
 
   &loadskutonvp( $FORM{'obj1'} );

   ## load linkage information from form   
   #
   $FORM{'loadfrom'}="form"; 

   @links=loadlinkages( $FORM{'loadfrom'}, $FORM{'obj1'} );
   for ( $i=0; $i<=$#links; $i++ ) {
      @temp=sort keys %{$links[$i]};
  
      while (@temp) {
         $x=shift @temp;
         if ($x =~ /inp/ && !$links[$i]->{$x}) {

            $pre="pre";
            $ini="ini";
            $xpre=$x;
            $xini=$x;	
            $xpre=~ s/inp/$pre/;
            $xini=~ s/ini/$ini/;

            $links[$i]->{$x}=$links[$i]->{$xini};
            if (!$links[$i]->{$x}) {$links[$i]->{$x}=$links[$i]->{$xpre};}
         }
      }
   } #/done dumping diagnostics...

   ## test for (and kill, as appropriate) kill entries
   #
   for ( $i=0; $i<=$#links; $i++ ) {
      # next if ( ! $links[$i]->{'KILL_inp'} );

      # there is a kill entry!

      if ( $links[$i]->{'objid'} =~ /^newrow/ && $links[$i]->{'KILL_inp'} ) {
         # just reinitialize
         $x=$links[$i]->{'objid'};


         $x =~ tr/A-Za-znewrow//d ;      # strip alphas 
	 if ($debug) {
	     print ERLOG "Create new row for: $x \n";
	 }
         $links[$i]=createnewrow($x);

      } elsif ($links[$i]->{'objid'} !~ /^newrow/) {
         # existing sku, kill the record and the list entry
         # 


	  if ($links[$i]->{'KILL_inp'}) {
          $q="UPDATE linkage SET status='15001-A' where ";
	      $q.="obj1='$FORM{'obj1'}' and obj2='$links[$i]->{'obj2_ini'}' ";
	      $dbh->do( $q );

	  if ($debug) {
	      print ERLOG "about to kill this item with --> $q\n";
	  }

	      ## kill it from the list
	      #

	      $ip=$i-1;
	      $ix=$i+1;
	      if ($ip > -1 && $#links >= $ix) { 
		  @links=( @links[0..$ip],@links[$ix..$#links] );
	      } elsif ($ip < 0 and $#links >= 1) { 
		  @links=@links[1..$#links];
	      } elsif ($ix > $#links && $ip >= 0) {
		  @links=@links[0..$ip];
	      }
	      #/ checking how to remake @links

	      $i--;         # decrement one so auto-increment net zero
	   
	  } else {
	      if (!$links[$i]->{'cellstyle_inp'}) {
		  $links[$i]->{'cellstyle_inp'}=$links[$i]->{'cellstyle_ini'};
	      }
	      if (!$links[$i]->{'linkwt_use_inp'}) {
		  $links[$i]->{'linkwt_use_inp'}=$links[$i]->{'linkwt_use_ini'};
	      }
	      if (!$links[$i]->{'alttitle_inp'}) {
		  $links[$i]->{'alttitle_inp'}=$links[$i]->{'alttitle_ini'};
	      }
	      $q="UPDATE linkage SET cellstyle='$links[$i]->{'cellstyle_inp'}', "; 
	      $q.=" linkwt_use='$links[$i]->{'linkwt_use_inp'}' ";
	      $q.=" where obj1='$FORM{'obj1'}' and obj2='$links[$i]->{'obj2_ini'}' ";
	      if ($debug) {
		  print ERLOG "Update linkage with --> \n$q\n";
	      }
	      $dbh->do($q);

	  }   
	  
      } # end of choosing how to kill the entry
  } # done killing links

   ## validate submitted data, write changes to tables
   #
   for ( $i=0; $i<=$#links; $i++ ) {
      $links[$i] = validatelink( $links[$i] );

      if ( ( $links[$i]->{'validationcheck'} eq "ok" ) 
         and ( $links[$i]->{'changestowrite'} eq "yes" ) ) {
         # write and log changes
         if ( $links[$i]->{'objid'} =~ /^newrow/ ) {
            push @links, writelink( $links[$i] );
            $x=$links[$i]->{'objid'};
            $x =~ tr/[A-Za-z_.]//d ;      # strip alphas
            $links[$i]=createnewrow($x);
         } else { 
            # it is an existing row, just update it
            $links[$i]=writelink( $links[$i] );  
         } # end of testing for new or not
         #
      } # end of data write cycle
   }

   ## change to editlink just before display modes, not here
   #
} #/submitlink

if ($FORM{'mode'} eq "editlink" ) {

## validateobject
#   $x=validatesku( $FORM{'obj1'} );
#   $NVP{'OBJ1_err'}=$x; 

   $x = ValidateOBJID($FORM{'obj1'}, $dbh);
   if ($debug) {
       print ERLOG "Check for valid objectid...........................\n";
   }

   if ( ! $x ) {                         # object exists! 

      ## load primary sku's data to NVP
      &loadskutonvp( $FORM{'obj1'} );

      ## now load linkage information  
      #
      $FORM{'loadfrom'}="db" if (! $FORM{'loadfrom'} );

      @links=loadlinkages( $FORM{'loadfrom'}, $FORM{'obj1'} );
      
      for ( $i=0; $i<=$#links; $i++ ) {
         @temp=sort keys %{$links[$i]};
         while (@temp) {
            $x=shift @temp;
         }
      }

   } else {                              # sku was bad
      $FORM{'mode'}="home";
      $FORM{'obj1_err'}=$script_msg{$x};
   }
} #/editlink

## last moment mode changes
#
if ( $FORM{'mode'} eq "submitlink" ) {
   $FORM{'mode'}="editlink";
}

## populate deterministic NVP elements
#
&populate_nvp();


#################################################################
## display routine for form modes
#
if ( $FORM{'mode'} eq "editlink" ) {
 
   $target="os_allcommerce-".$script."-".$FORM{'mode'};
   $pagetemplate = 
      loadtemplate($target,$skeletonpath);
   @rs_CELLSTYLE = split /\n/, 
      loadtemplate("CELLSTYLE.sel",$selskeletonpath);
   @rs_CELLDEPTH = split /\n/,
      loadtemplate("CELLDEPTH.sel",$selskeletonpath);
  
   @links = sortlinks(@links);

   @rownames=( "row_linkageed_a","row_linkagenew_a" );    # manual stub

   ## expand row entries
   #
   while (@rownames) {
  
      $thisrow=shift @rownames;
     
      $target=$thisrow;   # compute from $rownames[$i]
      $rowval="";

      $rowtemplate=loadtemplate( $target, "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin" );
      ## run through each linkage... 
      #
      $errortrap="";
      for ( $i=0; $i<=$#links; $i++ ) {
	  if ($links[$i]->{'obj2_err'}) { $errortrap ="yes";}

	  ## skip links not relevant to this row group

         next if ( ( $thisrow =~ /new_/ ) 
          and ( $links[$i]->{'objid'} !~ /newrow/ ) );

         next if ( ( $thisrow !~ /new_/ ) 
          and ( $links[$i]->{'objid'} =~ /newrow/ ) );

         ## append to processed template to growing rowval
         #     move linkage row data forward first

         $links[$i] = agelink($links[$i]); 
         $links[$i] = linksafehtml( $links[$i] ); 

         ## construct pulldowns as hashref entries
         #

         $links[$i]->{'CELLSTYLE_SELECT'} = 
          gen_select( $links[$i]->{'cellstyle_inp'},5,@rs_CELLSTYLE );
         $links[$i]->{'CELLDEPTH_SELECT'} = 
          gen_select( $links[$i]->{'cellstyle_inp'},1,@rs_CELLDEPTH );
         @temp = sort keys %{$links[$i]};

         while (@temp) {

            $k = shift @temp;

         } # done dumping linkage to logfile
         #

         $rowval.=permutebit( $rowtemplate, $links[$i] );

      } 
      ## now substitute back into page template
      #
      $thisrow="__".$thisrow."__";
      $pagetemplate =~ s/$thisrow/$rowval/gs ;
   }

   # populate template

   ## override anything inherited for these vars:
   #
   $NVP{'mode'}="submitlink";

##### garbage
    
 $spine=loadtemplate("openmerchant-linkage-spine","/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin");
 $pagetemplate = permutebit( $pagetemplate, \%NVP );
 $pagetemplate = permuteclean( $pagetemplate, \%NVP );
   
   # spew template 

$pagetemplate=~ s/<\!--#include virtual=\"openmerchant-linkage-spine.html\"-->/$spine/gms;

    $pagetemplate=~ s/__sid__/$sid/g;
    $pagetemplate=~ s/__obj1_pre__/$FORM{'obj1'}/g;

   print $pagetemplate;
   print "\n"; 
   
} else  {                                          # default to show search 
                                                   # engine box 

   ## locate and load the primary page template
   # 
   $target="os_allcommerce-"."linkage-home";


 $spine=loadtemplate("openmerchant-linkage-homespine","/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin");
   $pagetemplate=loadtemplate($target,"/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin");
   # populate template
   $pagetemplate = permutebit( $pagetemplate, \%NVP );
   $pagetemplate = permuteclean( $pagetemplate, \%NVP );
   
$pagetemplate=~ s/<\!--#include virtual=\"openmerchant-linkage-homespine.html\"-->/$spine/gms;

    $pagetemplate=~ s/__sid__/$sid/g;
    

   # spew template 
   print $pagetemplate;
   print "\n";
}

## terminal cleanup
#

$x = $dbh->disconnect if ( $dbh );


##################################################
## Subroutines

## loadlinkages - load sku-by-sku linkage data from form or database
sub loadlinkages {
   ## takes two arguments (mandatory) $source, $FORM{'objid'}
   # 

   my(%tfld,$sti,$n,$m,$source,$q,$sku,@linkah,$h,$k,$k2,$k3);

   if ($debug) {
       print ERLOG " IN loadlinkages................... \n";
   }

   # initialize hasref
   @linkah = ();      # array of hashrefs
   $h = {};           # temp for each linkage

   ( $source,$objid ) = @_;
   if ( $source eq "db" ) {
      $q='SELECT objid,obj2,status,linkwt_use ';
      $q.=" from linkage ";
#      $q.=" where obj1='$objid' and status <> '15001-A' ORDER BY linkwt_use";
      $q.=" where obj1='$objid' and status='15000-A' ORDER BY linkwt_use";

      if ($debug) {
	  print ERLOG "Select current links in loadlinkages with --> $q\n";
      }

      $sti = $dbh->prepare( $q );
      $sti->execute;
      $n=$sti->rows;

      ## go through the returned rows
      #
      for ( $i=0; $i<$n; $i++ ) {
	     $j=$i+1;

         $h=loadlinktohash( ($sti->fetchrow)[0], $j );

         push @linkah, $h;

      }
      $sti->finish;

      ## create the rows for new entries
      #
      for ( $i=1; $i<= $blankrows; $i++ ) {
         push @linkah, createnewrow($i);
      }

      ## fill in lost _inp elements
      #
      for ( $i=0; $i<=$#linkah; $i++ ) {
         $linkah[$i] = filllostinp( $linkah[$i] );
      } # done building linkah form-ish fields

   } else {

      ## assume load from form
      #
      %rowids = ();
      @formkeys = sort keys %FORM;
      ## now run through formkeys and construct $linkhh
      #
      while ( @formkeys ) {
         $s = shift @formkeys;
         next if ( $s !~ /^row/ );      # skip over the non-repetitive elements
         ## extract the rowid
         #
         $rid = (split /\./, $s )[1];
         ## check to see if the rowid has already been created
         #     if not, push a new hashref onto @linkah and record the 
         #     mapping of rowid onto array element number

         if ( defined($rowids{$rid}) ) {
            ## get the rowid for hash referencing
            #       
	     $rn=$rowids{$rid}; 

         } else {
            ##
            #
            push @linkah, {}; 
            $rowids{$rid} = $#linkah;
            $rn=$#linkah;
            $linkah[$rn]->{'objid'}=$rid;

         }
         ## now have the row number in $rn
         #     compute the field-key name from the form key

         @temp = split /\./, $s;
         $k = join ".", @temp[2..$#temp] ;

         ## write the hash entry 

         $linkah[$rn]->{$k} = $FORM{$s};

      } #/formkeys

      #
      ## linkah now constructed, perform data validation elsewhere
      #     each linkage is now a hashref of it's own
      #

      for ( $i=0; $i<=$#linkah; $i++ ) {
      	
         ## check for lost inputs
         #
         $linkah[$i] = filllostinp( $linkah[$i] );
         $linkah[$i]->{'cellwidth_ini'} = ( split /_/,
            $linkah[$i]->{'cellstyle_inp'} )[1];

      } # done checking for lost inputs

   } #/source variations

   # return the hashref array...
   return @linkah;
} #/loadlinkages

## populate_nvp
#     populate the NVP hash from %FORM elements, 
#     returns sorted array of row-style elements
sub populate_nvp {
   ## construct a return value that is an array of hash refs
   #     each hash is one sku
   #     hashes are sorted on column width and weight
   #
   my(@keys,$k);
   if ($debug) {
       print ERLOG " IN populate_nvp................... \n";
   }

   ## stuff from submitted form elements
   #

   @keys = sort keys %FORM;
   ## separate repetitive elements from non-repetitive
   #
   while (@keys) {
      $k = shift @keys;
      next if ( $k =~ /^row/ );       # skip repetitive bits
      $NVP{$k}=$FORM{$k} if ( ! defined($NVP{$k}) );
   } #/while running through keys
  
   ## stuff from localization specific data
   #
   #$NVP{'script'}="$scriptpath/login.cgi?mode=main";
   $NVP{'script'}="$scriptpath/$scriptname";
   $NVP{'scriptname'}=$scriptname;
   $NVP{'scriptpath'}=$scriptpath;
   $NVP{'sitename'}=$site->{'sitename'};
   
   #
   return 1;
} # /populate_nvp


## createnewrow(n):\% - returns a hashref to a blank newrow of number n
#
sub createnewrow {
   my($h,$n);
   $n=$_[0];     # the passed row number

   if ($debug) {
       print ERLOG " IN createnewrow................... \n";
   }
   $h = {};
   $h->{'obj2'}="";
   $h->{'title'}="";
   $h->{'linkwt_use'}="";
   $h->{'linkwt_man'}="";
   $h->{'cellstyle'}="";
   $h->{'celldepth'}="";
   $h->{'status'}="";
   @temp=keys %{$h};
   while (@temp) {
      $k = shift @temp;
      $k2 = $k."_ini";
      $h->{$k2}="";
      $k2 = $k."_inp";
      $h->{$k2}="";
   }
 
   $h->{'objid'}="newrow$n";
   return $h;
} #/createnewrow


## filllostinp( \% ): \% - fill in lost _inp fields
sub filllostinp {
   my(@temp,$h,$k,$k2);
   $h=$_[0];
   if ($debug) {
       print ERLOG " IN fillostinp................... \n";
   }
   @temp = keys %{$h}; 
   foreach $k ( @temp ) {
      next if ( $k !~ /_pre$/ );
      $k2 = $k;
      $k2 =~ s/_pre$/_inp/ ;
      $h->{$k2}=$h->{$k} if (( ! exists( $h->{$k2} ) ) and ( $h->{$k} ));
   }
   return $h;
} #/filllostinp


## writelink( \% ):\% - writes changes to a linkage to tables, returns
#     a new hashref to the updated record
#
sub writelink {
   my($h,$sti,$t,$q,$k,$fn);
   $h = $_[0];

   if ($debug) {
       print ERLOG " IN writelink................... \n";
   }
   $fields_linkage="obj1,obj2,objclass,title,alttitle,linkwt_use,";
   $fields_linkage.="manweight,cellstyle,celldepth,";
   $fields_linkage.="objclass,status,cdate,mdate";
   $t = time();
   $q="";             # holder for UPDATE statement

   $h->{'obj1_inp'}=$FORM{'obj1'};
   $h->{'obj1_ini'}="";

   ## insert a blank record if new, use to set objid
   #
   if ( $h->{'objid'} =~ /new/ ) {    # new sku
       $dvalue=$h->{'obj1_inp'}."\t".$h->{'obj2_inp'};
# added series
       $p="INSERT INTO levents (dtable,dvalue,cdate,series) values('linkage','$dvalue','$t','$site->{'series'}') ";
       if ($debug) {
	   print ERLOG "Insert into levents with --> $p\n";
       }
       $stp=$dbh->prepare( $p );
       $stp->execute;
       $e="SELECT event,series from levents where dtable='linkage' and ";
       $e.=" dvalue='$dvalue' and cdate='$t' ";
       if ($debug) {
	   print ERLOG "Select next num from levents with --> $e\n";
       }
       $ste=$dbh->prepare($e);
       $ste->execute;
       $nume=$ste->rows;
       ($event, $series) = $ste->fetchrow;
       $objid=$event."-".$series;

       if ($debug) {
	   print ERLOG "Created objid $objid \n";
       }

# added status to the query
      $q="INSERT INTO linkage (objid,obj1,obj2,linkwt_use,cellstyle,celldepth,cdate,mdate,status) ";
      $q.=" VALUES ('$objid','$h->{'obj1_inp'}','$h->{'obj2_inp'}','$h->{'linkwt_use_inp'}', ";
      $q.="'$h->{'cellstyle_inp'}','$h->{'celldepth_inp'}','$t','$t','15000-A') ";
      if ($debug) {
	  print ERLOG "Inserting linkage with --> $q\n";
      }
      $sti=$dbh->prepare( $q );
      $sti->execute;

      $h->{'objid'}=$objid;
      $sti->finish;
  
 } # end of initial insertion for new skus

   ## check for passable values of LNKWEIGHT and CELLWIDTH
   #     lookup/generate if needed
   #
   if ( ! $h->{'linkwt_use_inp'} ) {
      $q="SELECT objid,weight_use from things where objid=";
      $q.="'$h->{'obj2_inp'}'";
      if ($debug) {
	  print ERLOG "Select objid and weight from things with --> $q\n";
      }
      $sti = $dbh->prepare( $q );
      $sti->execute;
      $q=$sti->{'errstr'};
      $x = $sti->rows;

      if ( $x == 1 ) {
         ( $k,$v ) = $sti->fetchrow;
         $h->{'linkwt_use_inp'}=$v;
         $h->{'linkwt_use_ini'}="" if ( ! $h->{'linkwt_use_ini'} );
      } # else wrong number of rows...

   } # end of evaluation of value of LNKWEIGHT

   # now check the cellwidth entry...        
   ( $v ) = ( split /_/, $h->{'cellstyle_inp'} )[1];
   
   ## run through fields, look for non-initial values     
   $q="";
   @temp = sort keys %{$h};
   while (@temp) {

      $k = shift @temp;

      next if ( $k !~ /_inp$/ );  # only care about entered fields
      next if ( $k =~ /^KILL/ );  # only care about entered fields
      next if ( $k =~ /^objid/ ); # NEVER update the objid

      $fn = $k;
      $fn =~ s/_inp$// ;         # fieldname root
      $k2 = $fn."_ini";          # initial value
 
      next if ( $fields_linkage !~ /$fn/ );  # a real field? 

      # now compare and construct the insert clause
      if ( exists($h->{$k2}) and ( $h->{$k2} ne $h->{$k} )) {
         # meaningful comparison 
         $q.="," if ( $q );
         $q.="$fn='".string_todbi($h->{$k})."'";
      } #/done evaluating if this is a change or not
   } # end of running through fields

   ## finish the query
   #
   if ($q) {
      # update syntax
      $q.=",mdate=$t";
      $q = "UPDATE linkage SET $q where obj1='$h->{'obj1_inp'}' and obj2='$h->{'obj2_inp'}' ";
      if ($debug) {
	  print ERLOG "Update an existing linkage with --> $q\n";
      }
      $dbh->do( $q );
   }
   
   ## update the hashref
   #
   if (!$h->{'objid'}) {
      if (!$h->{'obj2_inp'}) {
         $h->{'obj2_inp'}=$h->{'obj2_ini'};
      }

      $wow="SELECT objid from linkage where obj1='$h->{'obj1_inp'}' "; 
      $wow.=" and obj2='$h->{'obj2_inp'}' and status='15001-A' ";
      $wow.=" and obj2='$h->{'obj2_inp'}'";

      if ($debug) {
	  print ERLOG "Select the deactivated rows with  --> $wow\n";
      }

    $stw=$dbh->prepare($wow);
    $stw->execute;
    $numw=$stw->rows;

    ($objid)=$stw->fetchrow;
    $h->{'objid'}=$objid;
  }
   if ($debug) {
       print ERLOG "IN loadlinktohash with $h->{'objid'}\n";
   }
  $h=loadlinktohash( $h->{'objid'} );

   return $h;
} #/writelink

##### loadlinktohash(rowid):\% - loads linkage 
#
sub loadlinktohash {
   ## take a numeric rowid and load it
   #
   my($objid,$h,$sti,$q);
   $objid=$_[0];
   if ($debug) {
       print ERLOG " IN loadlinktohash................... \n";
   }
   $h={};
   
   if ( $objid ) {
#  Changed status check
#      $q="SELECT * from linkage where objid='$objid' and status <> '15001-A'";
      $q="SELECT * from linkage where objid='$objid' and status = '15000-A'";
      if ($debug) {
	  print ERLOG "Get valid links in loadlinktohash with --> $q\n";
      }
      $sti = $dbh->prepare( $q );
      $sti->execute;
      if ($debug) {
	  print ERLOG "Selecting current links with --> $q \n";
      }
      if ( $sti->rows == 1 ) {
         $h=$sti->fetchrow_hashref;
      	 $h->{'objid'}=$objid;
         ## now load the default title,weight...
         #

         # Added axisnames, ref_from and vcode to populate title of variant
         $q="SELECT title,weight_use,axisnames,ref_from,vcode from things where objid='";
         $q.=$h->{'obj2'}."' ";

         if ($debug) {
	     print ERLOG "Select from things with --> $q\n";
	 } 

         $sti = $dbh->prepare( $q );
         $sti->execute;
       
	 if ( $sti->rows == 1 ) {
            # Added axisnames, ref_from and vcode to populate title of variant
            ( $h->{'title'},$h->{'linkwt_man'},$h->{'axisnames'}, $h->{'ref_from'},$h->{'vcode'} ) = ( $sti->fetchrow );

            # Added to populate title of variant
	    if ($h->{'ref_from'} ne $h->{'obj2'} && $h->{'ref_from'} ne "") {
		if ($debug) {
		    print ERLOG "Need to set objid variant title!\n";
		}
		# get the master title
		$q="SELECT title FROM things WHERE objid = \"$h->{'ref_from'}\"";
                $sti2 = $dbh->prepare($q);
                $sti2->execute;

                if ($sti2->rows == 1) {
                   $h->{'title'} = $sti2->fetchrow;
		   
                   # get the body to determine the text to take for th title
  		   $q="SELECT body FROM extraprop WHERE objid = \"$h->{'axisnames'}\" and fieldname = 'encodings'";
		   if ($debug) {
		       print ERLOG "Extraprop query --> $q\n";
		   }
		   $sti2 = $dbh->prepare($q);
		   $sti2->execute;
		   if ($sti2->rows == 1) {
		      $extraprop->{'body'} =  $sti2->fetchrow;
		      if ($debug) {
			  print ERLOG "Body is .$extraprop->{'body'}.\n";
		       }
		      @rows = split (/\n/,$extraprop->{'body'});
		      foreach $row (@rows) {
			 ($code, $val) = split(/:/,$row);
		 	 if ($code eq $h->{'vcode'}) {
			    $h->{'title'} .= " - " . $val;
                            if ($debug) {
                              print ERLOG "Title is .... $h->{'title'} for variant!\n"
                            }
                            break;
		         }
                      }
		   }
                }
	    }  # end of populate title for variant
           $h->{'title'} = string_exdbi( $h->{'title'} );
         } # done loading default title, if extant

         @temp = keys %{$h};
         while ( @temp ) {
            $k = shift @temp;
            $v = string_exdbi($h->{$k});
            $kp=$k."_pre";
            $kn=$k."_ini";
            $ki=$k."_inp";
            $h->{$k}=$v;
            $h->{$kp}=$v;
            $h->{$kn}=$v;
            $h->{$ki}=$v;
         } # done permuting fieldnames
      } # done loading if one record
      $sti->finish;
   } # done acting on good rowid
   
   return $h;
} #/loadlinktohash


## agelink ( \% ):\% - moves _inp to _pre values
#
sub agelink {
   my($h,@temp,$k,$v);
   $h = @_[0];   
   if ($debug) {
       print ERLOG " IN agelink................... \n";
   }
   @temp = sort keys %{$h};
   while (@temp) {
      $k = shift @temp;
      next if ( $k !~ /_inp$/ );   # only want input values
      $v =  $h->{$k} ;
      $k2 =~ s/_inp$/_pre/ ;
      $h->{$k2}=$v if ( $v );
   }
   return $h;
} #/agelink


## linksafehtml ( \% ):\% - makes TITLE and ALTTITLE keys html-safe
#
sub linksafehtml {
   my($h,@temp,$k,$v);
   $h = @_[0];   
   if ($debug) {
       print ERLOG " IN linksafehtml................... \n";
   }
   @temp = sort keys %{$h};
   while (@temp) {
      $k = shift @temp;
      next if ( $k !~ /(title|alttitle)/ );   # only want titles
      $h->{$k} = string_tohtml( $h->{$k} ) ;
   }
   return $h;
} #/agelink


## loadskutonvp($sku) - loads sku's data to NVP
sub loadskutonvp {
   my($h,$k,@temp,$k2,$sku);
   $sku=$_[0];

   if ($debug) {
       print ERLOG " IN loadskutonvp................... \n";
   }
   ## load parent sku's data from db
   #
   $h = {};
   $h=loadskutohash( $sku );

   @temp = keys %{$h};
   while (@temp) {
      $k = shift @temp;
      $NVP{$k} = $h->{$k};
      $k2=$k."_pre";
      $NVP{$k2} = $h->{$k};
      $k2=$k."_ini";
      $NVP{$k2} = $h->{$k};
   }       
   ## special cases
   #
   $NVP{'lengthdescr'}=length($NVP{'descript'});        
   $NVP{'lengthdescr'}.=" Characters";
    
   return 1;
} #/loadskutonvp


## sortlinks( @ ): @ - take a list of links and sort them 
#
sub sortlinks {
   my( @h,@o,@temp,$i,$k,$c );
   @h = @_; 
   @o = ();
   @temp=();

   if ($debug) {
       print ERLOG " IN sortlinks................... \n";
   }  
   for ( $i=0; $i<=$#h; $i++ ) {
      $k=$h[$i]->{'linkwt_use'};
      $k='0' if ( ! $k );
      if ( $h[$i]->{'manweight_inp'} > 0  ) {
         $k=$h[$i]->{'manweight_inp'};
      } # done seeing if manweight overrides LNKWEIGHT

      $c='0' if ( ! $c );
      # now construct sort key
      $k = "$c".'.'."$k X$i";
      push @temp, $k; 
   } # end of running through key creation for sorting

   sub bywidthweight { $b <=> $a; } # sort numerically descending 
   @temp=sort bywidthweight @temp;

   while ( @temp ) {
      ( $k, $i ) = split /X/, shift @temp;
      push @o, $h[$i] ;
   } # end of assembling new array   

   
   return @o;
} #/sortlinks

sub message {

   if ($debug) {
       print ERLOG " IN message................... \n";
   }
   # check the language that is being used and open appropriate
   # message language file or get messages below
   if ($om_render_lang eq "eng" ) {
      $script_msg{1}="evaluates as";
      $script_msg{INVALID_OBJ}="The object entered could not be found!";
   } else {
      open( EM, "<$relpath/bits/$om_render_lang/system/$script.messages");
      while(<EM>) {
         chomp;
         next if /^\#/;
         next if (! $_);
         @temp=split /\t/;
         $script_msg{$temp[0]}=$temp[1];
      }
      close(EM);
   }
}


1;
