#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#
# order.cgi
#
# Version 0.9.1 IB 20000502
#    introduced $script variable
# Version 0.7.27 IB 20000420
#    insert->INSERT, set->SET
# Version 0.7.27 JC 20000411
#    $om_render_lang update
# Version 0.7.26 JC 20000410
#    multilingual messages
# Version 0.7.25 IB 20000402
#    new directory structure
# Version 0.7.24 JC 20000330
#    changed connect statement
# Version 0.7.23 JC 20000329
#    changed DBI prepare/connect
# Version 0.7.22 IB 20000327
#    corrected $relpath
# Version 0.7.21 IB 20000324
#    changed the way site.pm is obtained (multiple stores)
# Version 0.7.20 IB 20000302
#    updated copyright
# Version 0.7.19 IB 20000228
#    changed store to site
# Version 0.7.18 JZ 20000224
#    Add funciton to show order, change SHIPSTATUS to ORDERSTATUS 
# Version 0.7.17 JZ 20000216
#    Add cancellation of order, replace html with templates
# Version 0.7.16 JZ 20000210
#    show address and credit card information
# Version 0.7.15 JZ 20000117
#    removed CALLSTATUS
# Version 0.7.14 JZ 20000114
#    fixed shipping and call information
# Version 0.7.13 JZ 20000112
#    fixed searching date validation err msg
# Version 0.7.12 JZ 20000108
#    fixed finding problem
#    add validation check of date format
# Version 0.7.11 IB 991205
#    replaced exmysql with exdbi
# Version 0.7.10 IB 991203
#    Corrected om directory
# Version 0.7.9 IB 991202
#    fixing of global variables
# Version 0.7.8 IB 991126
#    fixing of a comment statement
# Version 0.7.7 IB 991121
#    corrected bits/sel to bits/site/sel
# Version 0.7.6 IB 991112
#    corrected the determining of a relpath
#    removed foreach
#    corrected $scriptname
# Version 0.7.5 IB 991109
#    removing of HACKS, and correcting of relpath
# Version 0.7.4 IB 991103
#    general cleanup
# Version 0.7.3 RF 990908
#    changed embeded html bits to utilize $script instead of hard paths
# version 0.7.2 SH 990831
#    added in vcode display from myhome
#    fix weird bug where i had to substr selects but no more   
# SH Major Version whatever many many many rewrites 
# SH will fill in later what i did
#

## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om/admin,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$siteshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $siteshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $siteshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

$relpath .= "/../$siteshortname";

use DBI;
require "$relpath/lib/conversions.pm";
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/login.pm";
require "$relpath/conf/site.pm";
require "$relpath/lib/validate.pm";

## establish site-specific parameters
#
$site=setsite();

## get the CGI bits
#
%FORM=();
&ReadParse;

$sid=$FORM{'sid'};

$om_render_lang=$FORM{'OM_UI_LANGUAGE'};
$om_render_lang=$site->{'om_locale_lang_def'} if ( !$om_render_lang);
$om_render_lang="eng" if ( !$om_render_lang );

## load messages
$verbose_errors=1;
%script_msg=();          # user interaction messages
%script_err=();
$script=( split /\./, $scriptname )[0];
&message; 

## done with pull-from-file bits, rest of global settings...
#
$x= (split /\?/, $ENV{'REQUEST_URI'})[0];   # strip get stuff
@temp=split /\//, $x;

@temp=("cgi-bin","test","order.cgi") if (! $ENV{'REQUEST_URI'} );

$script=( split /\./, $scriptname )[0];
$n= $#temp - 1;
$scriptpath = join "/", ( @temp[0..$n] );
$skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin";
$selskeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/site/sel";

## filled in with time/context variable info
$nicedt=nicedatetime();

$now=time();

## construct some shorthands
$script_html = join "-", ($site->{'siteshortname'},$script,"");

## connect to database
# system 6 database state, products, and customer tables are collapsed
#
$q="$site->{'db_site_config'}";
$dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

## start the replacements hash
#
%NVP=();
$NVP{'sitename'}=$site->{'sitename'};


$spine=loadtemplate("openmerchant-order-spine",$skeletonpath);

foreach ( 'SHIPSTATUS|2', 'ORDERSTATUS|2', 'WAREHOUSE|2') {
   local($k,$v,$x,@raw);
   ( $k,$v) = split /\|/, $_;
   open(FH, "<$selskeletonpath/$k.sel");
   @raw=<FH>;
   chomp @raw;
   close(FH);
   $x=$k."_inp";;
   $kt=$k."_SELECT";
   $NVP{$kt}= gen_select( "",$v,@raw );
}

if (! $FORM{'mode'}) {
   $FORM{'mode'}="home";
}

$FORM{'sid_ok'} = check_login($script,$FORM{'mode'},$FORM{'sid'});

if ( $FORM{'sid_ok'} ) {
   if ( $FORM{'sid_ok'} =~ /^ERROR/ ) {
      ## hard error, redirected to login page
      exit 0 ; 
   } elsif ( $FORM{'sid_ok'} =~ /^Error/ ) {
      ## soft error, send to default mode
      $FORM{'mode'}="home";
      $NVP{'PAGE_ERROR_MSG'}=$FORM{'sid_ok'};
   } else {
      ## welcome to the page...
   }   
   print "Content-type: text/html\n\n";
} else {
   ## unknown why sid_ok not populated with some string...
   #
   print "Content-type: text/html\n\n";
   print "<HTML><HEAD></HREAD><BODY>\n";
   print "$FORM{'sid'} sid $script_msg{1} $FORM{'sid_ok'} \n";
   exit 0;
}

$NVP{'sid'}=$FORM{'sid'};
$NVP{'lastmode'}=$FORM{'mode'};
$NVP{'script'}="$scriptpath/$scriptname";
$NVP{'datetime'}=$nicedt;
$NVP{'scriptpath'}=$scriptpath;

# check to see if the homepage is simply clearing the form
if (($FORM{'searchclear'}) and ($FORM{'mode'} eq "find")) {
   $FORM{'mode'}="home";
} #

if ($FORM{'mode'} eq "showstats" and $FORM{'submit'} eq "Show Stats"){
   $FORM{'startdate'} =~ s/\s*//g if $FORM{'startdate'};
   $FORM{'enddate'} =~ s/\s*//g if $FORM{'enddate'};  

   $FORM{'mode'} = 'stats'; 
   if ($FORM{'startdate'} =~ /^\d{1,2}\/\d{1,2}\/\d{4}$/ && $FORM{'enddate'} =~ /^\d{1,2}\/\d{1,2}\/\d{4}$/) {
      @start= split /\//, $FORM{'startdate'};
      @end= split /\//, $FORM{'enddate'};
      if ($start[0] > 12 || $start[1] > 31 || $end[0] > 12 || $end[1] > 31) {
         $NVP{'PAGE_ERROR_MSG'} = "$script_msg{2}";
      } else {
         use Time::Local;
         $testtime=timelocal(0,0,0,6,01,99);
         $starttime=timelocal(0,0,0, $start[1], $start[0]-1, $start[2]);
         $endtime=timelocal(59,59,23, $end[1], $end[0]-1, $end[2]);
         $now = time();
         if ($starttime == -1 || $endtime == -1) {
            $NVP{'PAGE_ERROR_MSG'} = "$script_msg{3}";
         } elsif ($starttime > $endtime) {
            $NVP{'PAGE_ERROR_MSG'} = "$script_msg{4}";      
         } elsif ($starttime > $now) {
            $NVP{'PAGE_ERROR_MSG'} = "$script_msg{5}";
         } else { $FORM{'mode'} = 'showstats';}
      }
   } elsif (!$FORM{'startdate'} || !$FORM{'enddate'}) {
      $NVP{'PAGE_ERROR_MSG'} = "$script_msg{6}";
      $NVP{'startdate_prev'} = $FORM{'startdate'};

      $NVP{'enddate_prev'} = $FORM{'enddate'};
   } else { $NVP{'PAGE_ERROR_MSG'} = "$script_msg{7}"; }
} # end of showstats date check

# check if the time input is OK
if ($FORM{'mode'} eq "showstats" and $FORM{'submit'} eq "Today" ) {
   #check time entered
   if ($FORM{'startmin'} =~ /\d+/ && $FORM{'starthour'} =~ /\d+/ && $FORM{'endhour'} =~ /\d+/ && $FORM{'endmin'} =~ /\d+/
 	&& $FORM{'startmin'} <60 && $FORM{'endmin'}<60 && $FORM{'starthour'} <24 && $FORM{'endhour'}<24) { 
      use Time::Local; 
      $nowdate = localtime();
      @today = split /\s/, $nowdate;
      %mh = $script_msg{8};
      $starttime = timelocal(0, $FORM{'startmin'}, $FORM{'starthour'}, $today[2], $mh{$today[1]}, $today[4]);
      $endtime = timelocal(0, $FORM{'endmin'}, $FORM{'endhour'}, $today[2], $mh{$today[1]}, $today[4]); 
   } else {
      $NVP{'PAGE_ERROR_MSG'} = "$script_msg{9}";  
      $FORM{'mode'} = 'stats';
   }

} # end of showstatus time check

if ($FORM{'mode'} eq "find" ) {
   chomp $FORM{'ORDERSTATUS'} if $FORM{'ORDERSTATUS'};
   chomp $FORM{'WAREHOUSE'} if $FORM{'WAREHOUSE'};
   $orderid_pre = '';
   if ($FORM{'orderid'}) { $orderid_pre = $FORM{'orderid'};  $FORM{'orderid'} =~ s/\s//g; $FORM{'orderid'} =~ s/'/''/g; $FORM{'orderid'} =~ s/\\/\\\\/g;}
   $FORM{'startdate'} =~ s/\s*//g if $FORM{'startdate'};
   $FORM{'enddate'} =~ s/\s*//g if $FORM{'enddate'};

   @extract= split /"/, $FORM{'WAREHOUSE'};
   $FORM{'WAREHOUSE'} = $extract[0];

   $dateflag = 0;
   $x = 0;
   if ($FORM{'startdate'} =~ /^\d{1,2}\/\d{1,2}\/\d{4}$/ && $FORM{'enddate'} =~ /^\d{1,2}\/\d{1,2}\/\d{4}$/) {
      @start= split /\//, $FORM{'startdate'};
      @end= split /\//, $FORM{'enddate'};
      if ($start[0] > 12 || $start[1] > 31 || $end[0] > 12 || $end[1] > 31) {
         $NVP{'PAGE_ERROR_MSG'} = "$script_msg{10}";
      } else { 
         use Time::Local;
         $testtime=timelocal(0,0,0,6,01,99);
         $starttime=timelocal(0,0,0, $start[1], $start[0]-1, $start[2]);
         $endtime=timelocal(59,59,23, $end[1], $end[0]-1, $end[2]);
         $now = time();
         if ($starttime == -1 || $endtime == -1) {
            $NVP{'PAGE_ERROR_MSG'} = "$script_msg{11}";
         } elsif ($starttime > $endtime) {
            $NVP{'PAGE_ERROR_MSG'} = "$script_msg{12}";     
         } elsif ($starttime > $now) {
            $NVP{'PAGE_ERROR_MSG'} = "$script_msg{13}";
         } else { $dateflag = 1;}
      }
   }  elsif ( !$FORM{'enddate'} && !$FORM{'startdate'}) {
      if (!$FORM{'CALLSTATUS'} && !$FORM{'ORDERSTATUS'} && !length($FORM{'orderid'}) && !$FORM{'WAREHOUSE'} && !$FORM{'custname'}) {
         $NVP{'PAGE_ERROR_MSG'} = "$script_msg{14}";
      } else { $x = 1;}
   } elsif ( !$FORM{'enddate'} || !$FORM{'startdate'}) {
      $NVP{'PAGE_ERROR_MSG'} = "$script_msg{15}";
   } else {
      $NVP{'PAGE_ERROR_MSG'} = "$script_msg{16}";
   }

     if ($x || $dateflag ) {
      $query = "SELECT DVALUE, CDATE from levents where DVALUE LIKE '\%success\%' ";
      if ($FORM{'custname'}) {
	 $cn = $FORM{'custname'};
	 $cn =~ s/'/''/g;
	 $cn =~ s/^\s*//;
	 $cn =~ s/\s*$//;
	 $query = "SELECT levents.DVALUE, levents.CDATE from levents, contacts";
	 $query .= " where contacts.uid = levents.uid";
	 $query .= " AND contacts.uname LIKE '\%$cn%'";
	 $query .= " AND DVALUE LIKE '\%success\%' ";
      }

      if ( length($FORM{'orderid'}) > 0 ) {
         $query .=" AND DVALUE LIKE '$FORM{'orderid'}\t%' ";
      
      } elsif ($dateflag) {
         $query .=" and CDATE >= '$starttime' and CDATE <= '$endtime' "; 
         $flag = 1;
      }

      if ( $FORM{'ORDERSTATUS'} && !$FORM{'orderid'}) { 
         $query.=" AND DVALUE LIKE '\%\t$FORM{'ORDERSTATUS'}\t\%' "; 
         $flag = 1;
      } 
   
      if ( $FORM{'WAREHOUSE'} && !$FORM{'orderid'} ) {
         $query.=" AND DVALUE LIKE '\%\t$FORM{'WAREHOUSE'}\t\%' ";
      }

      $query .="  ORDER BY CDATE ";
      $sth = $dbh->prepare($query);
      $sth->execute;
      $num = $sth->rows;
    
      if ( $num < 1 ) {
         # the query returned nothing
   	  
         $FORM{'mode'}='home';
   
         # push error message into page error message 
         $NVP{'PAGE_ERROR_MSG'} = "$script_msg{17}";
         $NVP{'orderid_prev'}=$orderid_pre;
         $NVP{'startdate_prev'}=$FORM{'startdate'};
         $NVP{'enddate_prev'}=$FORM{'enddate'};
         $NVP{'ORDERSTATUS_prev'}=$FORM{'ORDERSTATUS'};
	 $NVP{'custname_prev'} = $FORM{'custname'}; 
      } elsif ( $num==1 ) {
         # exactly one row returned
         # --> send directly to appropriate editor routine
   	 $FORM{'mode'}="showorder";      
         $FORM{'loadfrom'}="db";    
         $FORM{'query'}=$query;
   	 if (!$FORM{'orderid'}) {$FORM{'orderid'} = $dvalue[0];}
         $NVP{'orderid_prev'}=$orderid_pre;
      } else {
         $FORM{'mode'}="searchlist";
         $FORM{'query'}=$query;
      }

         $sth->finish;

   } else {
      $FORM{'mode'}="home";
      $NVP{'orderid_prev'}=$orderid_pre;
      $NVP{'startdate_prev'}=$FORM{'startdate'};
      $NVP{'enddate_prev'}=$FORM{'enddate'}; 
      $NVP{'custname_prev'} = $FORM{'custname'};
   }
 # }  # end searchnow if
} 

if ($FORM{'mode'} eq "update" and $FORM{'submit'} eq "Update") {
   # handle shipped, remove, update QTY, return, reship information
   $orderid = $FORM{'orderid'};

   $linecounter = 0;
   for (1..$FORM{'linecounter'}) {
      $linecounter ++;
      $lineid = $FORM{"LINE$linecounter"};

      if ($FORM{"ACT$lineid"} eq "Update QTY") {
=cut
	$l="UPDATE ocart SET quant=$FORM{'QTY$lineid'} where lineid=$lineid";
	$stl=$dbh->prepare($l);
	$stl->execute;
        $stl->finish;

        $l="INSERT into levents(dtable, dvalue, cdate) values ('ocart', '$lineid\tUpdated', '$now');
	$stl=$dbh->prepare;
        $stl->execute;  
        $stl->finish;
=cut
      } elsif ($FORM{"ACT$lineid"} eq "Reship") {

      } elsif ($FORM{"ACT$lineid"} eq "Return") {



      } elsif ($FORM{"ACT$lineid"} eq "Remove") {

      } elsif ($FORM{"ACT$lineid"} eq "Shipped") {


      } 

   }
}

if ($FORM{'mode'} eq "editship" ) {
   if ( $FORM{'loadfrom'} eq "db" ) {
      &loadskufromdb($FORM{'lineid'},$FORM{'orderid'});
   } elsif ( $FORM{'loadfrom'} eq "form" ) {
      &checkformbits();
   } 

   $okdata=validatefields();

   if ( $okdata ) {
      if ( $FORM{'loadfrom'} eq "form" ) {
         $x=writeskutodb($FORM{'lineid'},$FORM{'orderid'});
         $skulink="<A HREF=$scriptpath/$scriptname";
         $skulink.="\?\&mode=find&orderid=$FORM{'orderid'}&lineid=$FORM{'lineid'}&sid=$FORM{'sid'}\>orderid=$FORM{'orderid'}&lineid=$FORM{'lineid'} </a>";
         $NVP{'lastaction'}="$script_msg{18} $skulink <BR>";
         $FORM{'mode'}="editship" if ($x);
      }
   } # okdata
} #editship

$targ=$siteshortname."-".$script."-".$FORM{'mode'};

if ( $verbose_errors ) {
print STDERR "$script_err  $siteshortname $targ \n";
}
########################################################
## Primary Display Mode Handling

if ($FORM{'mode'} eq "searchlist") {
   $pagetitle="$script_msg{19}";
   if ($FORM{'query'}) {
      $query = $FORM{'query'};
   } else {
      $query = "select DVALUE, CDATE from levents where DVALUE LIKE '\%success\%' AND DVALUE LIKE '$FORM{'orderid'}\t\%' ";
   }

   $sth = $dbh->prepare ( $query );
   $sth->execute;
   $num = $sth->rows;
   $expand1 = "";
   $v="&sid=$sid&mode=showorder&loadfrom=db";
   $old = "old";

   $t = loadtemplate("row_order_searchlist", $skeletonpath);
   $t =~ s/<!--.*-->//s;
   for (1..$num) {
      %row=%{$sth->fetchrow_hashref};
      $dvalue=$row{'DVALUE'};
      @dvalue=split /\t/, $dvalue;
      $oid=$dvalue[0];
      $sidwh=$dvalue[1];
      $k="orderid=$oid";
      next if ($old eq $oid && $dvalue ne /success/ );     
      $old=$oid;

      @keys= keys %row;

      $date = $row{'CDATE'};

      $l="select shipcost, taxrate, ordtotal, uid from orders where oid='$oid' ";
      $stl=$dbh->prepare($l);
      $stl->execute;
      $numl=$stl->rows;
      ($shipcost, $taxrate, $ordtotal, $uid)=$stl->fetchrow;

      $l = "select uname from contacts where uid='$uid'";
      $stl=$dbh->prepare($l);
      $stl->execute; 
      ($SL{'UNAME'}) = $stl->fetchrow;

      @date=localtime($date);
      $month=$date[4]+1;
      $date[5] += 1900;

      $SL{'DATE'} = "$month/$date[3]/$date[5]";
      $SL{'TIME'} = "$date[2]:$date[1]:$date[0]";
      $SL{'OID'} = $oid;
      $SL{'OIDREF'} = "$scriptpath/$scriptname\?$v\&$k";

      $sh="select dvalue from levents where dtable='orders' and dvalue='$oid\tShipped' ";
      $stsh=$dbh->prepare($sh);
      $stsh->execute;
      $numsh=$stsh->rows;
      ($shipstatus)=$stsh->fetchrow;

#      $SL{'SHIPREF'} = "$scriptpath/$scriptname\?$v&$k";  
      $SL{'SHIP'} = "$script_msg{20}";
      $SL{'SHIP'} = "$script_msg{21}" if (!$shipstatus);
      $SL{'WH'} = $sidwh;

      $NVP{'column_215_1'} .= permutebit($t, \%SL);
   }

} elsif ( $FORM{'mode'} eq "showorder" ) {
   $NVP{'mode'} = "update";

   if ($FORM{'query'}) {
      $query = $FORM{'query'};
   } else {
      $query = "select DVALUE, CDATE from levents where DVALUE LIKE '\%success\%' AND DVALUE LIKE '$FORM{'orderid'}\t\%' ";
   }
  
   $sth = $dbh->prepare ( $query );
   $sth->execute;
   $num = $sth->rows;

#   $v="&sid=$sid&mode=showorder&loadfrom=db";
   $old="";
 
   if ($num > 0) {
      %row=%{$sth->fetchrow_hashref};
      $dvalue=$row{'DVALUE'};
      @dvalue=split /\t/, $dvalue;
      $oid=$dvalue[0];
      $sidwh=$dvalue[1];
      $NVP{'sidwh'}=$sidwh;

      $l="select c.uname from contacts as c, orders where c.uid=orders.uid and orders.oid='$oid' ";
      $stl=$dbh->prepare($l);
      $stl->execute; 
      ($NVP{'CUSTNAME'}) = $stl->fetchrow;

#     $k="orderid=$oid";
      $l="select lineid, wh, sku, vcode, quant, linetotal, status, unitpr from ocart where oid='$oid' ";
      $stl=$dbh->prepare($l);
      $stl->execute;
      $numl=$stl->rows;
      $allshipstatus="sp";

      $t = loadtemplate("row_order_showorder", $skeletonpath);
      $t =~ s/<!--.*-->//s;  

      $op = loadtemplate("row_option", $skeletonpath);   
      $op =~ s/<!--.*-->//s;
      $subtotal = 0;
      $totitem = 0;
      $linecounter=0;
      for (1..$numl) {
	  ($lineid, $wh, $sku, $vcode, $quant, $linetotal, $status, $unitpr)=$stl->fetchrow;
          $SO{'ACTIVITY'} ="";	 
	  $SO{'LID'} = $lineid;
          $SO{'ACTID'} = "ACT"."$lineid";
          $SO{'QTYID'} = "QTY"."$lineid"; 
          $linecounter ++; 
          $SO{'LINEID'} = "LINE".$linecounter;
          $SO{'SKU'} = "$sku $vcode";
          $SO{'WH'} = $wh;  
	  $SO{'QTY'} = $quant;
	  $SO{'LINETOTAL'} = $linetotal;
	  $SO{'PRICE'} = $unitpr;
	  $subtotal += $linetotal;
	  $totitem += $quant;

	  $s="select title from things where sku='$sku' ";
	  $sts=$dbh->prepare($s);
	  $sts->execute;
	  $nums=$sts->rows;
          ($title)=$sts->fetchrow;
	  $SO{'TITLE'} = $title;

	  $n="select shipvia from orders where oid='$oid' ";
	  $stn=$dbh->prepare($n);
	  $stn->execute;
	  $numn=$stn->rows;
	  ($shipsku)=$stn->fetchrow;

	  $s="select title from things where sku='$shipsku' ";
	  $sts=$dbh->prepare($s);
	  $sts->execute;
	  $nums=$sts->rows;
          ($shiptitle)=$sts->fetchrow;

          $sh="select dvalue from levents where dtable='ocart' and dvalue='$lineid\tShipped' ";
          $stsh=$dbh->prepare($sh);
          $stsh->execute;
          $numsh=$stsh->rows;
          ($shipstatus)=$stsh->fetchrow;

	  $OP{'VALUE'} = "";
	  $OP{'DVALUE'} = "$script_msg{22}";
	  $SO{'ACTIVITY'} = permutebit($op, \%OP);

          if (!$shipstatus) {
	     $OP{'VALUE'} = "Shipped";
             $OP{'DVALUE'} = "$script_msg{23}";  
	     $SO{'ACTIVITY'} .= permutebit($op, \%OP); 
             $OP{'VALUE'} = "Unship";
             $OP{'DVALUE'} = "$script_msg{24}";
             $SO{'ACTIVITY'} .= permutebit($op, \%OP);   
             $OP{'VALUE'} = "ToBeShipped";
             $OP{'DVALUE'} = "$script_msg{25}";
             $SO{'ACTIVITY'} .= permutebit($op, \%OP);
             $OP{'VALUE'} = "UpdateQTY";
             $OP{'DVALUE'} = "$script_msg{26}";
             $SO{'ACTIVITY'} .= permutebit($op, \%OP);
             $OP{'VALUE'} = "Remove";
             $OP{'DVALUE'} = "$script_msg{27}";

#	     $SO{'SHIPREF'} = "/cgi-bin/om/admin/order.cgi?mode=editship&orderid=$oid&lineid=$lineid&sid=$sid";
	     $SO{'SHIP'} = "Unshipped";
             $allshipstatus = "no";
          } else {
	     $OP{'VALUE'} = "Reship";
             $OP{'DVALUE'} = "$script_msg{28}"; 
	     $SO{'ACTIVITY'} .= permutebit($op, \%OP);
 	     $OP{'VALUE'} = "Return";
             $OP{'DVALUE'} = "$scrip_msg{29}"; 
#	     $SO{'SHIPREF'} = "/cgi-bin/om/admin/order.cgi?mode=showship&lineid=$lineid&orderid=$oid&sid=$sid";
	     $SO{'SHIP'} = "Shipped";
          }
          $NVP{'SHIPMETHOD'} = $shiptitle;
          $SO{'ACTIVITY'} .= permutebit($op, \%OP); 

	  $so = permutebit($t, \%SO); 
          $NVP{'tableinfo'}.= permuteclean($so);
       }

          $NVP{'LINECOUNT'} = $linecounter;
	  $NVP{'TOTITEM'} = $totitem;
	  $NVP{'SUBTOTAL'} = $subtotal;
          ($NVP{'SUBTOTAL'}, $temp) = split /\./, $NVP{'SUBTOTAL'};
	  $temp .= "00"; 
          $NVP{'SUBTOTAL'} .= "\.".substr( $temp, 0, 2);    

          if ($allshipstatus ne "sp") {
# 	     $NVP{'SHIPREF'} = "/cgi-bin/om/admin/order.cgi?mode=editship&orderid=$oid&sid=$sid";
	     $NVP{'SHIPMODE'} = "editship";
	     $NVP{'SHIPINFO'} = "$script_msg{30}";
          } else {
#	     $NVP{'SHIPREF'} = "/cgi-bin/om/admin/order.cgi?mode=showship&orderid=$oid&sid=$sid";
	     $NVP{'SHIPINFO'} = "$script_msg{31}";
	     $NVP{'SHIPMODE'} = "showship";
             $newdvalue="";
	   
             for ($i2=0; $i2 <= $#dvalue; $i2++) {
                if ($i2 != 0) {
                    $newdvalue.="\t";
                }
	        if ($i2 ==  2) {
                    $newdvalue.="sp";
                } else {
                    $newdvalue.="$dvalue[$i2]"; 		 
                }
             } 

             $l="UPDATE levents SET dvalue='$newdvalue' where dtable='orders' and dvalue='$dvalue' ";
             $stl=$dbh->prepare($l);
             $stl->execute;

	     $mydvalue="$oid\t$script_msg{32}";

             $l="select * from levents where dtable='orders' and dvalue='$mydvalue' ";
             $stl=$dbh->prepare($l);
             $stl->execute;
             $numl=$stl->rows;
             if ($numl < 1) {
	        $l="INSERT into levents (DTABLE, DVALUE, CDATE) values('orders','$mydvalue','$now') ";
	        $stl=$dbh->prepare($l);
	        $stl->execute;
             }
         }# end of if $allshipstatus

       $instr="select body from extraprop where objid='$oid' and fieldname='INSTRUCTIONS' ";
       $sti=$dbh->prepare($instr);
       $sti->execute;
       $numi=$sti->rows;
       if ($numi > 0) {
        	  ( $instructions)=$sti->fetchrow;
       };

       $o="select ccname, ccid, ccexpmo, ccexpyr, billto, shipto, ordtotal, shipcost, taxrate from orders where oid='$oid' ";
       $sto=$dbh->prepare($o);
       $sto->execute;
       $numo=$sto->rows;
       ($ccname, $ccid, $ccexpmo, $ccexpyr, $billto, $shipto, $ordtotal, $NVP{'SHIPCOST'}, $taxrate)=$sto->fetchrow;
       
       $s="select name, address1, address2, city, state, postcode from addresses where ADDRID='$billto' \n";
       $sts=$dbh->prepare($s);
       $sts->execute;
       $nums=$sts->rows;
       ($uname, $address1, $address2, $city, $state, $postcode)=$sts->fetchrow;
	$address1 .= "<br>".$address2 if ($address2);     
       if ($billto) {  
          $NVP{'BILLTO'} = "$uname <br> $address1 <br> $city, $state $postcode";
       }   
       $b="select name, address1, address2, city, state, postcode, dayphone from addresses where ADDRID='$shipto' \n";
       $stb=$dbh->prepare($b);
       $stb->execute;
       $numb=$stb->rows;
       ($uname, $address1, $address2, $city, $state, $postcode, $dayphone)=$stb->fetchrow;
       $address1 .= "<br>".$address2 if ($address2);

	$NVP{'PAYMENT'} = $ccname;
	$NVP{'CCID'} = $ccid;
	$NVP{'CCEXPIRE'} = "$ccexpmo/$ccexpyr";

	$NVP{'SHIPTO'} = "$uname <br> $address1 <br> $city, $state $postcode";

	$dayphone =~ s/-|\(|\)|\s*//g;
	$plen = length($dayphone);
	$NVP{'PHONE'} = substr($dayphone, -4);
	$NVP{'PHONE'} = substr($dayphone, -7, 3)."-".substr($dayphone, -4);
	if ($plen>7) { $NVP{'PHONE'} = substr($dayphone, 0, $plen-7)."-".$NVP{'PHONE'}; }

       $num--
   }

   $NVP{'ORDERTOTAL'} = $ordtotal."00";
   ($NVP{'ORDERTOTAL'}, $temp) = split /\./, $NVP{'ORDERTOTAL'};
   $temp .= "00"; 
   $NVP{'ORDERTOTAL'} .= "\.".substr( $temp, 0, 2);

   $NVP{'TOTALTAX'} = $NVP{'SUBTOTAL'} * $taxrate;
   ($NVP{'TOTALTAX'}, $temp) = split /\./, $NVP{'TOTALTAX'};
   $temp .= "00";
   $NVP{'TOTALTAX'} .= "\.".substr( $temp, 0, 2);

   $NVP{'DELIVER'} = "none";
   $NVP{'DELIVER'} = $instructions if ($instructions);

   if (!$FORM{'orderid'}) {
      $FORM{'orderid'} = $oid;
   }
   $pagetitle="$script_msg{33} $FORM{'orderid'} ";
   $NVP{'pagetitle'}=$pagetitle;
   $NVP{'orderid'}=$FORM{'orderid'};

} elsif ( $FORM{'mode'} eq "update") {
   $NVP{'pagetitle'}=$FORM{'pagetitle'};
   $NVP{'orderid'} = $FORM{'orderid'};
   $orderid = $FORM{'orderid'};    

   #display contect according to the input
   if ($FORM{'submit'} eq "Update") {
     #display the order again, like show order
     #need to implement
   
   } elsif ($FORM{'submit'} eq "Change Bill Address") {
      #display old addresses and new address input
      $l="select a.name, a.address1, a.city from orders, addresses as a where orders.oid='$orderid' and orders.uid=a.uid";
      $stl=$dbh->prepare($l);
      $stl->execute;
      $numm = $stl->rows;

      $N{'CHANGE'} = "$script_msg{34}";

      for (1..$numm) {
          ($name, $ad1, $ad2, $city) = $stl->fetchrow; 
	  $N{'ADDRESS'} .= "<input type=radio name=address>".$name."<br>".$ad1."<br>".$ad2."<br>".$city."<p>\n";
      }
      $N{'ADDRESS'} .= "<input type=radio name=address>New Address:<p>\n";
      $l = loadtemplate("row_order_changebill", $skeletonpath);
      $NVP{'CHANGE'} = permutebit($l, \%N);

   } elsif ($FORM{'submit'} eq "Change Shipping Address") {

     #display old addresses and new address input
      $l="select a.name, a.address1, a.city from orders, addresses as a where orders.oid='$orderid' and orders.uid=a.uid";
      $stl=$dbh->prepare($l);
      $stl->execute;
      $numm = $stl->rows;
 
      $N{'CHANGE'} = "$script_msg{35}";
 
      for (1..$numm) {
          ($name, $ad1, $ad2, $city) = $stl->fetchrow;
          $N{'ADDRESS'} .= "<input type=radio name=address>".$name."<br>".$ad1."<br>".$ad2."<br>".$city."<p>\n";
      }
      $N{'ADDRESS'} .= "<input type=radio name=address>$script_msg{36}<p>\n";
      $l = loadtemplate("row_order_changebill", $skeletonpath);   
      $NVP{'CHANGE'} = permutebit($l, \%N);

   } elsif ($FORM{'submit'} eq "Change Payment Method") {
      


   }


} elsif ( $FORM{'mode'} eq "editship") {
   $pagetitle="$script_msg{37} $FORM{'orderid'} \n";
   $NVP{'pagetitle'}=$pagetitle; 
   $NVP{'loadfrom'}="form";
   $NVP{'lineid'}=$FORM{'lineid'};
   $NVP{'orderid'}=$FORM{'orderid'};

} elsif ( $FORM{'mode'} eq "stats") {
   $NVP{'pagetitle'}= "$script_msg{38}";

} elsif ( $FORM{'mode'} eq "showstats") {
   $NVP{'pagetitle'}= "$script_msg{39}";
   #search display data in this section

   if ($FORM{'submit'} eq "Last 24 Hours") {
      $endtime = time();
      $starttime = $endtime - 24*3600;
   } elsif ($FORM{'submit'} eq "Last 7 Days") {
      $endtime = time();
      $starttime = $endtime - 7*24*3600; 
   } elsif ($FORM{'submit'} eq "Last 30 Days") {
      $endtime = time();
      $starttime = $endtime - 30*24*3600; 
   }

   $NVP{'FROMTIME'} = scalar localtime($starttime);
   $NVP{'TOTIME'} = scalar localtime($endtime);

   $l="select count(*), sum(o.ordtotal), sum(o.shipcost), sum(o.st_tax) from orders as o, ocart ";
   $l.="where o.oid=ocart.oid";
   $l .= " and o.cdate<'$endtime' and o.cdate>'$starttime' ";
   $stl=$dbh->prepare($l);
   $stl->execute;
   $NVP{'NUM'} = 0;
   $NVP{'TOTAL'} = 0;
   $NVP{'SHIP'} = 0;
   $NVP{'TAX'} = 0;
   ($NVP{'NUM'}, $NVP{'TOTAL'}, $NVP{'SHIP'}, $tax)=$stl->fetchrow;
   ($NVP{'TAX'}, $tax) = split /\./, $tax;
   $NVP{'TAX'} .= "." .substr($tax, 0, 2);

   $l="select sum(quant*unitpr), sum(quant) from ocart where cdate<'$endtime' and cdate>'$starttime' "; 
   $stl=$dbh->prepare($l);
   $stl->execute;
   $NVP{'ORDTOTAL'} =0;
   $NVP{'ITEM'} =0; 
   ($NVP{'ORDTOTAL'}, $NVP{'ITEM'}) = $stl->fetchrow;  

   $l="select LINEID, QUANTi, OID from ocart where cdate>'$starttime' ";
   $stl=$dbh->prepare($l);
   $stl->execute;
   $numm = $stl->rows;
   foreach (1..$numm) {
     $h=$stl->fetchrow_hashref;  
     $ITEM{$h->{'LINEID'}} = $h->{'QUANT'};
     $successoid{$h->{'OID'}} = 1;
   }

   $l="select dvalue from levents where dtable='ocart' and dvalue like '\%\tShipped' "; 
   $l .= "and cdate<'$endtime' and cdate>'$starttime' ";
   $stl=$dbh->prepare($l);
   $stl->execute;
   $numm = $stl->rows;
   $NVP{'SHIPPED'} =0;
   foreach (1..$numm) {
     ($dvalue) = $stl->fetchrow;
     ($lineid) = split /\t/, $dvalue;
     $NVP{'SHIPPED'} += $ITEM{$lineid};
   } 

   $l="select dvalue from levents where dtable='ocart' and dvalue like '\%\tReturned' ";
   $l .= "and cdate<'$endtime' and cdate>'$starttime' ";
   $stl=$dbh->prepare($l);
   $stl->execute;
   $numm = $stl->rows;
   $NVP{'RETURN'} = 0;
   foreach (1..$numm) {
     ($dvalue) = $stl->fetchrow;
     ($lineid) = split /\t/, $dvalue;
     $NVP{'RETURN'} += $ITEM{$lineid};   
   }

} elsif ( $FORM{'mode'} eq "showship") {

   if (!$FORM{'orderid'}) {
      $m="select oid from ocart where lineid='$FORM{'lineid'}' ";
      $stm=$dbh->prepare($m);
      $stm->execute;
      $nummm=$stm->rows;
      ($oid) = $stm->fetchrow;
      $FORM{'orderid'} = $oid;
   }

   $pagetitle="$script_msg{40} $FORM{'orderid'} ";
   $NVP{'pagetitle'}=$pagetitle."\n";

   if ($FORM{'lineid'} ne "") {
      $q="select fieldname, body from extraprop where objid='$FORM{'lineid'}' ";
      $stq=$dbh->prepare($q);
      $stq->execute;
      $numq=$stq->rows;

      $NVP{'info'}.="$script_msg{41} $FORM{'lineid'} <BR> <P> \n";
      for (1..$numq) {
         ($fieldname, $body)= $stq->fetchrow;
         $NVP{'info'}.="$fieldname = $body  <BR>\n";
      }
   } else {
      $q="select lineid from ocart where oid='$FORM{'orderid'}' ";
      $stq=$dbh->prepare($q);
      $stq->execute;
      $numq=$stq->rows;

      for (1..$numq) {
         ($lineid)=$stq->fetchrow;
         $m="select fieldname, body from extraprop where objid='$lineid' ";
         $stm=$dbh->prepare($m);
         $stm->execute;
         $numm=$stm->rows;    
         $NVP{'info'}.="$script_msg{41} $lineid <BR><P> \n";
	 for (1..$numm) {
	   
            ($fieldname,$body)=$stm->fetchrow;
            $NVP{'info'}.="$fieldname = $body <BR> \n";
         }	

	 $NVP{'info'}.="<BR><P> \n";
      }
      $NVP{'info'}.="<BR><P>";
   }
}


`$site->{'fsrootcron'}/generate_temps.pl $site->{'fsrelativeroot'}`;    # regenerate the temps

foreach ( keys %NVP ) {
   $NVP{$_} = string_tohtml( $NVP{$_} );
}


&writetonvp;

if ($NVP{'lastaction'}) {
   $targ="openmerchant-order-home";
   $FORM{'mode'}="home";
}
$l = loadtemplate($targ, $skeletonpath);
$l=permutebit($l, \%NVP);

if ($FORM{'mode'} eq "home") {
   $spine=loadtemplate("openmerchant-order-homespine",$skeletonpath);
   $l=~ s/<\!--#include virtual=\"openmerchant-order-homespine.html\"-->/$spine/gms;
} else {
   $l=~ s/<\!--#include virtual=\"openmerchant-order-spine.html\"-->/$spine/gms;
}

$l=~ s/__ORDERSTATUS_SELECT__/$NVP{'ORDERSTATUS_SELECT'}/gms;
$l=~ s/__WAREHOUSE_SELECT__/$NVP{'WAREHOUSE_SELECT'}/gms;
$l=~ s/__CALLSTATUS_SELECT__/$NVP{'CALLSTATUS_SELECT'}/gms;
$l=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG'}/gms;
$l=~ s/__script__/$scriptpath\/$script.cgi/gms;
$l=~ s/__sitename__/$site->{'sitename'}/gms;
$l=~ s/__sid__/$sid/gms;
$l=~ s/__mode__/$NVP{'mode'}/gms if $NVP{'mode'};
$l=~ s/__mode__/$FORM{'mode'}/gms;
$l = permuteclean($l);
print $l;

$dbh->disconnect if ( $dbh );

######################################################
## subroutines
##
######################################################

##### validatefields
#        takes all %FORM entries, seeks _inp entries, and 
#        performs field-by-field validation, with 
#        generation of _err error messages in %FORM as needed
#     returns 1 for OK, 0 for errors
#        - run after checkformbits
#        - does not need explicit fieldlist
#     Version 1 RF 981123
sub validatefields {
   # reads global %FORM
   my(@keys,$k,$e,$rv);
   $rv=1;                  # default OK, to 0 if error
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      next if ( $k !~ /_inp$/ );
      $kt = $k;
      $kt =~ s/_inp$// ;
      next if ( $kt =~ /[a-z]/ );   # fields are all uppercase
      $e=validatefield( $kt,$FORM{$k}, \%FORM );
      if ($e) {
         $rv=0;           # there was an error returned
         $kt.="_err";
         $FORM{$kt}=$e;   # emplace the error message 
      } # done checking for a returned error
   } # done running through form keys 
   return $rv;
} #/validatefields


##### checkformbits - checks population of _inp, does not touch
#        NVP hash
#
sub checkformbits {
   # goes through global %FORM
   #

   my($k,$kt,@keys);

   @keys = keys %FORM;

   while (@keys) {

      $k=shift @keys;
      next if ( $k =~ /_ini$/ );   # nothing to do with ini
      if ( $k =~ /_pre$/ ) {
         # check to see if the inp key exists
         # if it doesn't exist, then create and set to _pre
         $kt=$k;
         $kt =~ s/_pre$/_inp/ ;
         $FORM{$kt}=$FORM{$k} if ( ! exists($FORM{$kt}) );

      } # only really concerned with _pre/_inp pairs
   } # done with all keys

   return 1;
} #/checkformbits

##### writetonvp - write form data to NVP hash
sub writetonvp {
   # could rewrite to take a hashref
   my(@keys,$k,$kt);
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      $kt = $k;
      $kt =~ s/(_ini|_inp|_pre|_err)$// ;
      if ( $k =~ /_inp$/ ) {           # _inp -> _pre
         $kt.="_pre";
         $NVP{$kt}=$FORM{$k};
      } elsif ( $k =~ /_ini$/ ) {      # _ini -> _ini
         $NVP{$k}=$FORM{$k};
      } elsif ( $k =~ /_err$/ ) {      # _err -> _err
         $NVP{$k}=$FORM{$k};
      } elsif ( $k eq $kt ) {          # X -> X
         if (( $kt !~ /[a-z]/ ) and ( ! exists($NVP{$kt}) )) {
            # this looks like a fieldname and is not yet set
            $NVP{$kt}=$FORM{$kt} if ( $FORM{$kt} );
         }
      } # any other inheritance modes?
   } # done running through form keys
   ## special cases
   #
   $NVP{'skukind'}=$FORM{'SKUKIND_inp'} if (( ! $NVP{'skukind'} ) and ( $FORM{'SKUKIND_inp'} ));
   return 1; 
} #/writetonvp

##### LoadSkuFromDb
sub loadskufromdb {

   $q = 'SELECT * from ocart';
   $q.= " WHERE lineid='$FORM{'lineid'}' ";
   if (!$FORM{'lineid'}) {$q=" SELECT * from ocart WHERE oid='$FORM{'orderid'}' ";}

   $sth = $dbh->prepare( $q );
   $sth->execute;
   $num = $sth->rows;

   if ( $num==1 ) {
       # query returned exactly one record
      $h = $sth->fetchrow_hashref;
      foreach (keys %{$h} ) {
         $x = string_exdbi($h->{$_});
         $kt=$_."_inp";
         $FORM{$kt}=$x if ( ! exists($FORM{$kt}) );
      }
 
      $q ="SELECT OBJID, FIELDNAME, BODY from extraprop ";
      $q.=" WHERE OBJID LIKE '$h->{'LINEID'}' ";
      $sth = $dbh->prepare( $q );
      $sth->execute;
      $num = $sth->rows;
      while ($num) {
         ( $x,$i,$k ) = $sth->fetchrow;
         $k=string_exdbi($k);
         $kt=$i."_inp";        
         $FORM{$kt}=string_tohtml($k) if ( ! $FORM{$kt} );
         $num--;
      }

   } else {
      # there was an error!
      # send back to homepage with error message
      $FORM{'mode'}="home";
   }
   $sth->finish;
   return 1;
}
# /loadskufromdb

sub writeskutodb {
  
   my($rv);

   $rv="";

   $lineid=$FORM{'lineid'};
   $numo=1;

   $o="select lineid, wh from ocart where oid='$FORM{'orderid'}' ";
   $sto=$dbh->prepare($o);
   $sto->execute;
   $numo=$sto->rows;

   if ($lineid) {
      $numo=1; $flag="yes";
   }

   $d = " select dvalue from levents where dtable='orders' and dvalue LIKE '$FORM{'orderid'}\t\%' and dvalue LIKE '\%\tsuccess\%' ";

   $std=$dbh->prepare($d);
   $std->execute;
   $numd=$std->rows;

   ($dvalue)=$std->fetchrow;

   {
      for (1..$numo) {
 
         if ($flag ne "yes") {
            ($lineid, $sidwh) = $sto->fetchrow;
         } 
 
         $q="UPDATE ocart SET status='$FORM{'ORDERSTATUS_inp'}' where lineid='$lineid' ";
         $stq=$dbh->prepare($q);
         $stq->execute;
 
         if ($FORM{'ORDERSTATUS_inp'} eq "sp") {
            $q="INSERT into levents (DTABLE, DVALUE, CDATE) values ('ocart', '$lineid\tShipped', '$now') ";
            $stq=$dbh->prepare($q);
            $stq->execute;
         }

         $FORM{'SHIPPER_inp'} =~ s/'/''/g;
         $FORM{'COMMENTS_inp'} =~ s/'/''/g;
         $FORM{'SHIPPER_inp'} =~ s/\\/\\\\/g;
         $FORM{'COMMENTS_inp'} =~ s/\\/\\\\/g;
         $q1="INSERT into extraprop (objid, objkind, fieldname, body) values ('$lineid', 'lineid', 'SDATE', '$FORM{'SDATE_inp'}') ";
         $q2="INSERT into extraprop (objid, objkind, fieldname, body) values ('$lineid', 'lineid', 'SHIPPER', '$FORM{'SHIPPER_inp'}') ";
         $q3="INSERT into extraprop (objid, objkind, fieldname, body) values ('$lineid', 'lineid', 'COMMENTS', '$FORM{'COMMENTS_inp'}') "; 

         $stq1=$dbh->prepare($q1);
         $stq1->execute;
         $stq2=$dbh->prepare($q2);
         $stq2->execute;
         $stq3=$dbh->prepare($q3);
         $stq3->execute;
	 }
 
      $q="select status from ocart where oid='$FORM{'orderid'}' ";
      $stq=$dbh->prepare($q);
      $stq->execute;
      $status="sp";
      $numq=$stq->rows;
      for (1..$numq) {
         ($status1) = $stq->fetchrow;
         if ($status1 ne "sp") {
            $status="no";
         }
      }
   
      @dvalue=split /\t/, $dvalue;
      $callstatus=$dvalue[3];
      $newdvalue="";
      $sidwh=$dvalue[1];

      for ($i2=0; $i2 <= $#dvalue; $i2++) { 
         if ($i2 != 0) {$newdvalue.="\t";
      }

      if ($i2==2) {
         $newdvalue.="$status";
      } else {
         $newdvalue.="$dvalue[$i2]";}
      }    

      $l="UPDATE levents SET dvalue='$newdvalue' where dtable='orders' and dvalue='$dvalue' ";
      $stl=$dbh->prepare($l);
      $stl->execute;

      if ($status eq "sp") {
         $mydvalue="$FORM{'orderid'}\t$script_msg{42}";
         $q="INSERT into levents (DTABLE, DVALUE, CDATE) values('orders','$mydvalue', '$now' ) ";
         $stq=$dbh->prepare($q);
         $stq->execute;
      }
   }
  
   return $rv;
} #/writeskutodb

sub message {
   # check the language that is being used and open appropriate
   # message language file or get messages below
   if ($om_render_lang eq "eng" ) {
      $script_msg{1}="evaluates as";
      $script_msg{2}="Date was entered invalid";
      $script_msg{3}="Date entered invalid, please don't try any impractical date.";
      $script_msg{4}="Ending date should be later than starting date.";
      $script_msg{5}="Starting date can not be now or later.";
      $script_msg{6}="Please enter both dates!";
      $script_msg{7}="Date format invalid!";
      $script_msg{8}="('Jan'=>0,'Feb'=>1,'Mar'=>2,'Apr'=>3,'May'=>4,'Jun'=>5,'Jul'=>6,'Aug'=>7,'Sep'=>
8,'Oct'=>9,'Nov'=>10,'Dec'=>11 )";
      $script_msg{9}="Today's hour and min data invalid!";
      $script_msg{10}="Date was entered invalid";
      $script_msg{11}="Date entered invalid, please don't try any impractical date.";
      $script_msg{12}="Ending date should be later than starting date.";
      $script_msg{13}="Starting date can not be now or later.";
      $script_msg{14}="You must specify at least one of the following items for search";
      $script_msg{15}="You should specify both of the dates for search";
      $script_msg{16}="Date must be of the form mm/dd/yyyy";
      $script_msg{17}="Sorry, nothing found! Please try another search.";
      $script_msg{18}="Submitted changes to order";
      $script_msg{19}="Searchlist";
      $script_msg{20}="Shipped";
      $script_msg{21}="UnShipped";
      $script_msg{22}="Not Specified";
      $script_msg{23}="Shipped";
      $script_msg{24}="Unship";
      $script_msg{25}="ToBeShipped";
      $script_msg{26}="Update QTY";
      $script_msg{27}="Remove";
      $script_msg{28}="Reship";
      $script_msg{29}="Return";
      $script_msg{30}="Ship Entire Order";
      $script_msg{31}="See Ship Info";
      $script_msg{32}="Shipped";
      $script_msg{33}="Order ID:";
      $script_msg{34}="Change Bill Address";
      $script_msg{35}="Change Shipping Address";
      $script_msg{36}="Address:";
      $script_msg{37}="Shipping Order Number:";
      $script_msg{38}="Order Statistics";
      $script_msg{39}="Show Order Statistics";
      $script_msg{40}="Shipping Information for Order Number";
      $script_msg{41}="This Line id was shipped:";
      $script_msg{42}="Shipped";
   } else {
      open( EM, "<$relpath/bits/$om_render_lang/system/$script.messages");
      while(<EM>) {
         chomp;
         next if /^\#/;
         next if (! $_);
         @temp=split /\t/;
         $script_msg{$temp[0]}=$temp[1];
      }
      close(EM);
   }

   if ( $verbose_errors ) {
      if ($om_render_lang eq "eng" ) {
         $script_msg{1}="looking for";
      } else {
         open( EM, "<$relpath/bits/$om_render_lang/system/$script.errors");
         while(<EM>) {
            chomp;
            next if /^\#/;
            next if (! $_);
            @temp=split /\t/;
            $script_msg{$temp[0]}=$temp[1];
         }
         close(EM);
      }
   }

}

1;

1;
