#!/usr/bin/perl 
############################################################################
#    Copyright (C) 1999-2000 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#
#statsman.cgi
#
#Administration on stats report
#
# Version 0.9,3 IB 20000531
#    added custom-lib.pm
# Version 0.9.2 GF 20000524
#    changed targ
# Version 0.9.1 IB 20000502
#    introduced $script variable
# Version 0.7.15 JC 20000411
#    $om_render_lang update
# Version 0.7.14 JC 20000410
#    multilingual messages
# Version 0.7.13 IB 20000402
#    new directory structure
# Version 0.7.12 JC 20000330
#    changed connect statement
# Version 0.7.11 JC 20000329
#    changed DBI prepare/connect
# Version 0.7.10 IB 20000327
#    corrected $relpath
# Version 0.7.9 IB 20000324
#    changed the way site.pm is obtained (multiple stores)
# Version 0.7.8 IB 20000302
#    updated copyright
# Version 0.7.7 IB 20000228
#    changed store to site
# Version 0.7.6 JZ 20000216
#    show all stats files
# Version 0.7.5 JZ 20000214
#    use templates for snapshot  
# Version 0.7.4 JZ 20000211
#    corrected dir files lookup and run_stats argument
# Version 0.7.3 JZ 20000204
#    change to dynamic stats output
# Version 0.7.2 JZ 20000202
#    add snapshot view
# Version 0.7.1 JZ 20000126
#    creation

## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om/admin,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$siteshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $siteshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $siteshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

$relpath .= "/../$siteshortname";

use DBI;
require "$relpath/lib/conversions.pm";
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/login.pm";
require "$relpath/conf/site.pm";
require "$relpath/lib/validate.pm";
require "$relpath/lib/custom-lib.pm";

## establish site-specific parameters
#
$site=setsite();

## get the CGI bits
#
%FORM=();
&ReadParse;

$sid=$FORM{'sid'};

$om_render_lang=$FORM{'OM_UI_LANGUAGE'};
$om_render_lang=$site->{'om_locale_lang_def'} if ( !$om_render_lang);
$om_render_lang="eng" if ( !$om_render_lang );

## load messages
%script_msg=();          # user interaction messages
$script=( split /\./, $scriptname )[0];
&message; 

## done with pull-from-file bits, rest of global settings...
#
$x= (split /\?/, $ENV{'REQUEST_URI'})[0];   # strip get stuff
@temp=split /\//, $x;

@temp=("cgi-bin","test","statsman.cgi") if (! $ENV{'REQUEST_URI'} );

$script=( split /\./, $scriptname )[0];
$n= $#temp - 1;
$scriptpath = join "/", ( @temp[0..$n] );

$skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin";
$selskeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/html/sel";

## filled in with time/context variable info
$nicedt=nicedatetime();

$now=time();

## construct some shorthands
$script_html = join "-", ("os_allcommerce",$script,"");

## establish connection in
#
$s = "$site->{'db_site_config'}";
$dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

## start the replacements hash
#
%NVP=();
$NVP{'sitename'}=$site->{'sitename'};

$FORM{'sid_ok'} = check_login($script,$FORM{'mode'},$FORM{'sid'});

if ( $FORM{'sid_ok'} ) {
   if ( $FORM{'sid_ok'} =~ /^ERROR/ ) {
      ## hard error, redirected to login page
      exit 0 ; 
   } elsif ( $FORM{'sid_ok'} =~ /^Error/ ) {
      ## soft error, send to default mode
      $FORM{'mode'}="home";
      $NVP{'__PAGE_ERROR_MSG__'}=$FORM{'sid_ok'};
   } else {
      ## welcome to the page...
   }   
   print "Content-type: text/html\n\n";
} else {
   ## unknown why sid_ok not populated with some string...
   #
   print "Content-type: text/html\n\n";
   print "<HTML><HEAD></HEAD><BODY>\n";
   print "$FORM{'sid'} sid $script_msg{1} $FORM{'sid_ok'} \n";
   exit 0;
}

$NVP{'sid'}=$FORM{'sid'};
$NVP{'lastmode'}=$FORM{'mode'};
$NVP{'script'}="$scriptpath/$scriptname";
$NVP{'datetime'}=$nicedt;
$NVP{'scriptpath'}=$scriptpath;

$crondir = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/stats/cron";
opendir (DIR, $crondir);
@statsfiles = readdir(DIR);
close (DIR);
shift @statsfiles;
shift @statsfiles;   

#create stats file

if ($FORM{'mode'} eq 'home') { #home, need to create stats snapshot
	$q = 'select c.uname from contacts c, sessions s';
	$q .= " where c\.uid=s\.uid and s\.sid = $sid;";
	$sth = $dbh->prepare($q);
	$sth->execute;
	$statsuser = $sth->fetchrow;

	$statsuser = 'Opensales' if (!$statsuser);
	#special characters is assumed not allowd in uname in database
	$statsuser =~ s/"/\\"/g;
	$statsuser =~ s/`/\\`/g;
	$statsuser =~ s/\$/\\\$/g;

	$statsdata = `$site->{'fsrootcron'}/run_stats.pl "$statsuser" $now`;

	#get the snapshot view data
	@snap = split /\&/, $statsdata;
	$NVP{'FROMTIME'} = shift @snap;
	$NVP{'TOTIME'} = shift @snap;
	$NVP{'STATSUSER'} =  shift @snap;
	$NVP{'TOT_PAGE'} =  shift @snap;
	$NVP{'TOT_VISITOR'} =  shift @snap;
	$NVP{'TOT_ORDER'} =  shift @snap;
	$NVP{'ORDER_TOTAL'} =  shift @snap;
	$NVP{'TOPITEMS'} =  shift @snap;
	$NVP{'FILEDATE'} =  shift @snap;

} elsif ($FORM{'detail'}) { #mode is display, check if display detailed realtime stats
	open(D, "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/stats/include/$FORM{'detail'}");
	while (<D>) { $statsdata .= $_; }
	close(D);
} else { 
	# find the file and display
	$filename = $FORM{'statsfile'};

	$statsdata ="";
	foreach $f (@statsfiles) {
		if ( $f eq $filename ) {
			open(DF, "<$crondir/$f");
			while (<DF>) { $statsdata .= $_; }
			close (DF);		
			last;
		}
	}
	
	if (!$statsdata) { 
		$NVP{'PAGE_ERROR_MSG'} = "$script_msg{2}";
		$FORM{'mode'} = 'home';
		$NVP{'FROMTIME'} = $FORM{'FROMTIME'};
		$NVP{'TOTIME'} = $FORM{'TOTIME'}; 
		$NVP{'STATSUSER'} = $FORM{'STATSUSER'} ;
		$NVP{'TOT_PAGE'} = $FORM{'TOT_PAGE'} ;
	        $NVP{'TOT_VISITOR'} =  $FORM{'TOT_VISITOR'} ;
        	$NVP{'TOT_ORDER'} = $FORM{'TOT_ORDER'} ;
        	$NVP{'ORDER_TOTAL'} = $FORM{'ORDER_TOTAL'}; 
       	 	$NVP{'TOPITEMS'} = $FORM{'TOPITEMS'} ;
        	$NVP{'FILEDATE'} =$FORM{'FILEDATE'} ;
	}
}

$t = loadtemplate("row_option", $skeletonpath);
$t =~ s/<!--.*-->\n//s;
@mh=$script_msg{3};
foreach $f (sort @statsfiles) {
	next if $f !~ /\d+\.html$/;
	$y = substr($f, 0, 4);
	$m = $mh[substr($f, 4, 2)-1];
	$d = substr($f, 6, 2);
	$ST{'VALUE'} = $f;
	$ST{'DVALUE'} = "$m  $d  $y";
	$select .= permutebit($t, \%ST);
}

$targ="os_allcommerce-".$script."-".$FORM{'mode'};
if ($NVP{'lastaction'}) {
	$targ="os_allcommerce-statsman-home";
	$FORM{'mode'}="home";
}

$l = loadtemplate($targ, $skeletonpath);
$l=permutebit($l, \%NVP);
$spine=loadtemplate("openmerchant-statsman-homespine",$skeletonpath);
$l=~ s/<\!--#include virtual=\"openmerchant-statsman-homespine.html\"-->/$spine/gms;

$l=~ s/__selectstats__/$select/;
$l =~ s/__statsdata__/$statsdata/;
$l = permuteclean($l);

print $l;

$dbh->disconnect if ( $dbh );

sub message {
   # check the language that is being used and open appropriate
   # message language file or get messages below
   if ($om_render_lang eq "eng" ) {
      $script_msg{1}="evaluates as";
      $script_msg{2}="Sorry, The Stats you specified is not available, please try another date";
      $script_msg{3}="('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'D
ec')";  
   } else {
      open( EM, "<$relpath/bits/$om_render_lang/system/$script.messages");
      while(<EM>) {
         chomp;
         next if /^\#/;
         next if (! $_);
         @temp=split /\t/;
         $script_msg{$temp[0]}=$temp[1];
      }
      close(EM);
   }
} 

1;
