#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#
# cust_serv.cgi
#
# Program to administer thesaurus
#
# Version 0.9.3 IB 20000608
#    language and interface from table 'sessions'
# Version 0.9.3 IB 20000531
#    added custom-lib.pm
# Version 0.9.2 IB 20000502
#    corrected the sequence of statements
# Version 0.9.1 IB 20000425
#    introduced $script variable
# Version 0.7.15 JC 20000411
#    updated $om_render_lang
# Version 0.7.14 JC 20000410
#    multilingual messages
# Version 0.7.13 IB 20000402
#    new directory structure
# Version 0.7.12 JC 20000330
#    changed connect statement
# Version 0.7.11 JC 20000329
#    changed DBI prepare/connect
# Version 0.7.10 IB 20000327
#    corrected $relpath
# Version 0.7.9 IB 20000324
#    changed the way site.pm is obtained (multiple stores)
# Version 0.7.8 IB 20000302
#    updated copyright and removed -w
# Version 0.7.7 IB 20000228
#    changed store to site
# Version 0.7.5 IB 991126
#    fixing of comment statement
# Version 0.7.4 IB 991109
#    new header
# Version 0.7.3 IB 991109
#    removing of HACKS, and correcting of relpath
# Version 0.7.2 IB 991104
#    general cleanup
#
## setup localization information
#
$started=(times)[0];

## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om/admin,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$siteshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $siteshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $siteshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

$relpath .= "/../$siteshortname";

use DBI;
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/conversions.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/login.pm";
require "$relpath/lib/validate.pm";
require "$relpath/conf/site.pm";

# must be the last require statement
require "$relpath/lib/custom-lib.pm";

## establish site-specific parameters
#
$site=setsite();

## Get FORM data
#

%FORM=();
&ReadParse;

$q="$site->{'db_site_config'}";
$dbh=DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});
 
$om_render_lang = "";
$interface = "";

if ($FORM{'sid'}) {
   $q="SELECT language,interface from sessions where sid=$FORM{'sid'} ";
   $sts = $dbh->prepare( $q );
   $sts->execute;
   $h=$sts->fetchrow_hashref;
   $om_render_language=$h->{'language'};
   $interface=$h->{'interface'};
}

$om_render_lang=$site->{'om_locale_lang_def'} if ( ! $om_render_lang );
$om_render_lang="eng" if ( ! $om_render_lang );
$interface="html" if ( ! $interface );

## load messages 
%script_msg=(); 	# user interaction messages
$script=( split /\./, $scriptname )[0];
&message;

$skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin";
$target=$site->{'siteshortname'}."-people";

print "Content-type: text/html\n\n";

$h->{'package'}="";
$h->{'button'}="";
if ($FORM{'mode'} eq "home") {
   $template=$target."-home";
}
if (($FORM{'mode'} eq "delete")|| $FORM{'orderid'}) {	
   if ($FORM{'orderid'}) { 
      $submit="Cancel this order";
      &lookuporder($FORM{'orderid'}, $submit); 
   } 
   $template=$target."-cancelord";
   $h->{'orderid'} = $FORM{'orderid'};
   $h->{'script'} = "cust_serv.cgi";
   $h->{'mode'}="cancelord";
}

if (($FORM{'mode'} eq "changeord") || $FORM{'changeordid'}) {
   if ($FORM{'changeordid'}) { 
      $submit="Change Order";
      &lookuporder($FORM{'changeordid'}, $submit); 
   } 
   $template=$target."-changeord";
   $h->{'changeordid'} = $FORM{'changeordid'};
   $h->{'script'} = "cust_serv.cgi";
   $h->{'mode'}="changeord";
}
if (($FORM{'mode'} eq "changeaddr") || ($FORM{'lastname'}) || ($FORM{'firstname'})) {
   if (($FORM{'lastname'}) || ($FORM{'firstname'})) { 
      $submit="Enter Changes";
      &lookupaddr($FORM{'lastname'}, $FORM{'firstname'}, $submit); 
   } 
   if ($FORM{'change'} eq "yes") {
      $submit="Enter Changes";
      @name=split / /, $FORM{'fullname'};
      &lookupaddr($FORM{'firstname'}, $FORM{'lastname'}, $submit);
      $h->{'package'}=$h->{'input'};
   }
   $template=$target."-changeaddr";
   $h->{'lastname'} = $FORM{'lastname'};
   $h->{'firstname'}=$FORM{'firstname'};
   $h->{'script'} = "cust_serv.cgi";
   $h->{'mode'}="changeaddr";
}
if (($FORM{'mode'} eq "history") || ($FORM{'userid'})) {
   if ($FORM{'userid'}) {
      $userid=$FORM{'userid'};
   }
    
   $userid=$FORM{'userid'};
   $h->{'package'}=$package;
   $template=$target."-history";
   $h->{'mode'}="history";
}
if (($FORM{'mode'} eq "passwd") || ($FORM{'username'})) {
   if ($FORM{'username'}) {
      $username=$FORM{'username'};
      $w="SELECT UID from addresses where NAME LIKE '\%$username\%' ";
      $sth3=$dbh->prepare($w);
      $sth3->execute;
      $num3=$sth3->rows;
      for (1..$num3) { 
         ($uid) = $sth3->fetchrow; 
         $q="SELECT PASSWD from contacts where UID='$uid' ";
         $sth=$dbh->prepare($q);
         $sth->execute;
         $num=$sth->rows;
         for (1..$num) { 
            ($passwd) = $sth->fetchrow;
         }
          $package.=" <tr><td>$script_msg{1} $FORM{'username'}<br>UID: $uid<br> script_msg{2} $passwd <BR> <BR> </td></tr>";
      }    
   }
   $h->{'package'}=$package;
   $template=$target."-passwd";
   $h->{'username'} = $FORM{'username'};
   $h->{'script'}="cust_serv.cgi";
   $h->{'mode'}="passwd";
}

$spine=loadtemplate("openmerchant-cust_serv-spine",$skeletonpath);
$pagetemplate=loadtemplate($template, $skeletonpath);
$t=permutebit($pagetemplate, $h);

$t=~ s/<\!--#include virtual=\"openmerchant-cust_serv-spine.html\"-->/$spine/gms;
$color= "<font color=#ff0000>";
$new=$FORM{'mode'};
$t=~ s/__sitename__/$site->{'sitename'}/gms;
$t=~ s/<A HREF=\"\/cgi-bin\/admin\/cust_serv.cgi\?mode=$new&sid=__sid__\">/$color/gms;
$t=~ s/__sid__/$FORM{'sid'}/gms;

print $t;
print "\n";


##############################
sub lookupaddr {
    
   $last=$_[0];
   $first=$_[1];
   $submit=$_[2];

   $fullname=$first." ".$last;
   $h->{'fullname'}=$fullname;
   $w="SELECT NAME, ADDRESS1, ADDRESS2, CITY, STATE, POSTCODE from addresses where NAME LIKE '\%$fullname\%' ";
   $sth3=$dbh->prepare($w);
   $sth3->execute;
   $num3=$sth3->rows;
   for (1..$num3) {
      ($name, $addr1, $addr2, $city, $state, $zip) = $sth3->fetchrow;
      $package.=" <tr><td><A HREF='/cgi-bin/om/admin/cust_serv.cgi?mode=changeaddr&change=yes&name=$name'> $name</A> <br>$addr1<br>$city, $state $zip<br></td></tr> ";
      $h->{'zip'}=$zip;
      $h->{'state'}=$state;
      $h->{'addr'}=$addr1;
      $h->{'city'}=$city;
      $input.="NAME: <input type='text' name='fullname' value='__fullname__'> <br> \n";
      $input.="ADDRESS: <input type='text' name='addr' value='__addr__'> <br> \n";
      $input.="CITY: <input type='text' name='city' value='__city__'><br>\n";
      $input.="STATE: <input type='text' name='state' value=$state> <br> \n";
      $input.="ZIP: <input type='text' name='zip' value='__zip__'><br> \n";
   }
   $h->{'prevname'}=$fullname;

   ($name, $addr1, $addr2, $city, $state, $zip) = $sth3->fetchrow;
   $h->{'package'}= $package;
   return 1;
}

###########################
sub lookuporder {
    
   $orderid=$_[0];
    
   $totalcharge=0;
   $q=" SELECT SHIPTO, BILLTO, SHIPCOST, SHIPVIA, ST_TAX from orders where orderid='$orderid' ";
   $sth=$dbh->prepare($q);
   $sth->execute;
   $num=$sth->rows;
   for (1..$num) {
      ($shipto, $billto, $shipcost, $shipvia, $tax) = $sth->fetchrow;
   }
   $v =" SELECT SKU, LINETOTAL, QUANT, UNITPR from ocart where orderid='$orderid' ";
   $sth2=$dbh->prepare($v);
   $sth2->execute;
   $num2=$sth2->rows;
   $package.= "<TR><TD>SKU</TD><TD>script_msg{3}</TD><TD>script_msg{4}</TD><TD>script_msg{5}</TD><TD> script_msg{6}</TD><TD> script_msg{7} </TD></TR> ";
   for (1..$num2) {
      ($sku, $subtotal, $qty, $price) = $sth2->fetchrow;
      $y = "SELECT TITLE from products where SKU='$sku' ";
      $sthY=$dbh->prepare($y);
      $sthY->execute;
      $numY=$sthY->rows;
      ($title) = $sthY->fetchrow;
      if ($sku) {
         $row.="<TR><TD>$sku</TD><TD>$title</TD><TD>$price</TD><TD>$qty</TD><TD>$tax</TD><TD>$subtotal</TD></TR> ";
      }
      if ($subtotal) {
         $totalcharge=$totalcharge+$tax+$subtotal; 
      }
   }
   $tot=$totalcharge+$shipcost;
   $w="SELECT NAME, ADDRESS1, ADDRESS2, CITY, STATE, POSTCODE from addresses where ADDRID='$shipto' ";
   $sth3=$dbh->prepare($w);
   $sth3->execute;
   $num3=$sth3->rows;
   for (1..$num3) {
      ($name, $addr1, $addr2, $city, $state, $zip) = $sth3->fetchrow;
   }

   $w="SELECT NAME, ADDRESS1, ADDRESS2, CITY, STATE, POSTCODE from addresses where ADDRID='$billto' ";
   $sth3=$dbh->prepare($w);
   $sth3->execute;
   $num3=$sth3->rows;
   for (1..$num3) {
      ($name, $addr1, $addr2, $city, $state, $zip) = $sth3->fetchrow;
   }
   $package.=" $row";
   $package.="<TR><td colspan=5 align=right>script_msg{8}</td><td>$shipcost&nbsp;</td></TR>";    $package.="<TR><td colspan=5 align=right>script_msg{9} </td> ";
   $package.="<td>$tot</td></tr>";
   $button = "<p> <center><input type=submit name=submit value=$submit>";
   $h->{'package'} = $package;
   $h->{'orderid'}=$orderid;
   $h->{'button'}=$button;
   return 1;
}

sub message {
   # check the language that is being used and open appropriate
   # message language file or get messages below
   if ($om_render_lang eq "eng" ) {
      $script_msg{1}="NAME:";
      $script_msg{2}="PASSWORD:";
      $script_msg{3}="PRODUCT";
      $script_msg{4}="PRICE";
      $script_msg{5}="Qty";
      $script_msg{6}="Tax";
      $script_msg{7}="Subtotal";
      $script_msg{2}="Shipping";
      $script_msg{2}="total amt to be charged"; 
   } else {
      open( EM, "<$relpath/bits/$om_render_lang/system/$script.messages");
      while(<EM>) {
         chomp;
         next if /^\#/;
         next if (! $_);
         @temp=split /\t/;
         $script_msg{$temp[0]}=$temp[1];
      }
      close(EM);
   }
} 

1;
