#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

####
# cart.cgi
#    shopping cart script
#    RF 981203
#
####

####
#
# Version 0.8.53 GF 20000524
#   objtype to objclass
# Version 0.8.52 GF 20000521
#    added logic for variants/master
# Version 0.8.47 GF 20000516
#    variants squashed into things   
# Version 0.8.46 GF 20000508
#    error messages
# Version 0.8.41 GF 20000504
#    takes an objid    
# Version 0.8.40 GF 20000504
#    sku -> objid   
#    lowercase field names
#    u_email to custid
# Version 0.8.36 JC 20000417
#    changed loadtemplate to localize_template
# Version 0.8.35 IB 20000417
#    fixed messages
# Version 0.8.34 GF 20000413
#    fixed sku, var translations 
#    changed UID to U_EMAIL
#       TBD - hardcode xpr for promotions
#           - translation of sku, vsku and vcode 
# Version 0.8.33 IB 20000411
#    default to language in site.pm
# Version 0.8.32 IB 20000410
#    corrected a comment
# Version 0.8.31 IB 20000409
#    language
# Version 0.8.30 IB 20000405
#    language fix
#    corrected a typo
# Version 0.8.29 IB 20000404
#    new directory structure
# Version 0.8.28 IB 20000402
#    new directory structure
# Version 0.8.27 IB 20000331
#    cell templates renaming
# Version 0.8.26 IB 20000330
#    changed connect statement
# Version 0.8.25 JC 20000329
#    changed DBI prepare/connect
# Version 0.8.24 IB 20000327
#    corrected $relpath
# Version 0.8.23 IB 20000324
#    changed the way site.pm is obtained (multiple stores)
# Version 0.8.22 JC 20000322
#    put colon in at ssl_prefix
# Version 0.8.21 IB 20000317
#    renaming of templates
# Version 0.8.20 IB 20000313
#    corrected an operator
# Version 0.8.19 IB 20000302
#    updated copyright information and removed -w
# Version 0.8.18 IB 20000226
#    changed store to site
# Version 0.8.17 GF 20000202
#    added in no_item message when cart is empty
# Version 0.8.16 IB 20000128
#    fixed storeurl
# Version 0.8.15 JN 20000127
#    fixed addrid bug
# Version 0.8.14 JN 20000124
#    added wishlist and registry.cgi
# Version 0.8.13 JN 20000117
#    changed http to store.pm ref when accessing checkout
# Version 0.8.12 JN 20000103
#    fixed the price display when adding more items to an existing item
#    in the cart
# Version 0.8.11 IB 991217
#    reversed the order of two instructions in order to avoid messages
#    on the screen
# Version 0.8.10 IB 991203
#    added track.cgi
# Version 0.8.8 IB/GF 991202
#    added bits/site to bits
#    added in loadtemplate for footer element
#    removed bottom_nav loadtemplate element
# Version 0.8.7 JN 991202
#    variant support fixed
# Version 0.8.6 IB 991126
#    corrected bits/pages to bits/site/pages
# Version 0.8.4 IB 991111
#    corrected the determining of a relpath
#    removed foreach
#    corrected $scriptname
# Version 0.8.3 IB 991111
#    corrected DBI statement position, eliminated store_env
# Version 0.8.2 IB 991109
#    removing of HACKS, and correcting of relpath
# Version 0.8.1 IB 991102
#    general cleanup
# Version 0.7.6 SH 990903
#    specify active prices
# Version 0.7.1 GF 990829
#    Made work with variants
#    Accepts a VCODE and then translates sku and vcode
# Version 1 - 981204
#
####

## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$siteshortname="";

## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $siteshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $siteshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

$relpath .= "/../$siteshortname";

use DBI;
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/conf/site.pm";
require "$relpath/lib/state.pm";
require "$relpath/lib/localization.pm";

## establish site-specific parameters
#
$site=setsite();

## get the CGI bits
#
%FORM=();
&ReadParse;

$om_render_lang=$FORM{'OM_UI_LANGUAGE'};
$om_render_lang=$site->{'om_locale_lang_def'} if ( ! $om_render_lang );
$om_render_lang="eng" if ( ! $om_render_lang );

## load messages
%script_msg=();          # user interaction messages
&message;

## check for a session id
#
&setsessionid();    # either a sid > 0 or 0

## start the response header
#
print "Content-type: text/html\n\n";

## deal with form elements that may need defaults
#
# destination upon successful login

if ( exists($FORM{'pg_targ'}) ) {       # target page element exists
                                        # user is coming from with script
                                        # don't need to do anything

} elsif ( $ENV{'HTTP_REFERER'} ) {      # no target page exists
                                        # do they have a environment referer  

   ## check that refered from inside site
   #
   if (( $ENV{'HTTP_REFERER'} =~
      /($site->{'sitedomain'}|$site->{'sitessldomain'})/ ) and
      ( $ENV{'HTTP_REFERER'} !~ /$scriptname/ )) {
      $FORM{'pg_targ'}=$ENV{'HTTP_REFERER'};

   } else {
                                         # referer is outside site or this 
                                         # script, default to home page
     
      $FORM{'pg_targ'}="http://$site->{'siteurl'}/html/$om_render_lang/home.shtml";
   } #/done looking at plausibility of using the referer as page target

} else {                                         # default target to home page
   $FORM{'pg_targ'}="http://$site->{'siteurl'}/html/$om_render_lang/home.shtml";
} #/done checking over page to use on outbound

## fork env and track user 
#
`$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/cgi-bin/om/track.cgi`;

## establish connection to database  
#
$q = "$site->{'db_site_config'}"; 
$dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

## determine identity of next page in checkout sequence
#
$q="SELECT sid,custid,mdate from sessions where sid=$FORM{'sid'} ";
$sts = $dbh->prepare( $q );
$sts->execute;
$num=$sts->rows;

if ( $num==1 ) {
      ( $a,$b,$c ) = $sts->fetchrow;

   if ( length($b)>2 ) { # event - series 

      # user logged in
      $q="$site->{'ssl_prefix'}://$site->{'sitesslurl'}/cgi-bin/om/ssl/";
      $q.="checkout.cgi?sid=$FORM{'sid'}";
      $FORM{'nextcheckoutpg'}=$q;

      ## wishlist sequence 
      #
      $FORM{'wishlist_en'}=1;
      $FORM{'wishlist_button'}=$wishlisturl;
      $uid=$b;

   } else {

      # user not logged in
      $q="$site->{'ssl_prefix'}://$site->{'sitesslurl'}/cgi-bin/om/ssl/";
      $q.="checkout.cgi?sid=$FORM{'sid'}";
      $u="http://$site->{'siteurl'}/cgi-bin/om/welcome.cgi?sid=$FORM{'sid'}&pg_targ=$q";
      $FORM{'nextcheckoutpg'}=$u;

      ## wishlist sequence 
      #
      $wishlisttarg="http://$site->{'siteurl'}/cgi-bin/om/cart.cgi?wishlist=1";
      $wishlisturl="http://$site->{'siteurl'}/cgi-bin/om/welcome.cgi?";
      $wishlisturl="sid=$FORM{'sid'}&pg_targ=$collectiontarg";
      $FORM{'wishlist_button'}=$wishlisturl;

   } #/done checking on login when session registered

} else {  # user has no cookie or no session id is being generated
          # add error checking and default user to wrapper script 
          # stub for now - there should be a session id on file.

   $q="$site->{'ssl_prefix'}://$site->{'sitesslurl'}/cgi-bin/om/ssl/checkout.cgi?";
   $q.="sid=$FORM{'sid'}";
   $u="http://$site->{'siteurl'}/cgi-bin/om/welcome.cgi?sid=$FORM{'sid'}&pg_targ=$q";
   $FORM{'nextcheckoutpg'}=$u;

   ## wishlist sequence
   #
   $wishlisttarg="http://$site->{'siteurl'}/cgi-bin/om/cart.cgi?wishlist=1";
   $wishlisturl="http://$site->{'siteurl'}/cgi-bin/om/welcome.cgi?";
   $wishlisturl.="sid=$FORM{'sid'}&pg_targ=$wishlisttarg";
   $FORM{'wishlist_button'}=$wishlisturl;

} #/end of checking on sid for login

if ( $FORM{'objid'} ) {                   # an object id exists, lets validate
                                          # this objid and see if it is an item 
                                          # we can add to the cart 

   ## validate the addition of this item to the cart
   #
   if ( $FORM{'add'} ) {                  # form add is the amount we are being
                                          # given to add to the cart

 ## cartaddcheck - make sure item is available
 #
      
 ($a,$b,$c_err)=cartaddcheck($FORM{'add'},'',$FORM{'objid'},$FORM{'sid'},$FORM{'cartclass'});

    # a      is objid    (line id) 
    # b      is quant    (quantity available to user)
    # c_err  is err      (error message)

      if ( $c_err eq "1" )  { 
         $c_err=$script_msg{4};
      } elsif ( $c_err eq "2" ) { 
         $c_err=$script_msg{5};
      } elsif ( $c_err eq "3" ) { 
         $c_err=$script_msg{6};     
      } elsif ( $c_err eq "4" ) {
         $c_err=$script_msg{7};
      }

      ## set the lineid to a form variable
      #
      $FORM{'newrow_objid'}=$a;

      $aa="row.".$a.".quant_err";
      $bb="row.".$a.".quant_inp";
      $FORM{$aa}=$c_err."<BR>" if ( $c_err ); 
      $FORM{$bb}=$b;
  
   } #/done seeing if they are attempting to add a promotion sku
} #/done adding new rows

## add item to wishlist      
#
 
foreach $k (keys %FORM ) {
   next if ( $k !~ /mv_pcart$/ );
   next if ( $FORM{$k} ne 'on');
   $tmp_lineid = (split /\./, $k)[1];
 
   if ($FORM{'wishlist_en'} == 1 && ($uid)) {
      if (tcart_to_pcart($sid,$uid,$tmp_lineid)) {
         $k =~ s/mv_pcart/kill/;
         $FORM{$k}='on';
      }
   } else {
      $k =~ s/mv_pcart/QUANT_err/;
      $FORM{$k}=$script_msg{3};
   }
}                  

## remove item from cart 
#
@temp = keys %FORM;

   while ( @temp ) {
      $k = shift @temp;

      next if ( $k !~ /kill$/ && ($k !~ /quant_inp$/ || $FORM{$k} != 0));
      next if ( $FORM{$k} ne "on" && ($k !~ /quant_inp$/ || $FORM{$k} != 0));
      $k = ( split /\./, $k )[1];
      next if ($k<1);

      $q = "DELETE from tcart where objid='$k' ";
      $dbh->do( $q );
   } #/ end of processing kills

                                          # adjust quantities in cart

@temp = keys %FORM;

   while (@temp) {
      $k=shift @temp;

      next if ( $k !~ /^row/ );           # only want row entries
      next if ( $k !~ /quant_inp/ );
      next if ( $FORM{$k} eq "no" );      # skip the new ones
      $kp = $k;
      $kk = $k;
      $kk =~ s/quant_inp/kill/ ;
      next if ( exists($FORM{$kk}) and ( $FORM{$kk} eq "on" ));  # skip remove items 
      next if ( $k =~ /quant_inp$/ && $FORM{$k} == 0); 
      $kn = ( split /\./, $k )[1];        # rowid
  
      next if ( $kn eq $FORM{'newrow_objid'} );   # skip newrow
      $kp =~ s/quant_inp/quant_pre/ ;
    

      ##change the quantity in the cart
      #
      if ( $FORM{$k} != $FORM{$kp} ) {    # quantity change
         $objid=$FORM{"row.".$kn.".lineobjid"};
         $err="row.".$kn.".quant_err";

         if ( $FORM{$sku} =~ /^xpr/ ) {    # promotional sku
                                           # do not allow quantity changes
            $FORM{$err}=$script_msg{1};

          } else {                         # normal sku
            $FORM{$k}=$FORM{$kp}-$FORM{$k} if ( $FORM{$k}<0 );
            $FORM{$k}=0 if ( $FORM{$k}<0 );

 ($a,$b,$c_err)=cartaddcheck($FORM{'add'},$FORM{$k},$objid,$FORM{'sid'},$FORM{'cartclass'});

          # a      is objid    (line id)
          # b      is quant    (quantity available to user)
          # c_err  is err      (error message)
 
          if ( $c_err eq "1" )  {
             $c_err=$script_msg{4};
          } elsif ( $c_err eq "2" ) {
             $c_err=$script_msg{5};
          } elsif ( $c_err eq "3" ) {
             $c_err=$script_msg{6};
          } elsif ( $c_err eq "4" ) {
             $c_err=$script_msg{7};
          }                          

          $FORM{$err}=$c_err."<BR>" if ( $c_err );
      } #/done sniffing for disallowed quantity changes
   } #/done with while
} #/done with adjustments

## use the sid and pull all rows from tcart
#
%rows=();           # row hashrefs

$q="SELECT * from tcart where sid='$FORM{'sid'}' ";
$sts = $dbh->prepare( $q );
$sts->execute;
$num=$sts->rows;

if ( $num < 1 ) {                 # error messages when either no items
                                  # are in the cart or cartaddcheck 

   if ( $c_err eq '' ) {
      # sorry you have no items in your cart
      $FORM{'cart_error'}=$script_msg{2};

   } else {
      # error message from cartaddcheck
      $FORM{'cart_error'}="$c_err";
   }
}  

foreach ( 1..$num ) {
   $h=$sts->fetchrow_hashref;
   $row=$h->{'objid'};
   $rows{$row}=\%{$h};

   $q="SELECT * from things where objid='$h->{'lineobjid'}' ";
   $sth=$dbh->prepare( $q );
   $sth->execute;
   $num=$sth->rows;

   if ( $num==1 ) {
      $h=$sth->fetchrow_hashref;

      foreach ( keys %{$h} ) {
         $rows{$row}->{$_} = $h->{$_} if ( ! $rows{$row}->{$_} );
      }

      ## do we have a variant
      #
      if ( length($h->{'ref_from'}) >2 ) {

         if ( $h->{'lineobjid'} ne $h->{'ref_from'} ) {
            $q="SELECT * from things where objid='$h->{'ref_from'}' ";
            $sth=$dbh->prepare( $q );
            $sth->execute;
            $num=$sth->rows; 
            $h=$sth->fetchrow_hashref;
         } 

         foreach ( keys %{$h} ) {
            $rows{$row}->{$_} = $h->{$_} if ( ! $rows{$row}->{$_} );
         }                                           
      } #/done checking for variants
   } #/end of loading the specifics from products 

   ## get price data
   #
   $p="SELECT * from prices where objid='$h->{'lineobjid'}' "; 
   $p=" and status='15000-A' ";
   $stp=$dbh->prepare($p);
   $stp->execute;
   $np=$stp->rows;
   
      for (1..$np) {
         $pp=$stp->fetchrow_hashref;

         foreach ( keys %{$pp} ) {
            next if ($_ ne "unitpr");
            $rows{$row}->{$_} = $pp->{$_} if ( ! $rows{$row}->{$_} || 
               $rows{$row}->{$_} eq "0.00" );
         } #/ done populating price data 
      } #/end of loading the specifics from variants for this one

} #/done loading fields

## page error message
#
$FORM{'page_error'}=$page_error;  

## load and permute templates
#
$templates{'cell_cart_message'}=
   localize_template("cell_cart_message", $om_render_lang,"html",0);
$templates{'cell_cart_header'}=
   localize_template("cell_cart_header", $om_render_lang,"html",0);
$templates{'cell_cart_list'}=
   localize_template("cell_cart_list", $om_render_lang,"html",0);
$templates{'cell_cart_subtotal'}=
   localize_template("cell_cart_subtotal", $om_render_lang,"html",0);
$templates{'cell_cart_buttons'}=
   localize_template("cell_cart_buttons", $om_render_lang,"html",0);

## construct "new" item row
#

if ( $FORM{'newrow_objid'} ) {
   $row=$FORM{'newrow_objid'};
   $h=$rows{$row};
   $k="row\.$row\.quant_err";
   $h->{'quant_err'}=$FORM{$k} if ( $FORM{$k} );

   ## cleanup decimals on prices
   #
   $h->{'unitpr'} = nicedecimals( $rows{$row}->{'unitpr'} );

   ## permute and build cells

   $u=permutebit( $templates{'cell_cart_list'}, $h );
   $u=permuteclean( $u );
   $FORM{'newrow_cell_cart_list'}=$u;
   $FORM{'newrow_cell_cart_message'}=$templates{'cell_cart_message'};
   $FORM{'newrow_cell_cart_header'}=$templates{'cell_cart_header'};
   $FORM{'newrow_cell_cart_buttons'}=
      permutebit( $templates{'cell_cart_buttons'}, \%FORM );
}

## construct "old" item rows
#
$u="";

$FORM{'newrow_objid'}=0 if ( ! defined($FORM{'newrow_objid'}) );

   foreach $r ( keys %rows ) {
      $rows{$r}->{'sid'}=$FORM{'sid'};
      next if ( $r eq $FORM{'newrow_objid'} || $skip );
      $k="row\.$r\.quant_err";
      $rows{$r}->{'quant_err'}=$FORM{$k};

      $rows{$r}->{'unitpr'} = nicedecimals ( $rows{$r}->{'unitpr'} ) ;

      $rows{$r}->{'objid'}=$r;

      $ub=permutebit( $templates{'cell_cart_list'}, $rows{$r} );
      $ub=permuteclean( $ub );
      $u.=$ub;
   } #/end of constructing old rows     

if ( $u ) {
   $FORM{'cell_cart_header'}=$templates{'cell_cart_header'};
   $FORM{'cell_cart_buttons'}=
      permutebit( $templates{'cell_cart_buttons'}, \%FORM );
   $FORM{'cell_cart_list'}=$u;
}

## output the file to stdout
#
$thispage=localize_template("page_cart_cart", $om_render_lang,"html",0);

## output the file to stdout
#
$thispage = permutebit( $thispage, \%FORM );
$thispage = permutebit( $thispage, $site );
$thispage = permutebit( $thispage, \%ENV );
$thispage = permuteclean ( $thispage  );
$thispage = permute_include( $thispage, $om_render_lang, "html", 0);

print $thispage;

## cleanup
#
$sth->finish if ( $sth );
$sts->finish if ( $sts );

$dbh->disconnect if ( $dbh );

sub message {
   # check the language that is being used and open appropriate
   # message language file or get messages below

   if ($om_render_lang eq "eng" ) {
      $script_msg{1}="We're sorry! Limit one per order!";
      $script_msg{2}="You currently have no items in your cart.";
      $script_msg{3}="Sorry you must log in before you can place items into your Wishlist";
      $script_msg{4}="Sorry quantity is limited to this item. ";
      $script_msg{5}="Sorry, we have a quantity limit on this item.";
      $script_msg{6}="Sorry, but this item is now out of stock.";
      $script_msg{7}="This item cannot be added to your cart.";

   } else {
      open( EM, "<$relpath/bits/$om_render_lang/system/$scriptname.$om_render_lang.messages");
      while(<EM>) {
         chomp;
         next if /^\#/;
         next if (! $_);
         @temp=split /\t/;
         $script_msg{$temp[0]}=$temp[1];
      }
      close(EM);
   }
}

## provide a return value
#
1;
