#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

####
# welcome.cgi
#    customer login screen set
#    RF 981203 
#
####

####
#
# Version 0.9.6 IB 20000605
#    language and interface from table 'sessions'
#    html -> $interface
#    u_email -> uname
# Version 0.9.5 IB 20000531
#    added custom-lib.pm
# Version 0.9.4 GF 20000524
#    fixed problem with storing of custid for new user
#    removed u_email from query into sessions
#    storing objtype and class
# Version 0.9.2 GF 20000509
#    fixed a problem setting a null custid
# Version 0.9.1 IB 20000502
#    introduced $script variable
# Version 0.7.33 GF 20000504
#    error messages
# Version 0.7.32 GF 20000502
#    field names lowercase
# Version 0.7.31 GF 20000501
#    CUSTID -> OBJID
# Version 0.7.29 IB 20000420
#    set->SET
# Version 0.7.28 JC 20000418
#    replaced loadtemplate with localize_template
#    included permute_include
#    removed $skeleton
# Version 0.7.27 GF 20000413
#    fixed levent entry
# Version 0.7.26 GF 20000411
#    moved sendmail info to site->{'mailserver'} 
#    changed UID to U_EMAIL, CUSTNUM to CUSTID 
#    reformatted
# Version 0.7.25 IB 20000411
#    default to language in site.pm
# Version 0.7.24 IB 20000410
#    multilingual messages
# Version 0.7.23 IB 20000404
#    new directory structure
# Version 0.7.22 IB 20000402
#    new directory structure
# Version 0.7.21 IB 20000331
#    cell template renaming
# Version 0.7.20 IB 20000330
#    changed connect statement
# Version 0.7.19 JC 20000329
#    changed DBI prepare/connect
# Version 0.7.18 IB 20000327
#    corrected $relpath
# Version 0.7.17 IB 20000324
#    changed the way site.pm is obtained (multiple stores)
# Version 0.7.16 JC 20000322
#    added colon to ssl_prefix
# Version 0.7.15 IB 20000302
#    updated copyright and removed -w
# Version 0.7.14 IB 20000226
#    change store to site
# Version 0.7.13 JN 20000117
#    using ssl_prefix instead of https/http for checkout
# Version 0.7.12 JN 20000111
#    When checking the HINT string let spaces remain spaces
#    Tightened up the checking to remove quotes
# Version 0.7.11 IB/GF 991203
#    added in track 
# Version 0.7.10 IB/GF 991202
#    added in skeletonpath
# Version 0.7.9 IB 991112
#    corrected the determining of the relpath
#    removed foreach
#    corrected $scriptname
# Version 0.7.8 IB 991110
#    correcting a list of databases
# Version 0.7.7 IB 991109
#    removing of HACKS, and correcting of relpath
# Version 0.7.6 IB 991101
#    general cleanup
# Version 0.7.5 GF 990914
#    changed password to encrypt
# Version 0.7.4 SH 990901
#    uid into levents 
# Version 0.7.3 SH 990831
#    fixed EMAIL ok
# Version 0.7.1 GF 990830
#    changed template names from 450 to 300
# Version 1 - 981204
#
####

## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$siteshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $siteshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $siteshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

$relpath .= "/../$siteshortname";

use DBI;
require "$relpath/lib/filetools.pm";
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/state.pm";
require "$relpath/conf/site.pm";
require "$relpath/lib/validate.pm";
require "$relpath/lib/localization.pm";

# must be the last require statement
require "$relpath/lib/custom-lib.pm";

## establish site-specific parameters
#
$site=setsite();

## read input form and cookie data
#
%FORM=();
&ReadParse;

## establish connection to database  
#
$q="$site->{'db_site_config'}";
$dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

$om_render_lang = "";
$interface = "";

if ($FORM{'sid'}) {
   $q="SELECT language,interface from sessions where sid=$FORM{'sid'} ";
   $sts = $dbh->prepare( $q );
   $sts->execute;
   $h=$sts->fetchrow_hashref; 
   $om_render_language=$h->{'language'};
   $interface=$h->{'interface'};
}

$om_render_lang=$site->{'om_locale_lang_def'} if ( ! $om_render_lang );
$om_render_lang="eng" if ( ! $om_render_lang );
$interface="html" if ( ! $interface );

## load messages
%script_msg=();          # user interaction messages
$script=( split /\./, $scriptname )[0];
&message;

## initialize other bits
#
$now=time();
$mode="login";                  # default is to show login screen
$logfile="/tmp/$scriptname";

## Form elements that are needed for page generation
#
$FORM{'scriptname'}=$scriptname;

## email_ok checkbox
#
if ( exists($FORM{'new.email_ok_inp'}) ) {  # checkbox submitted
   # carry state forward
   $FORM{'new.email_ok_pre'}=$FORM{'new.email_ok_inp'};

} elsif ( exists($FORM{'new.email_ok_pre'}) ) {  # checkbox previously sub
   $FORM{'new.email_ok_inp'}=$FORM{'new.email_ok_pre'};

} else {                                    # no evidence of checkbox inp
   $FORM{'new.email_ok_inp'}="y";
   $FORM{'new.email_ok_pre'}="y";
} #/done with checkbox permutations

$FORM{'new.email_ok_state'}="CHECKED" if ( $FORM{'new.email_ok_inp'} eq "y" );

## destination upon successful login
#
if ( exists($FORM{'pg_targ'}) ) {       # "target page" element exists

# don't need to do anything
} elsif ( $ENV{'HTTP_REFERER'} ) {   # site referer if

   # check that refered from inside site and not welcome
   if (( $ENV{'HTTP_REFERER'} =~ /($site->{'sitedomain'}|$site->{'sitessldomain'})/ ) 
      and ( $ENV{'HTTP_REFERER'} !~ /$scriptname/ )) {
      $FORM{'pg_targ'}=$ENV{'HTTP_REFERER'};

    } else { 
      ## referer is outside site or this script, default to home
      $u=$site->{'siteserver'}.$site->{'sitedomain'};
      $FORM{'pg_targ'}="http://$u/html/$om_render_lang/home.shtml";
    } #/done looking at plausibility of using the referer as targ

} else {                                         # default target
   $u=$site->{'sitesslserver'}.$site->{'sitessldomain'};
   $u="$site->{'ssl_prefix'}://$u/cgi-bin/om/ssl/checkout.cgi";
   $FORM{'pg_targ'}="$u?sid=$FORM{'sid'}";
   } #/done checking over page to use on outbound

## check for a session id
#
&setsessionid();    # Either a sid > 0 or 0

## look at submitted form data and log user in
#
@temp=keys %FORM;
%new=();               # new customer data
%old=();               # existing customer data

while ( @temp ) {
   $k=shift @temp;
   next if ( $k !~ /^(new|old)/ );

   ## kill bad characters
   #
   $v=$FORM{$k};

   if ($k =~ /HINT/) { 
      $v=~ tr/[]*&#^%$~+=\/\\<>\'\"//d; 

   } else {
         $v=~ tr/ []*&?#^%$!~+=\/\\<>,\'\"//d ;
   }

   if ( $k =~ /^new/ ) {
      $k =~ s/^new\.// ;
      $new{$k}=$v;

   } else {
      $k =~ s/^old\.// ;
      $old{$k}=$v;
    } #/done with new vs. old
} #/done loading information to new/old pair

## evaluate existing customer options first
#
$oldok=1;
$olderr=0; 
$old{'EMAIL_inp'}="" if ( ! defined($old{'EMAIL_inp'}));

if ( length($old{'email_inp'})>8 ) {

   if ( length($old{'passwd_inp'})>=5 ) {   # minimalist passwd
      ## attempt to validate login
      #
      $err=customerlogin( $FORM{'sid'},$old{'email_inp'},$old{'passwd_inp'} );

      if ( $err ) {
         $FORM{'old.login_err'}="<P>".$err;
         $oldok=0;
         $olderr=1;

      } else {  
         $mode="redirectok";  
      } #/done evaluating login

   } else  {    # short passwd or blank field
      $oldok=0;
      $olderr=1;
      $FORM{'old.passwd_err'} = $script_msg{1};
   } #/done with permutations on passwd

} else {            # short or null email
                    # error only if the password is entered 
                    # or if the email_inp >0 
   $oldok=0;

   if ( length($old{'email_inp'})>0 ) {  # attempted login
      $olderr=1;
      $FORM{'old.email_err'}=$script_msg{2}; 

      if ( length($old{'passwd_inp'})>4 ) { # minimalist passwd
         $FORM{'old.passwd_err'} = $script_msg{3};

      } else {   # short passwd or blank field
         $FORM{'old.passwd_err'} = $script_msg{1};
      } #/done with permutations on passwd

   } else {                              # no username provided
      # only generate an error message if the passwd is not blank

      if ( length($old{'passwd_inp'})>0 ) { # minimalist passwd
         $olderr=1;
         $FORM{'old.passwd_err'} = $script_msg{3};
      } #/done looking at error message permutations

   } #/done examining what error messages to display 

} # data basic checking on old inputs


## if login from existing customer data not OK, try the new data
#  
if (( ! $oldok ) or ( $olderr )) {    # existing login didn't work 
   $newok=1;
   $newerr=0;
   $u=validateemail( $new{'email_inp'} );

   if ( $u ) {
    
      if ( $FORM{'new.email_inp'} ) {   # there was an input

      ## if this is not a correct email address
      #  what is the correct error to display
 
      if ( $u eq "a" ) {
         # Error - No email address entered!
         $FORM{'new.email_err'}=$script_msg{21};
 
      } elsif ( $u eq "b" ) {
         # Error - Wrong email address format, need \@
         $FORM{'new.email_err'}=$script_msg{22};
 
      } elsif ( $u eq "c" ) {
         # Error - Invalid email address!
         $FORM{'new.email_err'}=$script_msg{20};
 
      }

         $newerr=1;

      } #/checking for any input

      $newok=0;

   } else {
                                        # plausible email
                                        # check the passwords to see if 
                                        # they match and are long enough

      if ( $new{'passwd1_inp'} eq $new{'passwd2_inp'} ) {

         # they match 
         if ( length( $new{'passwd1_inp'} ) > 4 ) {
            ## create the account if the email is unique
            #
            $new{'email_inp'}=~ tr/A-Z/a-z/ ;
            $q="SELECT objid from contacts where ";
            $q.=" uname='$new{'email_inp'}' and objtype='39003-A'";
            $stc = $dbh->prepare( $q );
            $stc->execute;
            $num = $stc->rows;

            if ( $num==0 ) {
               ## create the event for the account
               #
               $p= "INSERT into levents (series,dtable,dvalue,cdate) ";
               $p.=" values('$site->{'series'}','contacts',"; 
               $p.=" '$new{'email_inp'}\t Create 39003-A', '$now') ";
               $stp=$dbh->prepare($p);
               $stp->execute;
 
               $e ="SELECT event,series from levents where dtable='contacts' and ";
               $e.=" dvalue='$new{'email_inp'}\t Create 39003-A' and cdate='$now' ";
               $ste=$dbh->prepare($e);
               $ste->execute;
               $nume=$ste->rows;
               ($event, $series)=$ste->fetchrow;
               $objid=$event."-".$series;

               ## create the user account
               #
               $q="INSERT into contacts ";
               $q.=" (objid,objtype,uname,passwd,hint,email_ok,cdate,mdate) ";
               $q.=" VALUES ('$objid','39003-A','$new{'email_inp'}', ";
               $q.=" '$new{'passwd1_inp'}','$new{'hint_inp'}'";
               $q.=",'$FORM{'new.email_ok_inp'}',$now,$now)";
               $dbh->do( $q );

               ## set passwd to a form variable
               #
               $FORM{'passwd'}=$new{'passwd1_inp'};

               ## send the user a confirmation via email
               #
               if ( $site{'mailserver'} ) {
                  &send_mail; 
               }

            } else {
               ## error - name is already in use
               # 
               $FORM{'new.email_err'} = $script_msg{5};
               $newerr=1;
               $newok=0;
            } #/end of checking for existing matches...
 
         } else {                    # passwords too short
            # message variation on lengths
            if ( ! $new{'passwd1_inp'} ) {   # null condition
               $FORM{'new.passwd_err'}=$script_msg{6};
        
            } else {                         # just too short
               $FORM{'new.passwd_err'}= $script_msg{7};
            } #/message selection on length
   
            $newerr=1;
            $newok=0; 
       
         } #/checking password minimum lengths

      } else {                       # passwords don't match
         $FORM{'new.passwd_err'}=$script_msg{8};
         $newerr=1;
         $newok=0;
      } #/done checking passwords for new user 
   } #/done checking for a plausible email

} #/done examining new bits

## update SID record
#
$q="SELECT custid,sid,status,mdate from sessions where sid=$FORM{'sid'} ";
$sts = $dbh->prepare( $q );
$sts->execute;
$num=$sts->rows;

if ( $num==1 ) { 
   $h=$sts->fetchrow_hashref;
   $em="";

   if (( $newok ) and ( ! $newerr )) {
      $em=$new{'email_inp'};

   } elsif (( $oldok ) and ( ! $olderr )) {
      $em=$old{'email_inp'};

   } #/done checking on new vs. old worked

   ## store uname in FORM variable
   # 
   $FORM{'email'}=$em;

   # see if uname = $em
   if ( length($em)>8 ) {
    
      if ( length($h->{'custid'})>0 ) {

         ## see if em and uname match what we have 
         #
         $q="SELECT uname from contacts where objid='$h->{'custid'}' ";
         $sts = $dbh->prepare( $q );
         $sts->execute;
         $check_email=$sts->fetchrow;

         if ( $check_email eq $em ) {          # there is a uname on file
                                               # is it the same?

            $q="UPDATE sessions SET mdate=$now, custid='$h->{'custid'}' ";
            $q.="where sid=$FORM{'sid'} ";
            $dbh->do( $q ); 

         } else {                              # we have a problem
                                               # just update s essions
   
            $q="UPDATE sessions SET mdate=$now";
            $q.=" where sid=$FORM{'sid'} ";
            $dbh->do( $q );
         } #/done checking if this is a new uname

      } else {                          # no uname on file
                                        # so let's log it
         $q="UPDATE sessions SET mdate=$now where sid=$FORM{'sid'} ";
         $dbh->do( $q );
      } #/end of permutations on uname update
   } #/no else - if $em is null there is a login error

} else { # this isn't a good login, or DB troubles
      $q="UPDATE sessions SET mdate=$now where sid=$FORM{'sid'} ";
      $dbh->do( $q );
} #/decision tree based on exactly one record for SID 

if (( $newok ) and ( ! $newerr )) {       # new, session OK
   $thispage=localize_template("page_welcome_confirm", $om_render_lang, $interface, 0);
   $mode="confirm";

} elsif (( $oldok ) and ( ! $olderr )) {  # existing login
   $thispage=localize_template("page_welcome_onwards", $om_render_lang, $interface, 0);
   $mode="redirect";

} else {  # not logged in!
   $thispage=localize_template("page_welcome_login", $om_render_lang, $interface,0);
   $cell_rc = localize_template("cell_welcome_return_customer", $om_render_lang, "$inteface",0);
   $cell_nc = localize_template("cell_welcome_new_customer", $om_render_lang, $interface, 0);

   # done loading templates that are endemic
   $cell_rc=permutebit( $cell_rc, \%FORM );
   $cell_nc=permutebit( $cell_nc, \%FORM );
   $FORM{'cell_welcome_return_customer'}=$cell_rc;
   $FORM{'cell_welcome_new_customer'}=$cell_nc;
   
   $mode="login"; 
} #/done evaluating session

## start the response header - NOTE cookie set way up at start
#
print "Content-type: text/html\n\n";

## track user in site 
#
`$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/cgi-bin/om/track.cgi`;


## send the file to stdout
#
$thispage = permutebit( $thispage, \%FORM );
$thispage = permutebit( $thispage, $site );
$thispage = permutebit( $thispage, \%ENV );
$thispage = permuteclean ( $thispage  );
$thispage = permute_include( $thispage, $om_render_lang, "html", 0);
print $thispage;

## cleanup
#
$sts->finish if ( $sts );
$stc->finish if ( $stc );
$dbh->disconnect if ( $dbh );


###### subroutines
#

## customerlogin ( sid, username, passwd ): errstr;
#
sub customerlogin {
   my($sid,$uname,$pwd,$rv,$q,$stc,$num,$temp,$now);
   ( $sid,$uname,$pwd ) = @_;

   $rv="";

   $q="SELECT objid,uname,passwd from contacts where ";
   $q.=" uname='$uname' and passwd='$pwd' and objtype='39003-A' ";
   $stc = $dbh->prepare( $q );        # need to add password unhash
   $stc->execute;
   $num=$stc->rows;

      if ( $num==1 ) {
         $now = time();
 
         ## valid login, register the session
         #
         ($a,$b,$c)=$stc->fetchrow;

         ## now update customer timestamp 
         #
         $q="UPDATE contacts SET mdate=$now ";
         $q.= " where objid='$a' ";
         $dbh->do( $q );

         ## now update session record
         #
         $q="UPDATE sessions SET custid='$a', mdate=$now ";
         $q.=" where sid='$sid' "; 
         $dbh->do( $q );

      } else {
         ## too many or too few records, do not allow
         $rv=$script_msg{19};

         ## now update session record
         #
         $q="UPDATE sessions mdate=$now where ";
         $q.=" sid='$sid' "; 
         $dbh->do( $q );

      } # done evaluating whether or not the customer in system

   $stc->finish;

   return $rv;
} #/customerlogin 

## send email confirmation by GF 990518  
#

sub send_mail {

    $mailprog = $site->{'mailserver'};
    $title= $script_msg{9};

    open(MAIL,"|$mailprog -t");

    print MAIL "$script_msg{10}: $new{'EMAIL_inp'}\n";
    print MAIL "$script_msg{11}: info\@$site->{'sitename'}\n";

    print MAIL "$script_msg{12}: $title\n\n";

    print MAIL "$script_msg{13} $site->{'sitename'}\n";
    print MAIL "$script_msg{14}:\n\n"; 
    print MAIL "$script_msg{15}: $new{'EMAIL_inp'}\n";
    print MAIL "$script_msg{16}: $new{'PASSWD1_inp'}\n\n";
 
    print MAIL "$script_msg{16}\n";
    print MAIL "$script_msg{17}\@$site->{'sitename'}.\n\n";
    print MAIL "$script_msg{18} http://$site->{'sitename'}\n";

    close (MAIL);
}

sub message {
   # check the language that is being used and open appropriate
   # message language file or get messages below

      if ($om_render_lang eq "eng" ) {
         $script_msg{1}="Password too short!";
         $script_msg{2}="A valid email address is required!";
         $script_msg{3}="You need a valid email with your password";
         $script_msg{4}="Matches on";
         $script_msg{5}="Error - That address is already registered!";
         $script_msg{6}="Please select a password!";
         $script_msg{7}="Passwords are at least 5 characters!";
         $script_msg{8}="Error - your passwords do not match";
         $script_msg{9}="Your account has been created.";
         $script_msg{10}="To";
         $script_msg{11}="From";
         $script_msg{12}="Subject";
         $script_msg{13}="You have created an account with";
         $script_msg{14}="using the following information";
         $script_msg{15}="Email address";
         $script_msg{16}="Password";
         $script_msg{16}="If you have any problems or questions contact";
         $script_msg{17}="customer service";
         $script_msg{18}="Thank you for visiting";
         $script_msg{19}="Invalid login! Please try again.";
         $script_msg{20}="Error - Invalid email address!";
         $script_msg{21}="Error - No email address entered!";
         $script_msg{22}="Error - Wrong email address format, need \@";
      } else {
         open( EM, "<$relpath/bits/$om_render_lang/system/$scriptname.$om_render_lang.messages");
            while(<EM>) {
               chomp;
               next if /^\#/;
               next if (! $_);
               @temp=split /\t/;
               $script_msg{$temp[0]}=$temp[1];
            }
         close(EM);
      }
}

## provide a return value
#
1;
