#!/usr/bin/perl 

############################################################################
#    Copyright (C) 1999-2000 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

####
# wrapper.cgi
#    wrapperizer script that handles user request that don't accept cookies
#    HVC 20000327
#
####

#####
#
# Version 0.9.6 IB 20000502
#    introduced $script variable
# Version 0.9.5 IB 20000421
#    clean up 
# Version 0.9.4 HVC 20000420
#    replace ERLOG with message subroutine
# Version 0.9.02 HVC 20000403
#    clean up code
#    modify FixLinks
# Version 0.9.01 HVC 20000327
#    handle both GET/POST method
#    compatible with openmerchant0_7
#
#####

## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$siteshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $siteshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $siteshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

$relpath .= "/../$siteshortname";

use DBI;
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/conf/site.pm";
require "$relpath/lib/state.pm";
require "$relpath/lib/localization.pm";

## get the CGI bits
%FORM=();
&ReadParse;
## HVC - Make wrapper.cgi act like a browser.
## Here wrapper.cgi asks for the target page from the apache server, and 
## then parses the returned page to change links, so that user is always 
## within wrapper.cgi, it also handle GET/POST method accordingly.

$om_render_lang=$FORM{'OM_UI_LANGUAGE'};
$om_render_lang=$site->{'om_locale_lang_def'} if ( ! $om_render_lang );
$om_render_lang="eng" if ( ! $om_render_lang );

## load messages
%script_msg=();          # user interaction messages
$script=( split /\./, $scriptname )[0];
&message;

# Make sure you include LWP libraries
use LWP::UserAgent;

if (exists($FORM{'continue_shopping.x'})) {
   $host_path=sprintf("http://%s",$ENV{'HTTP_HOST'});  
   $sid=$FORM{'sid'};
   print "Location: $host_path/cgi-bin/om/wrapper.cgi?sid=$sid&target=/html/$om_render_lang/home.shtml\n\n";
}

print "Content-type: text/html\n\n";

# Check for SID
if ($FORM{'sid'}) {
   $sid=$FORM{'sid'};
} else {
   print "Content-type: text/html\n\n"; 
   print "<HTML><HEAD><TITLE>wrapper.cgi messages</TITLE></HEAD><BODY><BR><BR>$script_msg{1}</BODY></HTML>";
   print "\n\n";
   exit -1 ;
}

# Define path
$wrapper_path=sprintf("http://%s/cgi-bin/om/wrapper.cgi",$ENV{'HTTP_HOST'});
$default_path=sprintf("http\:\/\/%s\/cgi\-bin\/om\/wrapper.cgi\?sid=%s\&target=\/html\/home.shtml",$ENV{'HTTP_HOST'},$sid);
$welcome_path=sprintf("http://%s/cgi-bin/om/wrapper.cgi\?sid=%s&target=/cgi-bin/om/welcome.cgi",$ENV{'HTTP_HOST'},$sid);
$checkout_path=sprintf("http://%s/cgi-bin/om/wrapper.cgi\?sid=%s&target=/cgi-bin/om/ssl/checkout.cgi",$ENV{'HTTP_HOST'},$sid);

# Check for target
if ($FORM{'target1'}) {
   $pg_targ=$FORM{'pg_targ'} ;
   $pg_targ.=$FORM{'target1'};
   $pg_targ=sprintf("%s&target=%s",$FORM{'pg_targ'},$FORM{'target1'});
   $FORM{'pg_targ'}=$pg_targ;
   $target=$FORM{'target'};
} elsif ($FORM{'target'}) {
   $target=$FORM{'target'} ;
   if ($ENV{'HTTP_REFERER'} ne $wrapper_path) { 
      if ( ($ENV{'HTTP_REFERER'} =~ /target1/) || ($ENV{'HTTP_REFERER'} eq $welcome_path) ) {
         $FORM{'pg_targ'}=$checkout_path;
         $pg_targ=$FORM{'pg_targ'};
      } else {
         $FORM{'pg_targ'}=$ENV{'HTTP_REFERER'} ;
         $pg_targ=$FORM{'pg_targ'};}
      } elsif (! $FORM{'pg_targ'}) {
         $FORM{'pg_targ'}=$default_path;
         $pg_targ=$FORM{'pg_targ'} ; }
} else {
   print "Content-type: text/html\n\n"; 
   print "<HTML><HEAD><TITLE>wrapper.cgi messages</TITLE></HEAD><BODY><BR><BR>$script_msg{2}</BODY></HTML>";
   print "\n\n";
   exit -1;
}

$new_target=sprintf("http://%s%s\?sid=%s",$ENV{'HTTP_HOST'},$target,$sid);

## Determine which method   
if ($ENV{REQUEST_METHOD} eq 'GET' ) { 
   $ua = new LWP::UserAgent;
   $ua->agent("Mozilla/4.0" . $ua->agent);
   my $request = new HTTP::Request GET=>$new_target;
   my $response = $ua->request($request);
   if ($response->is_error()) { 
      print "Content-type: text/html\n\n"; 
      print "<HTML><HEAD><TITLE>wrapper.cgi messages</TITLE></HEAD><BODY><BR><BR>$script_msg{3}</BODY></HTML>";
      print "\n\n";
      exit -1;
   } else { 
      my $content = $response->content();
      FixLinks($content,$sid);
      InsertEntry($sid);
   }
} elsif ($ENV{REQUEST_METHOD} eq 'POST' ) {
   $ua = new LWP::UserAgent;
   $ua->agent("Mozilla/4.0" . $ua->agent);
   my $request = new HTTP::Request POST=>$new_target;
   $request->content_type('application/x-www-form-urlencoded');
   foreach $keyval (keys(%FORM)) {
      #SAM's magic number
      $FORM{$keyval} =~ s/\&/\%26/g;
      $postdata .= ("$keyval=$FORM{$keyval}&");
   }
   chomp($postdata);
   $request->content($postdata);
   my $response = $ua->request($request);
   if ($response->is_error()) { 
      print "Content-type: text/html\n\n"; 
      print "<HTML><HEAD><TITLE>wrapper.cgi messages</TITLE></HEAD><BODY><BR><BR>$script_msg{4}</BODY></HTML>";
      print "\n\n";
      exit -1;
   } else { 
      my $content = $response->content();
      FixLinks($content,$sid);
      InsertEntry($sid);
   }
} else {
   print "Content-type: text/html\n\n"; 
   print "<HTML><HEAD><TITLE>wrapper.cgi messages</TITLE></HEAD><BODY><BR><BR>$script_msg{5}</BODY></HTML>";
   print "\n\n";
   exit -1;
}

## Fix all links to pass through wrapper.cgi
sub FixLinks {
$pattern1="HREF=\"/";
$pattern12="HREF=\"\/cgi\-bin\/om\/wrapper\.cgi";
$pattern2="method=post action=";
$pattern22="METHOD=\"POST\" action=";
$pattern3="name=\"sid\" value=\"\"" ;
$pattern4="name=\"sid\" value=\"$sid\"" ;
$pattern5=sprintf("http://%s/html/home.shtml",$ENV{'HTTP_HOST'});
$pattern6="/cgi-bin/om/wrapper.cgi?sid=$sid&target=/html/home.shtml";
$pattern7=sprintf("http://%s/cgi-bin/om/welcome.cgi\\?sid=$sid\&pg_targ=http://%s/cgi-bin/om/ssl/checkout.cgi\\?sid=$sid",$ENV{'HTTP_HOST'},$ENV{'HTTP_HOST'});
$pattern8="/cgi-bin/om/wrapper.cgi?sid=$sid&target=/cgi-bin/om/welcome.cgi&pg_targ=/cgi-bin/om/wrapper.cgi?sid=$sid&target1=/cgi-bin/om/ssl/checkout.cgi";
$pattern9=sprintf("http://%s/cgi-bin/om/ssl/checkout.cgi\\?sid=%s",$ENV{'HTTP_HOST'},$sid);
$pattern10=sprintf("/cgi-bin/om/wrapper.cgi?sid=$sid&target=/cgi-bin/om/ssl/checkout.cgi",$sid);

$sid=$_[1];
@entirepage = split(/\n/,$_[0]);
foreach $eachline (@entirepage) {
   if (($eachline =~ /$pattern1/i) && ($eachline !~ /$pattern12/i)) { 
      $eachline =~ s/HREF="\//HREF="\/cgi-bin\/om\/wrapper.cgi\?sid=$sid&target=\//ig; }  
   if ($eachline =~ /$pattern2/i)  {
      $eachline =~ s/$pattern2/METHOD=POST ACTION=\"\/cgi\-bin\/om\/wrapper.cgi\"\><INPUT TYPE=\"HIDDEN\" NAME=\"target\" VALUE=/gi; }
   if ($eachline =~ /$pattern22/i) {
      $eachline =~ s/$pattern22/METHOD=\"POST\" ACTION=\"\/cgi\-bin\/om\/wrapper.cgi\"\><INPUT TYPE=\"HIDDEN\" NAME=\"target\" VALUE=/gi; }
   if ($eachline =~ /$pattern3/i) {
      $eachline =~ s/$pattern3/$pattern4/gi ;}
   if ($eachline =~ /$pattern5/i) {
      $eachline =~ s/$pattern5/$pattern6/gi ;}
   if ($eachline =~ /$pattern7/i) {
      $eachline =~ s/$pattern7/$pattern8/gi ;}
   if ($eachline =~ /$pattern9/i) {
      $eachline =~ s/$pattern9/$pattern10/gi ;}  
   print $eachline;
   print "\n"; }
}

## Make entry in clicks database
sub InsertEntry {
$now=time();
$sid=$_[0];

# establish store-specific parameters
$site=setsite();

# establish connection to database  
$q = "$site->{'db_site_config'}";
$dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

# insert values in clicks
$q="INSERT INTO clicks VALUES ";

if ($ENV{'HTTP_REFERER'}) {
   $value = $ENV{'HTTP_REFERER'};
} else {
   $value = "";
}

$q.="('$sid','$now','$ENV{'REQUEST_URI'}','$value','$site->{'clusterid'}')";
$dbh->do( $q );
$dbh->disconnect if ( $dbh ); }

## Print error messages
sub message {
   # check the language that is being used and open appropriate
   # message language file or get messages below

   if ($om_render_lang eq "eng" ) {
      $script_msg{1}="sid not found, wrapper.cgi fails.";
      $script_msg{2}="target not found, wrapper.cgi fails."; 
      $script_msg{3}="Error in GET Method, wrapper.cgi fails."; 
      $script_msg{4}="Error in POST Method, wrapper.cgi fails."; 
      $script_msg{5}="Neither GET/POST Method, wrapper.cgi fails.";
   } else {
      open( EM, "<$relpath/bits/$om_render_lang/system/$script.messages");
      while(<EM>) {
         chomp;
         next if /^\#/;
         next if (! $_);
         @temp=split /\t/;
         $script_msg{$temp[0]}=$temp[1]; 
      }
      close(EM);
   } 
}

1;
