#! /usr/bin/perl -w
############################################################################
#    Copyright (C) 1999-2000 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#############################
# Checkout.cgi              #
#   Version 0.9.0           #
#############################
 
## Version 0.9.8 20000524
 
## Missing Revs all dealt with converting
## code to all-commerce                     

#print "Content-type: text/html\n";
#print "\n\n";


####
# Relative directory finding taken from

## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#


if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
   } else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;
$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
#chdir( $rundir );

$relpath="";
$siteshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $siteshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;
   
   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels
   
   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );
   
   if ( $u eq "cgi-bin" ) {
      $siteshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root
   
} # done constructing relative path to store root


use DBI;
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/state.pm";
require "$relpath/conf/site.pm";
require "$relpath/lib/validate.pm";
#require "$relpath/lib/payment.pm";
require "$relpath/lib/localization.pm";
require "$relpath/lib/custom-lib.pm";

require "$relpath/lib/checkout_cells.pm";
my $now=time();




###########
# 	Init
#		Get SID
#			- error handling
#		Get custid
#			- go to welcome if can't
#		Get State
#			- go to first page if can't
#		Load hash re: current State

######
# Init

#####
# Get Site Hash
$site=setsite();

## establish connection to database
#
#
$q = "$site->{'db_site_config'}"; 
$dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

#######
# Get Sid and Form
%FORM = ();
%ORDER = ();
&ReadParse;

$om_render_lang=$FORM{'OM_UI_LANGUAGE'};
$om_render_lang=$site->{'om_locale_lang_def'} if ( ! $om_render_lang );
$om_render_lang="eng" if ( ! $om_render_lang );

$site->{'om_render_lang'} = $om_render_lang;

$sid = $FORM{'sid'};
$sid = &setsessionid();    # Either a sid > 0 or 0
$sid = $FORM{'sid'};

#######
# Check if user logged in
# get custid

$test_custidok=1;    # assume OK
if ( $sid ) {
   $q="SELECT custid,BROWSER FROM sessions where SID='$sid' ";
   $sts = $dbh->prepare( $q );
 
  $sts->execute;
   $num=$sts->rows;
   if ( $num==1 ) {
      ( $x,$u ) = $sts->fetchrow;
      if ($u eq substr($ENV{'HTTP_USER_AGENT'},0,40)) {
         $custid=$x;

         } else {
         $custid = '';
      }
      
      } else {
      $test_custidok=0;   # bad sid
      $custid="";
   } #/testing on records for sid
   } else {          # probable cookieless user!
   $test_custidok=0;
   $custid="";
} #/testing if user logged in

#####
# If we have a sid and custid get orderid
#



if ($sid and $custid) {
   
   ## update the tcart with the data coming from sessions;
   $q="update tcart set custid='$custid' where sid='$sid'";
   $dbh->do($q);
   ## now get the orderid(s)
   ## there can be more than one
   $q="SELECT objid FROM orders where custid = '$custid' and SID='$sid' and status='15012-A'";
   $sts = $dbh->prepare( $q );
   $sts->execute;
   $num=$sts->rows;
   if ($num == 1) {
      ## Great we got only one
      $orderid = $sts->fetchrow ;
      $orderid_array[0] = $orderid;
      
      } elsif ($num > 1) {
      
      ## okay we got more than one, lets put them in orderid_array
      foreach $t (1..$num)   {
         $orderid = $sts->fetchrow;
         push (@orderid_array ,$orderid);
      }
   }
}
$loadpoint = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site";


$FORM{'topnav'}=localize_template("topnav", $om_render_lang,"html",0);
$FORM{'bottom_nav'}=localize_template("bottom_nav", $om_render_lang,"html",0);


###########
# 	Page list			function
# 	Shipping Address Page		pg_shippingaddress()
#	Shipping Method Page		pg_shippingmethod()
#	Billing and Payment Pg		pg_billpay()
#	OrderApprove Page		pg_orderapprove()
#	OrderConf	Page		pg_orderconf()
#	EnterAcdress Page		pg_addressenter()
###########
###########
# page list hashref
#	this is so that input from FORM is never blindly used to call
#	a function

$pagelist = {
   firstdisplay =>		'pg_firstdisplay',
   shippingaddress => 	 	'pg_shippingaddress',
   shippingmethod  =>		'pg_shippingmethod',
   billpay		=>		'pg_billpay',
   orderapprove	=>		'pg_orderapprove',
   orderconf	=>		'pg_orderconf',
   addressenter	=>		'pg_addressenter',
   ordersummary 	=>		'pg_ordersummary'
};


###########
#	Cell List			function
#	Addressbook cell		cl_addressbook()
#	EnterAddress cell		cl_addressedit()
#	Shiping Method cell		cl_shippingmethod()
#  	Billing address and
#	Payment page			cl_billpay()
#   Orderlist				cl_orderlist()
#   Order approval cell		cl_orderapprove()
###########
$celllist = {
   addressbook	=>		'cl_addressbook',
   addressedit	=>		'cl_addressedit',
   shippingmethod  =>		'cl_shippingmethod',
   billpay		=>		'cl_billpay',
   orderlist	=>  		'cl_orderlist',
   orderapprove	=>		'cl_orderapprove',
   orderemail	=>		'cl_orderemail',
};
###########
# 	Transfer Hash
#	Key					Descript
#	ERROR					scalar, null if no errors
#	(FIELDNAME)				scalar, Database pull
#	orderid_array				array ref,  list of order ids for split shipments
#	orderid					scalar, order id
#	sid					scalar, session id
#	custnum					scalar, custumer #
#	mode					scalar, requested mode
# 	templatename				scalar, template string
###########


###########
# Page Logic
$ret_hash->{'FORM'}->{'topnav'}=localize_template("topnav", $om_render_lang,"html",0);





$cur_page = $pagelist->{$FORM{'cur_page'}};   	#get the current page from the hash
$ret_hash->{'mode'} = $FORM{'mode'};			#get the mode
$ret_hash->{'ERROR'} = $FORM{'ERROR'};			#get any error
$ret_hash->{'FORM'} = \%FORM;					#get all the form variables
$ret_hash->{'orderid'} = $orderid;						#get the orderid
$ret_hash->{'orderid_array'} = \@orderid_array;			#get a reference to the orderid_array
$ret_hash->{'sid'} = $sid;						#get the sid
$ret_hash->{'custid'} = $custid;						#get the custid
$ret_hash->{'DISPLAY'}=$FORM{'cur_page'};		#set the page to be displayed
# if no custid or sid send to welcome
$ret_hash->{'func'} = $ret_hash->{'FORM'}->{'func'}; #for some cells a function needs to be set
$ret_hash->{'FORM'}->{'scriptname'}=$scriptname;	#put the scriptname in there



# if we have no sid we have got to move them to the home page

if (!$sid ) {
   print "Status: 302/Moved\n";
   print "Location: http://$site->{'siteeurl'}/cgi-bin/om/inbound.cgi\n\n\n";
   exit 0;
   
}


# if we have no user identification we move them to welcome
if (!$custid ) {
   $welcome_arg = "pg_targ=$site{'siteurl'}/cgi-bin/om/ssl/checkout.cgi";
   print "Status: 302/Moved\n";
   print "Location: http://$site->{'siteurl'}/cgi-bin/om/welcome.cgi?$welcome_arg\n\n\n";
   exit 0;
   
}
print "Content-type: text/html\n";
print "\n\n";
# if no order id pg_shippingaddress
if (!$cur_page ||  !$orderid ) {
   if ($cur_page !~ /address/) {

      $cur_page = $pagelist->{'shippingaddress'}
   }
}

	#print "$cur_page  is curpage<br>";      
# goto currentpage

# mode = mode
# MODES :
#			SHOW
#				This is to tell the cells to permute there stuff and put it into the form
#				part of the ret_hash
#
#			APPROVE
#				This is to tell the cells that they're going to get data to validate
#
# if we don't have a mode given to us the mode is to SHOW


if (!$ret_hash->{'mode'}) { $ret_hash->{'mode'} = 'SHOW';};
# we need to store the mode given to us from the returning data
$mode = $ret_hash->{'mode'};

######
#
# Now we execute the page definitions
# Idealy the page is just a list of cells. Inside the page sub there shouldn't be much
# logic, however some things need to be set for that pages purpose so logic is includes
# to do such.

$ret_hash = &{$cur_page}($ret_hash);


if ($mode eq 'SHOW') {

   # if the checkout script was entered with a SHOW function we only go through the logic once
   
   $page = localize_template($ret_hash->{'template'}, $om_render_lang,"html",0);
   
   $page = permutebit ($page,$ret_hash->{'FORM'});
   $page = permutebit ($page,$site);
   $page = permuteclean ($page);
 $page = permute_include( $page, $om_render_lang, "html", 0);
  
   print $page;
   
   
   
   
   } elsif ($mode eq 'APPROVE') {
   
   # if we got into the checkout script through an approve, we have just finished earlier
   # computing the cells approvals of the data and should have been switched to SHOW to
   # print out the data
   
   # It is up to the pages to tell us what page we want to use when they return the ret_hash
   # to this part of the program. They do this with the DISPLAY part of ret_hash. If there
   # was an error the page should tell us to display its page again, however if there wasn't
   # the page will tell us what page needs to be displayed next.
   
   $ret_hash = &{$pagelist->{$ret_hash->{'DISPLAY'}}}($ret_hash);
   
   $page = localize_template($ret_hash->{'template'}, $om_render_lang,"html",0);

   $page = permutebit ($page,$ret_hash->{'FORM'});
   $page = permutebit ($page,$site);
   
  $page = permuteclean ($page);
  $page = permute_include( $page, $om_render_lang, "html", 0);

   print $page;
}

#}
close ();
sub pg_firstdisplay {


      my ($ret_hash)= $_[0];
      $ret_hash->{'template'} = 'page_checkout_firstdisplay';

	
      if (!$ret_hash->{'orderid'}) {

         
         $f= " SELECT * FROM tcart where sid='$ret_hash->{'sid'}' and custid='$ret_hash->{'custid'}' \n";
         $stf= $dbh->prepare ($f);
         $stf->execute;
         
         
         $z=$stf->fetchrow_hashref;
         $orderid = $z->{'orderid'}; 
         if (!$ret_hash->{'FORM'}->{'ADDRID'}) {
            	if ($ret_hash->{'addrid'}) {
			$ret_hash->{'FORM'}->{'ADDRID'}=$ret_hash->{'addrid'};
		} else {
			$ret_hash->{'FORM'}->{'ADDRID'}=$ret_hash->{'ADDRID'};
	    	}
         } 	# if we have an addrid from the form data we'll put that into the
         # orders table as well
         
         
         
         $q="INSERT into orders ";
         $q.="(objid,sid,custid,shipto,cdate,mdate,status) ";
         $q.=" VALUES ('$orderid','$ret_hash->{'sid'}', '$ret_hash->{'custid'}','$ret_hash->{'FORM'}->{'ADDRID'}',";
         $q.="'$now','$now','15012-A') ";
         $sts = $dbh->prepare( $q );
         $sts->execute;
         $ret_hash->{'orderid'} = $orderid;
	
         push (@{$ret_hash->{'orderid_array'}}, $orderid);
         } else {
         
         foreach $t (@{$ret_hash->{'orderid_array'}}) {
            if (!$ret_hash->{'FORM'}->{'ADDRID'}) {
               $ret_hash->{'FORM'}->{'ADDRID'}=$ret_hash->{'ADDRID'};
            }
            $q = "update orders set SHIPTO = '$ret_hash->{'FORM'}->{'addrid'}' ";
            $q .= ", BILLTO='$ret_hash->{'FORM'}->{'ADDRID'}' " if ($ret_hash->{'FORM'}->{'savetime'} =~ /on/);
            $q .= "where objid = '$t' ";
            $dbh->do($q);
           #print "q is $q t is $t<br>"; 
         }
      }

   if ($ret_hash->{'mode'} eq 'SHOW') {
      $ret_hash->{'func'} = 'firstdisplay';
      $ret_hash = &{$celllist->{'orderlist'}}($ret_hash);

   } elsif ($ret_hash->{'mode'} eq 'APPROVE') {
        $ret_hash->{'func'} = 'firstdisplay';
      $ret_hash = &{$celllist->{'orderlist'}}($ret_hash);  
      $ret_hash->{'mode'}='SHOW'; 
      if (!$ret_hash->{'ERROR'}) {
    
         $ret_hash->{'DISPLAY'} = 'shippingaddress';
      } else {
         $ret_hash->{'DISPLAY'} = 'firstdisplay';
      }
      



   }

   return $ret_hash;
}
sub pg_shippingaddress {
   ###########
   # pg_shippingaddress	Shipping Address Page
   #
   # Requires:
   #	sid
   #	custid
   # 	orderid
   #	state
   # 	FIELDS if orderid contains
   
   # Modes
   #	input		Displays fields, permutes page cell
   #	approve		passes to cell approval process
   
   # Cells
   #	cl_addressbook
   #	cl_addressedit
   
   # Function
   #   when it recieves an addrid from any cell contained within and a success
   #   flag it will insert it into orders and move on to next page.
   
   # Outputs as hashref:
   #	Hash of values
   # 	name of template
   # 	Error conditions
   #   mode
   
   
   my $ret_hash = $_[0];
   $ret_hash->{'addrid_type'} = 'shipto';
   $ret_hash->{'template'} = 'page_checkout_shipping_list';
   if ($ret_hash->{'mode'} eq 'APPROVE') {
      #######
      # ret_hash should now contain all the form info
      # if it doesn't goto show and display old with info if succesfull
      # we should have addrid from cell and can store that in the order
      #
      
      $ret_hash = &{$celllist->{'addressbook'}}($ret_hash);
      # Check for error
      
      if (!$ret_hash{'ADDRID'}) {
         $ret_hash = &{$celllist->{'addressedit'}} ($ret_hash);
      }
      
     
      } elsif ($ret_hash->{'mode'} eq 'SHOW') {
      
      $ret_hash = &{$celllist->{'addressbook'}}($ret_hash);
      $ret_hash = &{$celllist->{'addressedit'}}($ret_hash);
      $ret_hash->{'DISPLAY'} = 'shippingaddress';
      } else {
      
   }
   if (!$ret_hash->{'ERROR'} && $ret_hash->{'mode'} eq 'APPROVE' && ($ret_hash->{'FORM'}->{'addrid'} || $ret_hash->{'addrid'}) && $ret_hash->{'func'} ne 'delete' ) {
      ## it worked
      $ret_hash->{'addrid'} = $ret_hash->{'FORM'}->{'addrid'} if (!$ret_hash->{'addrid'}); 
      $ret_hash->{'mode'} = 'SHOW';
      ## get new orderid if we don't have one
    
            $q = "UPDATE orders set SHIPTO = '$ret_hash->{'FORM'}->{'addrid'}' ";
            $q .= ", BILLTO='$ret_hash->{'FORM'}->{'ADDRID'}' " if ($ret_hash->{'FORM'}->{'savetime'} =~ /on/);
            $q .= "where objid = '$ret_hash->{'orderid'}' ";
            $dbh->do($q);
 
      $q = "SELECT * FROM tcart where sid = '$ret_hash->{'sid'}'";
      $sth=$dbh->prepare($q);
      $sth->execute;
      $rows = $sth->rows;
      if ($rows > 0) {
         for (1..$rows)
         {
            #inventory_reserve($h);
            
         }
      }
      ## now we figure out what our next page is
      if ($ret_hash->{'FORM'}->{'nextpage'}) {
         ## this will be set by a cell
         
         $ret_hash->{'DISPLAY'} = $ret_hash->{'FORM'}->{'nextpage'};
         } else {
         ## our default will be shipping method
         $ret_hash->{'DISPLAY'} = 'shippingmethod';
      }
      } else {
      ## we must have got an error, default to show and lets go back again to
      ##shipping address
      $ret_hash->{'mode'} = 'SHOW';
      $ret_hash->{'DISPLAY'} = 'shippingaddress';
   }
   return $ret_hash;
   
   
}


sub pg_shippingmethod {
   ###########
   # pg_shippingmethod		Shipping Method Page

#
   # Requires:
   #	sid
   #	custid
   #	orderid
   #	state
   #	Fields if orderid active
   
   
   # Function
   #	when it recieves as shipping sku from the cell it will add to an an ordid line in orders
   #	then move to next page. Else it will dispaly an error
   
   # Cells
   #	cl_shippingmethod
   
   # Modes
   #	input
   #	approve
   
   ############
   
   my $ret_hash = $_[0];
   my %backhash = ();
   my %lines = ();
   #my $now;
   $ret_hash->{'template'} = 'page_checkout_shippingmethod';
   #$now = time();
   
   ##create new orderid
   ## What we need to do is go item by item and reserve inventory
   ## and figure out whether we can ship something now or if it
   ## is going to be a backorder
   
   ## First we get teh stuff from the tcart
   

   if ($ret_hash->{'mode'} eq 'SHOW'){
      
       if (!$ret_hash->{'orderid'}) {

         
         $f= " SELECT * FROM tcart where sid='$ret_hash->{'sid'}' and custid='$ret_hash->{'custid'}' \n";
         $stf= $dbh->prepare ($f);
         $stf->execute;
         
         
         $z=$stf->fetchrow_hashref;
         $orderid = $z->{'orderid'}; 
         if (!$ret_hash->{'FORM'}->{'ADDRID'}) {
            	if ($ret_hash->{'addrid'}) {
			$ret_hash->{'FORM'}->{'ADDRID'}=$ret_hash->{'addrid'};
		} else {
			$ret_hash->{'FORM'}->{'ADDRID'}=$ret_hash->{'ADDRID'};
	    	}
         } 	# if we have an addrid from the form data we'll put that into the
         # orders table as well
         
         
         
         $q="INSERT into orders ";
         $q.="(objid,sid,custid,shipto,cdate,mdate,status) ";
         $q.=" VALUES ('$orderid','$ret_hash->{'sid'}', '$ret_hash->{'custid'}','$ret_hash->{'FORM'}->{'ADDRID'}',";
         $q.="'$now','$now','15012-A') ";
         $sts = $dbh->prepare( $q );
         $sts->execute;
         $ret_hash->{'orderid'} = $orderid;
	
         push (@{$ret_hash->{'orderid_array'}}, $orderid);
         } else {
         
         foreach $t (@{$ret_hash->{'orderid_array'}}) {
            if (!$ret_hash->{'FORM'}->{'ADDRID'}) {
               $ret_hash->{'FORM'}->{'ADDRID'}=$ret_hash->{'ADDRID'};
            }
            $q = "update orders set SHIPTO = '$ret_hash->{'FORM'}->{'addrid'}' ";
            $q .= ", BILLTO='$ret_hash->{'FORM'}->{'ADDRID'}' " if ($ret_hash->{'FORM'}->{'savetime'} =~ /on/);
            $q .= "where objid = '$t' ";
            $dbh->do($q);
           #print "q is $q t is $t<br>why oh why"; 
         }
      }


      ## back the routine ... if the mode is show than the shipping method is show
      $ret_hash = &{$celllist->{'shippingmethod'}}($ret_hash);
      
      } elsif ($ret_hash->{'mode'} eq 'APPROVE') {
      # or approve
      $ret_hash = &{$celllist->{'shippingmethod'}}($ret_hash);
   }
   
   if ($ret_hash->{'mode'} eq 'APPROVE') {
      # if we have approve now we need to show
      $ret_hash->{'mode'} = 'SHOW';
      
   }
   if (!$ret_hash->{'ERROR'}) {
      
      
      ## other wise we use ordersummary
      $ret_hash->{'DISPLAY'} = 'ordersummary';
      } else {
      
      ## but if we have an error, we go back to shipping method
      $ret_hash->{'DISPLAY'} = 'shippingmethod';
   }
   return $ret_hash;
   
   
   
   
   
}

sub pg_billpay {
   ###########
   # pg_billpay			Billing address and Payment Page
   #
   # Requires:
   #	sid
   #	custid
   #	orderid
   #	state
   #	Fields
   #	mode
   
   # Modes
   #	input
   #	approve
   
   # Cells
   #	cl_addressenter
   #	cl_addressbook
   #	cl_billpay
   
   # Function
   #	Update billaddress if nescessary
   #	store billing info
   
   
   
   
   my ($orderid);
   my $ret_hash = $_[0];
   $ret_hash->{'template'} = 'page_checkout_billpay';
   $ret_hash->{'addrid_type'} = 'billto';
   if ($ret_hash->{'mode'} eq 'APPROVE') {
      #######
      # ret_hash should now contain all the form info
      # if it doesn't goto show and display old with info if succesfull
      # we should have addrid from cell and can store that in the order
      #
      
      $ret_hash = &{$celllist->{'addressbook'}}($ret_hash);
      
      # Check for error
      $ret_hash->{'FORM'}->{'func'}='billto';
      
      $ret_hash = &{$celllist->{'addressedit'}} ($ret_hash);
      if ($ret_hash->{'ADDRID'}) {$ret_hash->{'FORM'}->{'ADDRID'} = $ret_hash->{'ADDRID'};}
      
	
      if (!$ret_hash->{'ERROR'} && $ret_hash->{'FORM'}->{'addrid'}) {
         ## okay we checked the addesses and got
         ## Success now we save addrid to bilto in orders
         foreach $orderid (@{$ret_hash->{'orderid_array'}}) {
            $q = "update orders set billto = '$ret_hash->{'FORM'}->{'addrid'}' where objid = '$orderid'";
            $dbh->do($q);
         }
      }
      
      
      
      $ret_hash->{'FORM'}->{'func'}='billto';
      if (! $ret_hash->{'ERROR'} ) {
         $ret_hash = &{$celllist->{'orderlist'}}($ret_hash);
      }
      
      
      if (!$ret_hash->{'ERROR'}) {
         
         $ret_hash = &{$celllist->{'billpay'}} ($ret_hash);
         
      }
      if (!$ret_hash->{'ERROR'}) {
	 $ret_hash =  &{$celllist->{'orderapprove'}} ($ret_hash);   
      
      }







      } elsif ($ret_hash->{'mode'} eq 'SHOW') {
      
      ## we have four cells on this page
      ## addressbook, orderlist, addressedit and billpay
      
      $ret_hash = &{$celllist->{'addressbook'}}($ret_hash);
      
      #$ret_hash = &{$celllist->{'orderlist'}} ($ret_hash);
      
      $ret_hash = &{$celllist->{'addressedit'}} ($ret_hash);

      
      $ret_hash = &{$celllist->{'billpay'}} ($ret_hash);
      

      $ret_hash = &{$celllist->{'orderapprove'}} ($ret_hash);    
      
      
      
      } else {
      ## bad if we get here as we default to SHOW if no mode is found
   }
   
   # Insert cell handling
   
   ## same next page handling as before
   ## no errror we go to orderapprove else
   ## we go back, with the exception being we
   ## can say what page we want to go to next
   
   if ($ret_hash->{'mode'} eq 'APPROVE') {
      $ret_hash->{'mode'} = 'SHOW';
  
  
           
      
      if ($ret_hash->{'ERROR'} =~ /success/){
         
         
         foreach $order ( @{$ret_hash->{'orderid_array'}} ) {
            my %FORM = %{$ret_hash->{'FORM'}};
            &tcart_to_ocart($ret_hash->{'sid'},$order,$ret_hash->{'custid'}, $nextwh, $testing ); #
            $q = "UPDATE orders SET status='15020-A' where objid = '$order'";       
            $dbh->do($q);
            #print "$q is q <br>";
            #create an event with a success in the dvalue
            $l="SELECT  wh FROM tcart where orderid='$order' ";
            $stl=$dbh->prepare($l);
            $stl->execute;
            $numl=$stl->rows;
            ($wh)=$stl->fetchrow;
            if (!$sidwh) {
               $sidwh=$wh;
            }
            $dvalue=$order."\t".$ret_hash->{'cyberoid'}."\tno\tuc\t".$ret_hash->{'STATUSDVALUE'};
            $l="insert into levents (DTABLE,DVALUE,CDATE,custid) values('orders','$dvalue','$now','$ret_hash->{'custid'}') ";
            $stl=$dbh->prepare($l);
            $stl->execute;
            $ok_proceed=1;
            
            
            
            $q="Select WH FROM ocart where orderid = '$order'";
            $sth=$dbh->prepare($q);
            $sth->execute;
            $num=$sth->rows;
            for (1 .. $num) {
               $wh = $sth->fetchrow;
               $wh_hash->{$order}->{$wh} = 1;
            }
         }
         
     ## myhome to clip what do we do here TODO    
         foreach $o (keys %{$wh_hash}) {
            foreach $w (keys %{$wh_hash->{$o}}) {
               if ($wh_hash->{$o}->{$w} == '1') {
                  
                  `/www/sites/myhome/crons/xml_order_export.pl myhome $o`;
                  } else {
                  `/www/sites/myhome/crons/email_order_export.pl myhome $o`;
               }
            }
         }
         
         
         
         if ($ret_hash->{'FORM'}->{'next_page'}) {
            $ret_hash->{'DISPLAY'} = $ret_hash->{'FORM'}->{'nextpage'};
            } else {
            $ret_hash->{'DISPLAY'} = 'orderconf';
         }
         } else {
         if($ret_hash->{'ERROR'} =~ /REFUSAL/)
         {
            # the card was refused
            # the user shouldn't bother re-entering data and
            # trying again
            @error_array = split /\t/ , $ret_hash->{'ERROR'};
            $ret_hash->{'FORM'}->{'PAYMENT_err'}=$error_array[3];
            $ret_hash->{'DISPLAY'} = 'billpay';
         }
         elsif($ret_hash->{'ERROR'} =~ /DATA_ERROR/)
         {
            
            @error_array = split /\t/ , $ret_hash->{'ERROR'};
            $ret_hash->{'FORM'}->{'PAYMENT_err'}=$error_array[3];
            
            # customer may have entered bad data
            # ask them to try again
            $ret_hash->{'DISPLAY'} = 'billpay';
         }
         elsif($ret_hash->{'ERROR'} =~ /SYSTEM_ERROR/)
         {
            @error_array = split /\t/ , $ret_hash->{'ERROR'};
            $ret_hash->{'FORM'}->{'PAYMENT_err'}=$error_array[3];
            # there was a server problem with the transaction
            # the user shouldn't bother re-entering data and
            # trying again
            $ret_hash->{'DISPLAY'} = 'billpay';
         }
         
      }


 }
return $ret_hash;
   
   
   
   
   
   
   
   
}
sub pg_ordersummary {
   ## very simple page here, no approve just a display cell
   ## we set up the func to billto and run orderlist
   
   
   
   
   my $ret_hash = $_[0];
   $ret_hash->{'template'} = 'page_checkout_ordersummary';
   
   if ($ret_hash->{'mode'} eq 'SHOW') {
      $ret_hash->{'FORM'}->{'func'} = 'billto';
      $ret_hash =  &{$celllist->{'orderlist'}} ($ret_hash);
      
      } elsif ($ret_hash->{'mode'} eq 'APPROVE') {
      $ret_hash->{'mode'} = 'SHOW';
      
      $ret_hash->{'DISPLAY'} = 'billpay';
   }
   return $ret_hash;
}







sub pg_orderapprove {
   ###########
   # pg_orderapprove 		Billing list for approval
   #
   # Requires:
   #	sid
   #	custid
   #	orderid
   #	state
   #	Fields
   #	mode
   
   # Modes
   #	list
   #	approve
   
   # Cells
   #	cl_orderdisp
   
   # Function
   #	when aprove, check through payment.pm
   
   ###########
   
   
   ## this is a more indepth page as we need to handle different error messages
   ## then if everything is good, finish the order off
   
   my ($tmp_template);
   
   my $ret_hash = $_[0];
   #my $now;
   #$now=time();
   $ret_hash->{'template'} = 'page_checkout_orderapprove';
   
   if ($ret_hash->{'mode'} eq 'SHOW') {
      
      ## the show bit is pretty simple here, just show the order list
      ## and the approve button
      
      $ret_hash->{'FORM'}->{'func'} = 'APPROVE';
      $ret_hash=&{$celllist->{'orderlist'}} ($ret_hash);
      
      $ret_hash=&{$celllist->{'orderapprove'}} ($ret_hash);
      
      } elsif ($ret_hash->{'mode'} eq 'APPROVE') {
      
      $ret_hash = &{$celllist->{'orderapprove'}} ($ret_hash);
      
   }
   
   if ($ret_hash->{'mode'} eq 'APPROVE') {
      
      $ret_hash->{'mode'} = 'SHOW';
      
           
      
      if ($ret_hash->{'ERROR'} =~ /SUCCESS/){
         
         
         foreach $order ( @{$ret_hash->{'orderid_array'}} ) {
            my %FORM = %{$ret_hash->{'FORM'}};
            &tcart_to_ocart($ret_hash->{'sid'},$order,$ret_hash->{'custid'}, $nextwh, $testing ); #
            
            
            #create an event with a success in the dvalue
            $l="SELECT  wh FROM tcart where orderid='$order' ";
            $stl=$dbh->prepare($l);
            $stl->execute;
            $numl=$stl->rows;
            ($wh)=$stl->fetchrow;
            if (!$sidwh) {
               $sidwh=$wh;
            }
            $dvalue=$order."\t".$ret_hash->{'cyberoid'}."\tno\tuc\t".$ret_hash->{'STATUSDVALUE'};
            $l="insert into levents (DTABLE,DVALUE,CDATE,custid) values('orders','$dvalue','$now','$ret_hash->{'custid'}') ";
            $stl=$dbh->prepare($l);
            $stl->execute;
            $ok_proceed=1;
            
            
            
            $q="Select WH FROM ocart where orderid = '$order'";
            $sth=$dbh->prepare($q);
            $sth->execute;
            $num=$sth->rows;
            for (1 .. $num) {
               $wh = $sth->fetchrow;
               $wh_hash->{$order}->{$wh} = 1;
            }
         }
         
     ## myhome to clip what do we do here TODO    
         foreach $o (keys %{$wh_hash}) {
            foreach $w (keys %{$wh_hash->{$o}}) {
               if ($wh_hash->{$o}->{$w} == '1') {
                  
                  `/www/sites/myhome/crons/xml_order_export.pl myhome $o`;
                  } else {
                  `/www/sites/myhome/crons/email_order_export.pl myhome $o`;
               }
            }
         }
         
         
         
         if ($ret_hash->{'FORM'}->{'next_page'}) {
            $ret_hash->{'DISPLAY'} = $ret_hash->{'FORM'}->{'nextpage'};
            } else {
            $ret_hash->{'DISPLAY'} = 'orderconf';
         }
         } else {
         if($ret_hash->{'ERROR'} =~ /REFUSAL/)
         {
            # the card was refused
            # the user shouldn't bother re-entering data and
            # trying again
            @error_array = split /\t/ , $ret_hash->{'ERROR'};
            $ret_hash->{'FORM'}->{'PAYMENT_err'}=$error_array[3];
            $ret_hash->{'DISPLAY'} = 'billpay';
         }
         elsif($ret_hash->{'ERROR'} =~ /DATA_ERROR/)
         {
            
            @error_array = split /\t/ , $ret_hash->{'ERROR'};
            $ret_hash->{'FORM'}->{'PAYMENT_err'}=$error_array[3];
            
            # customer may have entered bad data
            # ask them to try again
            $ret_hash->{'DISPLAY'} = 'billpay';
         }
         elsif($ret_hash->{'ERROR'} =~ /SYSTEM_ERROR/)
         {
            @error_array = split /\t/ , $ret_hash->{'ERROR'};
            $ret_hash->{'FORM'}->{'PAYMENT_err'}=$error_array[3];
            # there was a server problem with the transaction
            # the user shouldn't bother re-entering data and
            # trying again
            $ret_hash->{'DISPLAY'} = 'orderapprove';
         }
         
      }
   }
   return $ret_hash;
   
   
   
}

sub pg_orderconf {
   ###########
   # pg_orderconf			Order Confermation
   #
   # Requires:
   #	sid
   #	custid
   #	orderid
   #	state
   #	fields
   #	mode
   
   # Modes
   #	list
   #	approve
   
   # Cells
   #	cl_orderconf
   
   # Functions
   #	notifyorder
   
   # Function
   #
   
   ############
   
   my $ret_hash = $_[0];
   $ret_hash->{'template'} = 'page_checkout_order_conf';
   
   if ($ret_hash->{'mode'} eq 'SHOW') {
      $tmp_form = '';
      foreach (@{$ret_hash->{'orderid_array'}}) {
         $ret_hash->{'orderid'}=$_;
         $tmp_form = sendemail ($ret_hash);
         
         $remplate = localize_template('cell_ck_finaldisp', $om_render_lang,"html",0);
         $tmp_form->{'storeurl'}=$site->{'storeurl'};
         
         $ret_hash->{'FORM'}->{'textarea'}.= permutebit($remplate,$tmp_form);
      }
   }
   
   
   
   if (!$ret_hash->{'ERROR'} && $ret_hash->{'mode'} eq 'approve') {
      
      $ret_hash->{'mode'} = 'SHOW';
      
      
      if ($ret_hash->{'FORM'}->{'next_page'}) {
         $ret_hash->{'DISPLAY'} = $ret_hash->{'FORM'}->{'nextpage'};
         } else {
         $ret_hash->{'DISPLAY'} = 'shippingmethod';
      }
   }
   return $ret_hash;
   
   
   
}


sub pg_addressenter {
   ############
   # pg_addressenter		Address Enter Page
   #
   # Requires:
   #	sid
   #	custid
   #	orderid
   #	state
   #	fields
   #	mode
   #
   
   # Modes
   #	list
   #	approve
   
   # Cells
   # 	Address Enter
   
   # Function
   #	Page to enter to change addresses anywhere
   
   my $ret_hash = $_[0];
   $ret_hash->{'template'} = 'page_checkout_addressenter';
   if ($ret_hash->{'mode'} eq 'SHOW') {
      $ret_hash = &{$celllist->{'addressedit'}}($ret_hash);
      
      
   }
   
   if ($ret_hash->{'mode'} eq 'APPROVE') {
      $ret_hash = &{$celllist->{'addressedit'}}($ret_hash);
   }
   if ($ret_hash->{'mode'} eq 'APPROVE') {
      
      $ret_hash->{'mode'} = 'SHOW';
      
      if (!$ret_hash->{'ERROR'}) {

		## I don't know why we would need another here, but I better check to make sure I must
		## have put it in for some reason

         if (!$ret_hash->{'orderid'}) {
            my $orderid;
           
            
            $f= " SELECT * FROM tcart where sid='$FORM{'sid'}' and custid='$FORM{'custid'}' \n";
            $stf= $dbh->prepare ($f);
            $stf->execute;
            
            
            $z=$stf->fetchrow_hashref;
            $orderid=$z->{'orderid'};
            push (@{$ret_hash->{'orderid_array'}}, $orderid);        
            $q="INSERT into orders ";
            
            $q.="(objid,SID,custid,$ret_hash->{'func'},cdate,mdate,status) ";
            $q.=" VALUES ('$orderid','$ret_hash->{'sid'}', '$ret_hash->{'custid'}','$ret_hash->{'FORM'}->{'addrid'}',";
            $q.="'$now','$now','ck') ";
            $sts = $dbh->prepare( $q );
            $sts->execute;
            $ret_hash->{'orderid'} = $orderid;
            
            } else {
            
            foreach $t (@{$ret_hash->{'orderid_array'}}) {
               
               $q = "update orders set $ret_hash->{'func'} = '$ret_hash->{'FORM'}->{'addrid'}' where objid = '$t' ";
               $dbh->do($q);
           #    print "ARGH $q<br>";
            }
         }
         
         
         if ($ret_hash->{'FORM'}->{'nextpage'})  {
            $ret_hash->{'DISPLAY'} = $ret_hash->{'FORM'}->{'nextpage'};
            } else {
            if ($ret_hash->{'FORM'}->{'func'} eq 'shipto') {
               $ret_hash->{'DISPLAY'} = 'shippingaddress';
               } else {
               $ret_hash->{'DISPLAY'} = 'billpay';
            }
         }
         } else {
         $ret_hash->{'DISPLAY'} = 'addressenter';
      }
   }
   return $ret_hash;
   
   
   
}




sub printtolog {
   
   my ($hash);
   $hash = $_[0];
   foreach $k (keys %{$hash}) {
      print  "key is $k val is $hash->{$k}<br>";
   }
}












sub sendemail {
   
   ## Local Vars:
   #     $thisord - hashref to entry from orders
   #     $formrows - hashref to order line items
   #
   # Copied from Checkout .0.7
   my($ret_hash, $u,$a,$o,%alist,$num,$q,$hi,$discount,$sts,$thisord,$temp );
   ## load the order information
   #
   $ret_hash = $_[0];
   $FORM = $ret_hash->{'FORM'};
   $FORM{'orderid'} = $ret_hash->{'orderid'};
   $FORM{'custid'} = $ret_hash->{'custid'};


   $q='SELECT * FROM orders where objid=';
   $q.="'$ret_hash->{'orderid'}' ";
   $sts = $dbh->prepare( $q );

   $sts->execute;
   if ( $sts->rows > 0 ) {
      $thisord=$sts->fetchrow_hashref;  #later figure lineid's
      } else {                              # this is an error
      $thisord={};
      $FORM{'page_err'}.="Order $ret_hash->{'orderid'} not found! \n";
   } # done loading order from tables...



   ##saved info
   ## construct order summary cells
   #
   $myhome_orderid = $ret_hash->{'orderid'};
   $u=localize_template("cell_ck_300_finallist", $om_render_lang, "html",0);
   $tfl=localize_template("cell_ck_text_finallist", $om_render_lang, "html",0);


   $q='SELECT * FROM ocart where orderid='."'$ret_hash->{'orderid'}'";
   $sts = $dbh->prepare( $q );
   $sts->execute;
   
   $num=$sts->rows;
   $j=0;
   $discount=0;
   foreach (1..$num) {
      $h = $sts->fetchrow_hashref;
    
      $q="SELECT title,objclass FROM things where objid='$h->{'lineobjid'}'";
      $sth = $dbh->prepare( $q );
      $sth->execute;
      if ( $sth->rows==1 ) {
         ($h->{'title'},$h->{'objclass'}) =  $sth->fetchrow ;
      } # done getting the title...

      ## Class diplay issues
      if ($h->{'objclass'} eq '140-A') { #shipping method
         $thisord->{'shipcost'} = $h->{'linetotal'};
         $thisord->{'ship_via'} = $h->{'title'};
         next;
      } elsif ($h->{'objclass'} ne '134-A') {
         next;
      }


      $o.= permutebit( $u, $h );
      $discount += $h->{'linetotal'} if ($h->{'objclass'} eq 'PRO');
      $txt.= permutebit( $tfl, $h );
      $txt[$j]=$h;
      $j++;
   } #
   $thisord->{'custid'} = $FORM{'custid'};
   ## now have tax, subtotal,etc..
   #

   ## we need the users email address

   $q = "SELECT u_email FROM contacts where objid='$ret_hash->{'custid'}'";
   $sth=$dbh->prepare($q);
   $sth->execute;
   if ($sth->rows > 0) {
      $thisord->{'u_email'} = $sth->fetchrow;
   }

   $FORM{'cell_ck_finallist'}=$o;
   $FORM{'cell_ck_text_finallist'}=$txt;
   $thisord->{'subtotal'}=$thisord->{'st_nontax'} + $thisord->{'st_taxable'}+$discount;
   $thisord->{'subtotal_disc'}=$thisord->{'subtotal'} ;
   ## fix number of zeros after the decimal point for some fields
   #


   $thisord->{'taxraten'}=$thisord->{'taxrate'};
   foreach $k ( "subtotal_disc", "st_nontax","st_tax","shipcost","ordtotal","subtotal", "st_taxable", "taxraten" ) {
      $thisord->{$k} = nicedecimals( $thisord->{$k});
   } # done with decimal point cleanup...


   $thisord->{'SHIPCOST'}="Free!" if ( ($thisord->{'SHIPCOST'}/1) == 0 );
   if ($thisord->{'SHIPCOST'} > 0) {
      $thisord->{'SHIPCOST'}="\$".$thisord->{'SHIPCOST'};
   }
   
   $thisord->{'subtotal1'}=$FORM{'subtotal1'};
   #$FORM{'TAXRATEN'}.="%";
   ## now the body of the order
   #
      
   if ( length($thisord->{'CCID'}) < 5) {
      $thisord->{'CCID'}="N/A";
      $thisord->{'CCEXPMO'}="N";
      $thisord->{'CCEXPYR'}="A";
   }
   


   ## permute the HTML Page

   $thisord->{'OID'} = $myhome_orderid;
   
   $thisord->{'custid'} = $FORM{'custid'};
   $o=localize_template("cell_ck_300_finalhdr", $om_render_lang, "html",0);
   $FORM{'cell_ck_finalhdr'} = permutebit( $o, $thisord );
   $o=localize_template("cell_ck_300_subtotal", $om_render_lang, "html",0);
   $FORM{'cell_ck_subtotal'} = permutebit( $o, $thisord );
   $o = localize_template("cell_ck_300_taxtotal", $om_render_lang, "html",0);
   $FORM{'cell_ck_taxtotal'} = permutebit( $o, $thisord );
   $o = localize_template("cell_ck_300_shipcost", $om_render_lang, "html",0);
   $FORM{'cell_ck_shipcost'} = permutebit( $o, $thisord );
   $o = localize_template("cell_ck_300_totalcost", $om_render_lang, "html",0);
   $FORM{'cell_ck_totalcost'} = permutebit( $o, $thisord );
   $o = localize_template("cell_ck_300_subtotal_discount", $om_render_lang, "html",0);
   $FORM{'cell_ck_subtotal_discount'} = permutebit( $o, $thisord );
   
   $FORM{'perdiscount'}=100*(1-$discount);
   #	$FORM{'cell_ck_final_discount'}=permutebit($FORM{'cell_ck_300_final_discount'},\%FORM);
   
   if ($discount==1.00) {
      $FORM{'cell_ck_final_discount'}="";
      $FORM{'cell_ck_subtotal_discount'}="";
   }
   
   
   ## now format the text template page
   #
   $txt = localize_template("cell_ck_text_giftcert", $om_render_lang, "html",0);
   $FORM{'cell_ck_text_giftcert'} = permutebit( $txt, $thisord );
   $txt = localize_template("cell_ck_text_subtotal", $om_render_lang, "html",0);
   $FORM{'cell_ck_text_subtotal'} = permutebit( $txt, $thisord );
   $txt = localize_template("cell_ck_text_subtotal", $om_render_lang, "html",0);
   $FORM{'cell_ck_text_subtotal'} = permutebit( $txt, $thisord );
   $txt = localize_template("cell_ck_text_taxtotal", $om_render_lang, "html",0);
   $FORM{'cell_ck_text_taxtotal'} = permutebit( $txt, $thisord );
   $txt = localize_template("cell_ck_text_shipcost", $om_render_lang, "html",0);
   $FORM{'cell_ck_text_shipcost'} = permutebit( $txt, $thisord );
   $txt = localize_template("cell_ck_text_totalcost", $om_render_lang, "html",0);
   $FORM{'cell_ck_text_totalcost'} = permutebit( $txt, $thisord );
   #	$txt = localize_template("cell_ck_text_subtotal_discount", $om_render_lang, "html",0);
   #	$FORM{'cell_ck_text_subtotal_discount'} = permutebit( $txt, $thisord );
   
   if ($discount==1.00) {
      #		$FORM{'cell_ck_text_subtotal_discount'}="";
   }
   
   ## the payment information cell...
   #     and all it's little bits...
   $FORM{'cell_ck_300_ccinfo'} =
   localize_template("cell_ck_300_ccinfo", $om_render_lang, "html",0);
   $FORM{'cell_ck_300_ccinfo'} = permutebit( $FORM{'cell_ck_300_ccinfo'}, $h );
   ## done constructing the payment cell...
   ## payment info is not sent via email
   ## the billing address cell


   $q="SELECT * FROM addresses where objid='$thisord->{'billto'}' ";
   $stc = $dbh->prepare( $q );
   $stc->execute;
   $bhp= $stc->fetchrow_hashref;
   ($fname,$lname,$ltite) = split /\|/, $bhp->{'name'};
   $bhp->{'name'} = $ltite . ' ' .$fname .' '. $lname;
   #print "q is $q<br>"; 
   if ( $stc->rows == 1 ) {
      $FORM{'cell_ck_billaddr'} =
      localize_template("cell_ck_text_displayaddr", $om_render_lang, "html",0);
      $FORM{'cell_ck_text_billaddr'} =
      localize_template("cell_ck_text_displayaddr", $om_render_lang, "html",0);
      $FORM{'cell_ck_billaddr'} =
      permutebit( $FORM{'cell_ck_billaddr'}, $bhp );
      $FORM{'cell_ck_text_billaddr'} =
      permutebit( $FORM{'cell_ck_text_billaddr'}, $bhp );
   } # end of address load
   ## the shipping address cell
   $q="SELECT * FROM addresses where objid='$thisord->{'shipto'}' ";

   $stc = $dbh->prepare( $q );
   $stc->execute;
   $shp= $stc->fetchrow_hashref;
   ($fname,$lname,$ltite) = split /\|/, $shp->{'name'};
   $shp->{'name'} = $ltite . ' ' .$fname .' '. $lname;
   
   
   
   if ( $stc->rows == 1 ) {
      $FORM{'cell_ck_shipaddr'} =
      localize_template("cell_ck_text_displayaddr", $om_render_lang, "html",0);
      $FORM{'cell_ck_text_shipaddr'} =
      localize_template("cell_ck_text_displayaddr", $om_render_lang, "html",0);
      $FORM{'cell_ck_shipaddr'} =
      permutebit( $FORM{'cell_ck_shipaddr'}, $shp );
      $FORM{'cell_ck_text_shipaddr'} =
      permutebit( $FORM{'cell_ck_text_shipaddr'}, $shp );
   } # end of address load
   
   $FORM{'cell_ck_shipcost'} = permutebit( $FORM{'cell_ck_shipcost'}, \%FORM );
   
   
   # end of ship method
   $q= "SELECT title FROM things where objid='$FORM{'DELIVERY'}' ";
   $stc = $dbh->prepare( $q );
   $stc->execute;
   $spm= $stc->fetchrow_hashref;
   if ( $stc->rows == 1 ) {
      $FORM{'DELIVERY'} = "$spm->{'TITLE'}";
   } # end of ship method
   $textpage=localize_template("page_ck_text" , $om_render_lang, "html",0);
   $textpagebot=localize_template("page_ck_text_bottom", $om_render_lang, "html",0);
   ## spit the file to stdout
   #
   $FORM{'storename'}=$site->{'storename'};
   $textpage = permutebit( $textpage, \%FORM );
   $textpage = permutebit( $textpage, $store_env );
   $textpage = permutebit( $textpage, \%ENV );
   $textpage=permutebit($textpage,$thisord);
   $textpagebot=permutebit( $textpagebot, \%FORM);
   $textpagebot=permutebit( $textpagebot, $store_env );
   $textpagebot=permutebit( $textpagebot, \%ENV );
   $textpagebot=permutebit( $textpagebot, $thisord);
   $textpagebot=permuteclean( $textpagebot );
   $nothing="            ";
   $textpage=~ s/<PRE>/$nothing/gms;
   ## load remaining ORDER vars into FORM
   foreach ( keys %{$thisord} ) {
      $FORM{$_} = $thisord->{$_};
   };
   
  # open( FO, ">/www/sites/myhome/orders/$FORM{'orderid'}.html" );
  # print FO "$textpage";
  # close(FO);
   ## send the email to customer and orders
   
   $mailprog = '/usr/sbin/sendmail';
   $title= "Your $site->{'storename'} order";
   # Open The Mail Program
#   open(MAIL,"|$mailprog -t");
   open(MAIL,">/tmp/email.txt");
   print MAIL "To: $FORM{'u_email'} \n";
   print MAIL "From: $site->{'customer_service_email_address'}\n";
   print MAIL "Bcc: $site->{'order_email_address'}\n";
   print MAIL "Subject: $title\n\n";
   print MAIL "$textpage\n";
   print MAIL "SKU        \tQty\tPrice\tProduct\n\n";
   foreach $line (@txt) {
      print MAIL "$line->{'SKU'}$line->{'VCODE'}\t$line->{'QUANT'}\t\$$line->{'UNITPR'}\t$line->{'TITLE'}\n";
      if ($line->{'SKU'} =~ /gct/ ) {
         push @giftemail, $line;
      }
   }
   $textpagebot=~ s/<BR>//gms;
   print MAIL "\n\n$textpagebot\n";
   close (MAIL);
   
   return \%FORM;
   
   
   
} #/make_pg_4

