#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999,2000 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

#####
# state.pm
#    RF 981204
#
# customer state management operations
# these assume connection parameters of site.6.pm +
#
#####

###
# 
# Version 0.7.46 GF 20000521
#   cartaddcheck classes for wishlist
# Version 0.7.38 GF 20000516
#   squashed variants into things
# Version 0.7.36 GF 20000507
#   changed vsku to msku,vcode
# Version 0.7.36 GF 20000507
#   cartclass in cartaddcheck
# Version 0.7.35 GF 20000504
#   cartaddcheck takes an objid
# Version 0.7.34 GF 20000426
#   cartaddcheck
# Version 0.7.33 IB 20000420
#   select->SELECT, insert->INSERT, update->UPDATE, set->SET
# Version 0.7.32 JC 20000420
#   added support more additional databases
# Version 0.7.31 GF 20000417
#   UID->CUSTID and miscellaneous changes
# Version 0.7.30 GF 20000414
#   cartaddcheck - working with 0_9
# Version 0.7.29 JC 20000331
#    correction on insertid entry
# Version 0.7.28 JC 20000330
#    insertid change
# Version 0.7.27 JC 20000330
#    changed connect statement
# Version 0.7.26 JC 20000330
#    changed DBI prepare/connect
# Version 0.7.25 IB 20000303
#    commented out a useless statement
# Version 0.7.24 IB 20000302
#    removed -w
# Version 0.7.23 IB 20000229
#    changed table to database
# Version 0.7.22 IB 20000226
#    changed store to site
# Version 0.7.21 JN 20000201
#    fixed multiple wishlist entries
# Version 0.7.20 IB 20000128
#    removed the ERLOG
# Version 0.7.19 JN 20000127
#    fixed bugs in previous version
# Version 0.7.18 JN 20000124
#    added tcart_to_pcart, pcart_to_tcart for wishlist
#    modified cartaddcheck for registry and wishlist
#    modified tcart_to_ocart for registry
# Version 0.7.17 JZ 20000114
#    fixed dvalue match
# Version 0.7.16 RF 000112
#    removed calls to the %FORM global in setsessionid()
# Version 0.7.15 IB 991217
#    removed the ERLOG 
# Version 0.7.14 IB 991115
#    remove commented out statements
# Version 0.7.13 IB 991110
#    replaced $store with $site     
# Version 0.7.12 IB 991027
#    changed setsessionid to return sid > 0 or 0
#    eliminated references to csid
# Version 0.7.11 RF 991022
#    cleanup of some excessive print statements
#    minor process cleanup of setsessionid()
# Version 0.7.8 SH 990801
#    included vcode into inventory cartaddcheck query
#    fixed error messages dropping quant requested
# Version 0.7.7 RF 990831
#    updated 'insertid' to 'mysql_insertid' on 788
# Versiom 0.7.3 GF 990830
#   added in subroutine for shipping method logic
# Version 0.7.2 GF 082899
#    SH swithced rowid back to line id
#    GF in process of revamping
#    Debugging JIT inventory, socheata what have you done here
#    cartaddcheck removed some wh stuff 
# Version 0.7.1 RF 990827
#    created new_eventid( \%h ): \%h -
#        grabs next available eventid and writes preliminary record
# Version 1 RF 981204
###


## new_eventid( \%h ): \%h - allocates and returns an eventid
#
#     Created 0.7.1 - 990827 RF
#     Input hashref:
#         series
#         dtable
#         ekind
#         process
#         status
#         dvalue
#
#     Returned hashref:
#         event
#         errors
#         series
#         dtable
#         ekind
#         process
#         status
#         dvalue
#         cdate
#
sub new_eventid {
    my( $hi,$ho,$n );

    $h=$_[0];                   # inbound hashref
    $o={};                      # outbound hashref
    ## check for database connect string
    #

    ## TBD - this is a stub
    #
    $o=$h;

    # return
    return $o;
} #/new_eventid 


## get_promotion(sid) - spits back HTML for promotion explanation
#
sub get_promotion {
   my(@temp,$now,$rs,$qt,$rd,$q,$uid,$num,$sts,$sid,$adbuy);
   $sid=$_[0];
   $now=time();
   $rs="";          # default return string   

   if ( $sid<100 ) {
      return $rs;
   } # done with short circuit
 
   ## establish connection to the database
   #
   $s="$site->{'db_site_config'}";
   $dbs=DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});
   
   $q="SELECT ADBUY,UID from sessions where SID=$sid";
   $sts = $dbs->prepare( $q );
   $sts->execute;
   $num=$sts->rows;
   if ( $num==1 ) {
      # exactly one row, good
      ( $adbuy,$uid ) = $sts->fetchrow; 
   } else { 
      # no rows or too many...
      $adbuy="";
      $uid="";
   } # done determining good sid or not

   ## now need to check on adbuy...
   if ( $adbuy =~ /^xpr/ ) {
      ## A promotional discount
      #
      ## HACK just two fork decision for now, replace with query later
      if ( $adbuy =~ /xprg0003/ ) {    # valentines day
         $rs="<center><b>presents.com welcomes our ";
         $rs.="return customers with a \$10 discount</b></center>";
      } else {                         # ewallet
         $rs="<center><b>presents.com welcomes our ";
         $rs.="eWallet customers with a \$10 discount</b></center>";
      } # done
      ## now check the scart, this should ONLY be called from cart.cgi
      #
      $q="SELECT SKU,QUANT,LINEID from tcart where SID=$sid and SKU='$adbuy'";
      $sts = $dbs->prepare( $q );
      $sts->execute;
      $num=$sts->rows;
      ## check for multiple items first, kill all then allow insert to run
      #
      if ( $num>1 ) {        # kill them all!!
         $q="DELETE from tcart where SID=$sid and SKU='$adbuy'";
         $dbs->do( $q );
         $num=0;            # now there ARE none
      } # done killing all promotional discounts
      ##
      if ($num==1) {         # ok, they have the discount
         ( $sku,$qt,$rd ) = $sts->fetchrow;
         if ( $qt!=1 ) {     # um, there should be quant just one...
            $q="UPDATE tcart SET QUANT=1 where CARTID=$rd ";
            $dbs->do($q);
         } # done adjusting quantity
      } else {  # they need it added
         $q="INSERT INTO tcart (LINEID,SID,SKU,VARIANT,QUANT,CDATE,MDATE) ";
         $q.=" VALUES (0,$sid,'$adbuy','--',1,$now,$now) ";
         $dbs->do( $q );
      } # done with permutations on how many discounts in cart...

   } # done with eWallet promo
   #
   $sts->finish;
   return $rs;  
} #/get_promotion



## sidtouid(sid):uid - takes a sid and returns the UID
#
sub sidtouid {
   my($sid,$dbc,$dbs,$sts,$stc,$num,$q,$rv);
   $sid = $_[0];
   $rv="";

   if ( $sid < 0 ) {  # error! no sid!
      $rv="ERROR - NO SID!";
      return $rv;
   } # don't bother to proceed if no sid
  
   ## establish connection to the database 
   #
   $s="$site->{'db_site_config'}";
   $dbs=DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});
   
   $q="SELECT UID from sessions where SID='$sid' ";
   $sts = $dbs->prepare( $q );
   $sts->execute;
   if ( $sts->rows == 1 ) {
      $rv = ( $sts->fetchrow )[0];
   } else {
      $rv="ERROR - no record of session $sid";
   } # done looking up the uid from the sid

   # cleanup
   $sts->finish;
   $dbs->disconnect;
   return $rv;
} #/sidtouid



## tcart_to_ocart(sid) : $s - moves items from tcart to ocart
#     returns a string stating how many items were moved
#
sub tcart_to_ocart {
   my($dvalue,$event, $y, $row, $sidwh, $nextwh, $l, $olineid, $series, $sid,$dbc,$dbs,$sts,$stc,$num,$q,$rv,$h,$now,$oid,$test,$tst, $sto, $o, $c);
   ( $sid,$oid,$sidwh,$nextwh,$test ) = @_;   # session id and order id as args
   $rv="";
   $now=time();
 
   if ( $test ) {
      $tst="xt";             # testing line status
   } else {
      $tst="pl";             # normal placed order status
   } # done with determining order line status to use

   if ( $sid < 0 ) {  # error! no sid!
      $rv="Error - No Session ID! Nothing transfered from ccart!";
      return $rv;
   } # don't bother to proceed if no sid
  
   ## establish connection to the database 
   #
   $s="$site->{'db_site_config'}";
   $dbs=DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

   ## run through ccart rows and create scart rows, adding inventory
   #    back to stock for hard inventory items
   #
   $q='SELECT * from tcart where ';
   $q.="SID='$sid' and oid='$oid' ";
   $sts = $dbs->prepare( $q );
   $sts->execute;
   $num=$sts->rows;

 
   foreach $row ( 1..$num ) {
      ## there are rows to move... 
      $h=$sts->fetchrow_hashref;

	  
      $q="INSERT INTO ocart (CARTID,OID,SID,UID,SKU,VCODE,QUANT,";
      $q.="HQUANT,SQUANT,UNITPR,UNITWT,TAXABLE,LINETOTAL,LINEID,STATUS,CDATE,MDATE,WH) ";
      $q.=" values ";
      $q.="('$h->{'CARTID'}','$oid','$sid','$h->{'UID'}','$h->{'SKU'}','$h->{'VCODE'}',";
      $q.="'$h->{'QUANT'}','$h->{'HQUANT'}','$h->{'SQUANT'}','$h->{'UNITPR'}',";
      $q.="'$h->{'UNITWT'}','$h->{'TAXABLE'}','$h->{'LINETOTAL'}','$h->{'LINEID'}','$tst','$now','$now','$h->{'WH'}' )"; 
      $dbs->do( $q );

      ###
      # Inserted for Registry JN 20000124

      if ($h->{'CARTKIND'} eq "REG") {
 
         $q = "SELECT CQUANT from pcart where cartid='$h->{'CARTID'}' and SKU = '$h->{'SKU'}' and VCODE = '$h->{'VCODE'}'";
 
         $sth = $dbs->prepare($q);
         $sth->execute;
 
         $innum = $sth->rows;
 
         if ($innum == 1) {
            $qu = $sth->fetchrow;
            $qu += $h->{'QUANT'};
         }
         $q = "UPDATE pcart SET CQUANT='$qu' where cartid='$h->{'CARTID'}' and SKU = '$h->{'SKU'}' and VCODE = '$h->{'VCODE'}'";
 
 
         $dbs->do($q);
 
      }
 
                
      ## now update inventory as needed ONLY FOR TEST ORDERS!
      #     TBD
      if ( $test==1 ) {  # this is a test order, return inventory to store
         $q="UPDATE inventory SET QUANT=QUANT+$h->{'HQUANT'} ";
         $q.=" where SKU='$h->{'SKU'}' and VCODE='$h->{'VCODE'}' and WH='$h->{'WH'}' ";
         if ( $h->{'HQUANT'} ) {
            $dbs->do( $q );
         } # else there was no hard quantity allocation for this...
      } # end of test mode inventory reversion
      # done with row ...
   } # end of moving rows from ccart to scart

   ## remove rows from ccart...
   $q="DELETE from tcart where SID=$sid";
   $dbs->do( $q );

   ## cleanup
   #
   $sts->finish if ( $sts );
   $dbs->disconnect;

   return $num;
} #/tcart_to_ocart


## tcart_to_inventory : $s - moves items from tcart to inventory
#     returns a string stating how many items were moved
#
sub tcart_to_inventory {
   
   my($putback,$l, $numl, $stl, $dvalue,$sid,$sidwh,$nextwh,$dbs,$sts,$stc,$num,$q,$rv,$h,$now, $oid);
   $sid = $_[0];
   $sidwh = $_[1];
   $nextwh = $_[2];
   $rv="";
   $now=time();

   if ( $sid < 0 ) {  # error! no sid!
      $rv="Error - No Session ID! Nothing transfered from inventory!";
   } # don't bother to proceed if no sid
  
   ## establish connection to the database
   #
   $s="$site->{'db_site_config'}";
   $dbs=DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

   ## run through tcart rows and create tcart rows, adding inventory
   #    back to stock for hard inventory items
   #
   $q = " SELECT * from tcart where SID='$sid' ";
   $sts = $dbs->prepare( $q );
   $sts->execute;
   $num=$sts->rows;

   foreach ( 1..$num ) {
      ## there are rows to move. 

      $h=$sts->fetchrow_hashref;
    
      $l = " SELECT dvalue from levents where DTABLE='orders' and DVALUE LIKE '\%success\%' and DVALUE LIKE '$h->{'OID'}\t\%' ";
      $stl=$dbs->prepare($l);
      $stl->execute;
      $numl=$stl->rows;

      if ($numl < 1) {
     
      $q="UPDATE inventory SET LSTOCK=LSTOCK+'$h->{'HQUANT'}' ";
      $q.=" where SKU='$h->{'SKU'}' and wh='$h->{'WH'}' and vcode='$h->{'VCODE'}' ";
      if ( $h->{'HQUANT'} ) {
         $dbs->do( $q );
	 $q=" UPDATE tcart SET HQUANT='0' where lineid='$h->{'LINEID'}' ";
         $dbs->do($q);


      } # else there was no hard quantity allocation for this...

}
      # done with row ...
   } # end of moving rows from ccart to scart

   ## remove rows from ccart...

   if ($numl == 1) {

   $q="DELETE from tcart where SID='$sid' and UID='$h->{'UID'}' and wh='$sidwh' ";
   $dbs->do( $q );

    $q="DELETE from tcart where SID='$sid' and UID='$h->{'UID'}' and wh='$nextwh' ";
   $dbs->do( $q );
   

}


   ## cleanup
   #
   $sts->finish if ( $sts );
   $dbs->disconnect;

   return $num;
} #/tcart_to_inventory

 ## pcart_to_tcart
 #
 #
 sub pcart_to_tcart {
       my ($sid, $uid, $pcartstring, $pcartvalstring, $lineid, $dbdrive, $tmp_str, $stl, $numlines);
       my $h = ();
       $sid = $_[0];
       $uid = $_[1];
       $lineid = $_[2];
       $error = 0;
       ## Add input checking here
       $tmp_str="$site->{'db_site_config'}";
       $dbdrive=DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

       $tmp_str = "SELECT * from pcart where LINEID='$lineid' and UID='$uid'";
       $stl=$dbdrive->prepare($tmp_str);
         $stl->execute;
       $numlines = $stl->rows;
 
       if ($numlines == 1)
       {
          $h = $stl->fetchrow_hashref;
          $pcartstring = '(';
          $pcartvalstring = '(';
          $commastring = '';
          foreach $k (keys %{$h}) {
             next if (!$h->{$k});
             next if ($k eq 'SID');
             $pcartstring .= $commastring . $k;
             $pcartvalstring .= $commastring . "'" . $h->{$k}."'";
             if (!$commastring) {$commastring = ',';}
          }
 
 
          $pcartstring .= ',SID)';
          $pcartvalstring .= ",'$sid')";
 
          $tmp_str = "INSERT into tcart $pcartstring VALUES $pcartvalstring";
          $stl=$dbdrive->prepare($tmp_str);
          $stl->execute;
          $error = 1;
       }
       $stl->finish if ( $stl );
       $dbdrive->disconnect;
 
 
    return $error;
 }                     
 ## tcart_to_pcart
 # clone of pcart to tcart
 #
 sub tcart_to_pcart {
 
       my ($sid, $uid, $pcartstring, $pcartvalstring, $lineid, $dbdrive, $tmp_str, $stl, $numlines);
       my $h = ();
       $sid = $_[0];
       $uid = $_[1];
       $lineid = $_[2];
       $error = 0;
       ## Add input checking here
       $tmp_str="$site->{'db_site_config'}";
       $dbdrive=DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'}); 

       $tmp_str = "SELECT * from tcart where LINEID='$lineid' and SID='$sid'";
 
       $stl=$dbdrive->prepare($tmp_str);
       $stl->execute;
       $numlines = $stl->rows;
 
       if ($numlines == 1)
       {
          $h = $stl->fetchrow_hashref;
          $pcartstring = '(';
          $pcartvalstring = '(';
          $commastring = '';
          foreach $k (keys %{$h}) {
             next if (!$h->{$k});
             next if ($k eq 'UID');
             $pcartstring .= $commastring . $k;
             $pcartvalstring .= $commastring . "'" . $h->{$k}."'";
             if (!$commastring) {$commastring = ',';}
          }
 
 
          $pcartstring .= ',UID)';
          $pcartvalstring .= ",'$uid')";

          $tmp_str = "INSERT into pcart $pcartstring VALUES $pcartvalstring";
          $stl=$dbdrive->prepare($tmp_str);
          $stl->execute;
 
          $error = 1;
      }
 
      $stl->finish if ( $stl );
      $dbdrive->disconnect;
 
 
 
      return $error;
 }
                 

## cartaddcheck gets( sku,var,sid,quant,unitpr ): outputs(lineid,quant,err);
#
# Version 0.7.21 20000507 GF
#    cartslass
# Version 0.7.20 20000504 GF 
#    OBJID for sku,vcode
#
# Version 0.7.19 20000414 GF
#
sub cartaddcheck {
  my($add,$cartid,$event,$series,$num,$dbs,$sts,$sku);
  my($lineobjid,$sid,$quant,$availquant,$err,$q,$q2,$qp,$unitpr);
  my($st,$lstock,$linetotal,$wh,$addrid,$custid,$cartclass);

  ( $add,$quant,$lineid,$sid,$cartclass,$addrid,$custid ) = @_;

   ## get the time
   #
   $now=time();

   print ERLOG " \n in cartaddcheck\n";
   print ERLOG "( $add,$quant,$lineid,$sid,$cartclass,$addrid,$custid )\n";
   print ERLOG "add is $add\n";

   ## check to see if have a requested quantity, if we don't 
   #  set it to the requested $add

   print ERLOG "quant is $quant\n";

   if (!$quant) { 
      $quant=$add;
      $availquant=$quant;
   } 
   print ERLOG "availquant is $availquant \n";


   if ( $sid < 1 ) {         # assume the sid is good!
                             # validated before user got here 

      $err="Error - no session id!";
      return( 0,0,$err );
   } 

   ## see if user is looking for wishlist or registry
   #
   if ( ($cartclass eq '81000-A') || ($cartclass eq '81002-A') ) {

      if ( $custid eq '' ) {    # must have uid for 
                                # registry and wishlist

         $err="Error - no user custid!";
         return (0,0,$err );
      }

      $db_cart = 'pcart';

   } else {
      $db_cart = 'tcart';
   }
 

   ## find the customer's existing cart entry for this item
   #
   $q="SELECT orderid ";
   $q.=" from $db_cart where ";
 
      if ($cartclass eq "81002-A") {         # wish list
         $q.=" custid='$custid' and objclass='81002-A'";
 
      } elsif ($cartclass eq "81000-A"){     # gift registry
         $q.=" and objclass='81000-A' and orderid='$cartid' ";
 
      } else {
         $q.=" sid='$sid' ";
      }
 
   $sts = $dbh->prepare( $q );
   $sts->execute;
   $num=$sts->rows;
   
   $cart_element=$sts->fetchrow_hashref;
 
   print ERLOG "$q\n";
   print ERLOG "do we have an orderid in the cart? $num \n"; 

   foreach ( 1..$num ) { 

print ERLOG "--------- We have $num records in cart ----------- \n";
print ERLOG "cart orderid is $cart_element->{'orderid'} \n";


      if ( exists($cart_element->{'orderid'}) ) {
         $orderid=$cart_element->{'orderid'};

         print ERLOG "orderid id $orderid\n";

                                           # they dont have this item in 
                                           # there cart but have an orderid
      } else {
                                           # no orderid
         $create_orderid=1;
      }
} #/end foreach

   print ERLOG " before creation of orderid and orderis is now $orderid\n";

   if  (  ( $num==0 ) || $create_orderid  ) {  # no orderid found for this user
 
                                     # create an orderid

       $dvalue="$sid\t Create OrderID";

       $q="INSERT into levents (dtable,dvalue,cdate,series) values ";
       $q.=" ('tcart','$dvalue','$now','$site->{'series'}') ";
       $dbh->do($q);

       $q="SELECT event,series from levents where dtable='tcart' ";
       $q.= " and dvalue='$dvalue' and cdate='$now' ";
       $sts=$dbh->prepare($q);
       $sts->execute;
       ($event, $series)=$sts->fetchrow;
       $orderid=$event."-".$series;

    print ERLOG "Created orderid for user: $orderid\n";

    }

#for the gift registry, use addrid for the orderid
#if ( !$addrid ) {
#$create_orderid=0;
#$orderid=$addrid;
#}    


print ERLOG "orderid is $orderid \n";

   ## now actually check the cart to see if the user this item in cart
   #
   $q="SELECT orderid,objid,sid,msku,vcode,wh,quant,linetotal from $db_cart ";
   $q.=" where lineobjid='$lineid' ";
      if ($cartclass eq "81002-A") {
         $q.=" and orderid='$custid' and objclass='81002-A'";
 
      } elsif ($cartclass eq "81000-A"){
         $q.=" and cartclass='81000-A' and orderid='$orderid'";
 
      } else {
         $q.=" and sid='$sid' and wh='$wh'";
      }
 
   $sts = $dbh->prepare( $q );
   $sts->execute;
   $num=$sts->rows;
 
print ERLOG "$q \n";
print ERLOG "$num \n";
 
   if ( $cartclass ne '81002-A' ) {        # check to see if item is in
                                            # cart, then update quantity
 
      if ( $num==1 ) {                      # item exists in the cart
 
         ($orderid,$objid,$sid,$msku,$vcode,$wh,$cquant,$linetotal)=$sts->fetchrow;
 
 
print ERLOG " before creation of orderid and orderis is now $orderid\n";
print ERLOG " \n what is num now? $num \n";

print ERLOG "cquant is $cquant\n";

         if ( $cquant ) {               # add previous cart count 

            if ( $add ) {               # new quantity is the existing
                                        # quantity added with the requested 
                                        # amount
               $newquant=$cquant+$add;

            }  else {                   # new quantity is just the quantity 
               $newquant=$quant;
            }

            $quant=$newquant;           # set the new quantity to $quant
         } #/done with new quantity count
      } #/done adding previous cart count 
   } #/done updating cart quantity

print ERLOG "quantity has beed adjusted: $quant \n";

print ERLOG " now see if it is in inventory \n";

                                  # check inventory and see if 
                                  # product is in local stock 
   
   $q="SELECT lstock,wh,status from inventory ";
   $q.=" where objid='$lineid' and wh='$wh' and status='15000-A' ";
   $sts=$dbh->prepare( $q );
   $sts->execute;
   $num = $sts->rows;

print ERLOG "$q \n";
print ERLOG "is this in inventory local stock? $num\n";

   if ( $num == 1 )  {            # there should be only one 
                                  # record matching

   ($lstock,$warehouse,$status) = $sts->fetchrow;

   } else {                       # TBD 
                                  # we have a problem - error
                                  # cannot place object in cart
   }
   
                                  # get the objects behavior and 
                                  # check the inventory rules 

print ERLOG " ---------- is this a master product or variant -----\n";

   $q="SELECT msku,vcode,ref_from,behavior from things where objid='$lineid' ";
   $sts=$dbh->prepare( $q );
   $sts->execute;
   $num=$sts->rows;

   ( $msku,$vcode,$ref_from,$behavior ) = $sts->fetchrow; 

print ERLOG "ref from is $ref_from, behavior is $behavior \n";


if ( length($ref_from)>2 ) {  # refrom larger than 2
#this is either a master or variant

print ERLOG " in if, must be master or variant \n";


   if ( $lineid eq $ref_from ) { # master product
     # can't add master product to cart
   $num=0;
   $master=1;

print ERLOG "this is a master product\n";

   } else { # variant
     
   $q="SELECT behavior from things where objid='$ref_from' ";
   $sts=$dbh->prepare( $q );
   $sts->execute;
   $num=$sts->rows;
   ( $behavior ) = $sts->fetchrow;

print ERLOG "this is a variant\n";

   }

} 

print ERLOG "$q \n"; 
                         
  ## now lets check the behavior to see if we can sell this product
  #
 
    ## classes coded
    # 90000-A special order if no stock
    # 90001-A special order regardless of stock
    # 90002-A jit saleable if no stock
    # 90003-A back orderable if no stock
    # 90004-A advance orderable if no stock
    # 90005-A potentially restockable if no stock
    #            ( ok to add to wish list or notify me list )
    # 90006-A saleable irrespective of stock
    # 90007-A discontinued
    # 90008-A recalled
    ##                

   if ( $cartclass eq 'wish' || $cartkind eq 'REG' ) {
      $num="1";
   }

   if ( $num==1 ) { 

    print ERLOG "\n\n  behavior is $behavior \n";


                               # inventory site limit rules
                               # jit limit      $site_limit_jit
                               # general limit  $site_limit_all
   
                               # see how it compares to the request

                               # jit -  compare to limit plus positive 
                               # stock only

     if ( $behavior eq '90002-A' || $cartclass eq '81002-A' || $cartclass eq '81000-A') {
         $limitjit=$site->{'site_limit_jit'};
         $limitjit+=$x if ( $x > 0 ); 

                               # jit error message

         if ( $quant > $limitjit ) {
            #error - Sorry quantity is limited to this item.
            $err="1";
            $availquant=$limitjit;

         } else {
               $availquant=$quant;
         } #/examining JIT scenarios

      } else {                 # quantity exceeds site limit 

         if (( $quant > $site->{'site_limit_all'} ) or ( $quant > $lstock )) {

            if ( $lstock > 0 ) {                 # stock available
               # error - Sorry, we have a quantity limit on this item.
               $err="2";

                  # quantity requested is more than lstock
                  if ( $quant > $lstock ) {
                     # set quant to local stock 
                     $availquant=$lstock; 
                  }

                  # quantity is more than site limit 
                  if ( $quant > $site->{'site_limit_all'} ) { 
                     # quant set to site limit
                     $availquant=$site->{'site_limit_all'};
                  }

               } else {                         # item is out of stock  
                  # error - Sorry, but this item is now out of stock.
                  $err="3";
                  $availquant=0;
               } # /done with available stock

             } else {                            # just give them what they 
                                                 # requested 
                  $availquant=$quant;

            } #/done with limits
         }  #/done with quantity adjustment logic
      } #/done with cartkind check

   print ERLOG "done checking inventory rules, quant is $availquant\n";

   ## item is not in cart, add item to cart
   #
   
   ## add or update the row
   #

   # calculate linetotal
   if ( $availquant > 0 ) {            # updating cart 

      $q="SELECT unitpr from prices where objid='$lineid' and ";
      $q.=" status='15000-A' ";
      $sts=$dbh->prepare( $q );
      $sts->execute; 

      $unitpr=$sts->fetchrow;

print ERLOG "$q \nprice is: $unitpr \n";

      ## unit price x quantity available
      #
      $linetotal=$unitpr*$availquant;

print ERLOG "linetotal is: $linetotal \n";
print ERLOG "glenn ----- order id $orderid\n";

   if ( ( $objid == 0 ) and ( !$master ) ) {         # new item
                                # create the entry for this sid

      $dvalue="$sid\t Create ObjectId";    # used to be lineid

      $q="INSERT into levents (dtable,dvalue,cdate,series) values ";
      $q.=" ('tcart','$dvalue','$now', '$site->{'series'}') ";
      $dbh->do($q);
 
      $q="SELECT event,series from levents where dtable='tcart' ";
      $q.= " and dvalue='$dvalue' and cdate='$now' ";
      $sts=$dbh->prepare($q);
      $sts->execute;
      ($event, $series)=$sts->fetchrow;
      $objid=$event."-".$series;  

      ## insert line in to cart
      #
      if ( $addrid ) {
             $cartclass = 'REG';
      }

         $q=" INSERT INTO $db_cart ";
         $q.=" (objid,orderid,sid,msku,vcode,quant,wh,cdate,mdate,unitpr,";
         $q.=" linetotal,lineobjid,objclass,custid) ";
         $q.=" values ";
         $q.="('$objid','$orderid','$sid','$msku','$vcode','$availquant','$wh','$now' ";
         $q.=" ,'$now','$unitpr','$linetotal','$lineid','$cartclass','$custid' ) ";
         $dbh->do( $q );

print ERLOG "$q \n";

   } # end of decision on whether or not, and how, to add the item

 } #/done adding product if inventory is greater than one

# fuck

print ERLOG "------------ Before Update -----------\n";
print ERLOG " orderid is $orderid \n";

   ## already one in cart do an update
   #
   if ( $orderid > 0 ) {    # update cart, adding another item
 
       ## create an event for this action
       #
       $q="UPDATE $db_cart SET wh='$wh', linetotal='$linetotal', ";
       $q.=" quant='$availquant', mdate='$now' where objid='$objid'";
       $dbh->do( $q );

   } #/update existing row 

   ## check for addition of master product
   #
   if ( $master ) {
      $err="4";
   }

print ERLOG "------------------- return $err\n";

   close(X); 
   return ( $objid,$availquant,$err );
} # /cartaddcheck

##  setsessionid(): $s - checks %FORM for sid, if needed sets cookie
#                       and returns either sid > 0 or 0
#
#        v6 2000521 GF - retrofit to 0.9 datastructure
#        v5 2000112 RF - removed %FORM dependancies, read data from
#                       the %ENV ( as $ENV{'REQUEST_URI'} ) instead
#        v4 991027  IB - changed setsessionid to return sid > 0 or 0
#        v3 991023  RF - added handling of AFFILIATE for affiliate referrals
#                       and cleanup of diagnostic printing to logfile
#        v2 981213  RF - added handling of ADBUY and ARTWORK
#        v1 981204  RF
#
sub setsessionid {
   my( $sid,$dbh,$s,$q,$sts,$now,$x,$adbuy,$artwork,$referer );

   $sid=0;

   ## read URI domain name and use for setting cookie
   #
   $td=$ENV{'SERVER_NAME'};

   $adbuy="";
   $artwork="";
   $referer="";

   ## parse out the affiliate, advert or adbuy, and artwork parameters
   #  from the $ENV{''} (do not require call to read_parse in cgi-lib.pm
   #  for the setting of session ids -- all required data is in the raw
   #  environment parameters).
   #

   $adbuy = ( $ENV{'REQUEST_URI'} =~ /(?:adbuy|advert)=(.*?)(?:$|\&)/o )[0];
   $adbuy="" if ( ! $adbuy );
   $affiliate = ( $ENV{'REQUEST_URI'} =~ /affiliate=(.*?)(?:$|\&)/o )[0];
   $affiliate="" if ( ! $affiliate );
   $artwork = ( $ENV{'REQUEST_URI'} =~ /artwork=(.*?)(?:$|\&)/o )[0];
   $artwork="" if ( ! $artwork );

   $referer=$ENV{'HTTP_REFERER'} if ( exists($ENV{'HTTP_REFERER'}) );

   ## do not read the FORM hash, read the ENV{HTTP_COOKIE} directly
   if ( ! $ENV{'HTTP_COOKIE'} ) {
      ## there is no cookie, see if we have a sid in the FORM
      #  and attempt to set a cookie
      #
      if ( $FORM{'sid'} ) {
         # there is a session id, just no cookie
         $sid=$FORM{'sid'};
      } else {
         # there is no session id, get a new one
         $now = time();

         ## establish connection to database
         #
         $s="$site->{'db_site_config'}";
         $dbh=DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

         # get $sid before insert for msql - this is just temporary
         if ( $site->{'site_datadriver'} =~ /msql/ ) {
            $q="SELECT _sid FROM sessions";
            $sts=$dbh->prepare($q);
            $sts->execute;
            $sid=$sts->fetchrow; 
         }
         $q="INSERT into sessions (sid,browser,sourceip,";
         $q.="referer,adbuy,artwork,cdate,mdate) ";
         $q.=" VALUES ";
         if ( $site->{'site_datadriver'} =~ /msql/ ) { 
            $q.=" ($sid,'$ENV{'HTTP_USER_AGENT'}','$ENV{'REMOTE_ADDR'}',";
         }  else {
            $q.=" (0,'$ENV{'HTTP_USER_AGENT'}','$ENV{'REMOTE_ADDR'}',";
         }

         $q.="'$referer','$adbuy','$artwork',$now,$now) ";
         $sts = $dbh->prepare( $q );
         $sts->execute;

         # get $sid after insert - this is just temporary 
         if ( $site->{'site_datadriver'} =~ /mysql/ ) {
            $sid=$sts->{mysql_insertid};
         } elsif ( $site->{'site_datadriver'} =~ /informix/ ) {
            $sid=$sts->{ix_sqlerrd}[1];
         } elsif ( $site->{'site_datadriver'} =~ /postgresql/ ) {
            $q="SELECT currval('sid')";
            $sts=$dbh->prepare($q);
            $sts->execute;
            $sid=$sts->fetchrow;
         } elsif ( $site->{'site_datadriver'} =~ /oracle / ) {
            $q="SELECT sid.currval FROM sessions";
            $sts=$dbh->prepare($q);
            $sts->execute;
            $sid=$sts->fetchrow;
         } 
         $sts->finish;
         $dbh->disconnect;

         $FORM{'sid'}=$sid;

      } # done entering log data in database 

      ## now set the cookie
      #
      print "Set-Cookie: sid=$sid; path=/; domain=$td\n";
      # the cookie has been set

   } else {
      ## there is a cookie, see if it contains the sid, if not, set new
      #
      @temp=split /;(\s*)/, $ENV{'HTTP_COOKIE'};
      while (@temp) {
         $kv = shift @temp;
         ( $k,$v ) = split /=/,$kv,2 ;
         if (( $k eq "sid" )) {
             $sid=$v if ( $k eq "sid" );
         } # done looking for a sid
      } # done walking through bits
      if ( $sid>0 ) {
         # it contains the sid, all is well
      } else {
         # there is no session id, get a new one
         $now = time(); 

         # get the next sid and set it as a cookie?
         $s="$site->{'db_site_config'}";
         $dbs=DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});
           
         # get $sid before insert for msql - this is just temporary
         if ( $site->{'site_datadriver'} =~ /msql/ ) {
            $q="SELECT _sid FROM sessions";
            $sts=$dbs->prepare($q);
            $sts->execute;
            $sid=$sts->fetchrow;
         }
         $q="INSERT into sessions (sid,browser,sourceip,";
         $q.="referer,adbuy,artwork,cdate,mdate) ";
         $q.=" VALUES ";
         if ( $site->{'site_datadriver'} =~ /msql/ ) {
            $q.=" ($sid,'$ENV{'HTTP_USER_AGENT'}','$ENV{'REMOTE_ADDR'}',";
         }  else {
            $q.=" (0,'$ENV{'HTTP_USER_AGENT'}','$ENV{'REMOTE_ADDR'}',";
         }

         $q.="'$ENV{'HTTP_REFERER'}','$adbuy','$artwork',$now,$now) ";
         $sts = $dbs->prepare( $q );
         $sts->execute;

         # get $sid after insert - this is just temporary
         if ( $site->{'site_datadriver'} =~ /mysql/ ) {
            $sid=$sts->{mysql_insertid};
         } elsif ( $site->{'site_datadriver'} =~ /informix/ ) {
            $sid=$sts->{ix_sqlerrd}[1];
         } elsif ( $site->{'site_datadriver'} =~ /postgresql/ ) {
            $q="SELECT currval('sid')";
            $sts=$dbs->prepare($q);
            $sts->execute;
            $sid=$sts->fetchrow;
         } elsif ( $site->{'site_datadriver'} =~ /oracle / ) {
            $q="SELECT sid.currval FROM sessions";
            $sts=$dbs->prepare($q);
            $sts->execute;
            $sid=$sts->fetchrow;
         }
         $sts->finish;
         $dbs->disconnect;

         print "Set-Cookie: sid=$sid; path=/; domain=$td\n";
         $FORM{'sid'}=$sid;

      }#done with permutations of "they had a cookie, but..."
   } # done examining the cookie

   return $sid;
} #/setsessionid


# Functions included:
#    list_ship_methods( tocntry, tozip, weight [,frmcntry [,frmzip ]] ) :
#        @(sku:price:method name)
#
#
#
#
### list_ship_methods
##     returns an array of join-ed sku, price, method name for the parcel
##     args: ( tocountry, tozip, weight [,fromcountry [,fromzip ]] ) : @array
##     NEW 990524 RF
#
sub list_ship_methods {
   # Takes globals: $site->{'site_db_connect'};
   my( $timeflag, $tocntry,$tozip,$fromcntry,$nextwh, $fromzip,$weight,$weekend, @methods,$sth,$q,$num,$i, $old, $promoflag, $merchandise );
   my( $title,%titles,$site );
   @methods=();
   %titles=();

   ( $tocntry,$tozip,$weight, $fromcntry,$fromzip ) = @_;

   ## check arguments and set defaults or throw an error message
   #
   $fromcntry = "USA" if ( ! $fromcntry );
   $tocntry = "USA" if ( ! $tocntry );
   $weight=1.0 if ( ! $weight );


   if ( ! $tozip ) {
      @methods = ( "ERROR - insufficient data to price shipping!",
                   "ERROR - $tocntry,$tozip,$weight,$fromcntry,$fromzip" );
      return @methods;
   } # done with exit early passing error messages

   ## get list of active shipping methods ( STATUS="pn" )
   #
   ## HACK RF 3-990526 to accomodate System V style calls
   #

   $q = 'SELECT * from things ';
   $q.= "where STATUS='pn' and SKU LIKE 'xsp%' ";
   $sth=$dbh->prepare($q);
   $sth->execute;
   $num=$sth->rows;
   foreach ( 1..$num ) {
      $h = $sth->fetchrow_hashref;
      $titles{$h->{'SKU'}} = $h->{'TITLE'};
   } # done loading active shipping methods
   $sth->finish if ( $sth );
   if ( $num<1 ) { # exit early...
      @methods = ( "ERROR - no available shipping methods!",
                   "ERROR - $tocntry,$tozip,$weight,$fromcntry,$fromzip" );
      return @methods;
   } # done with nothing found branch

   ## prepare querry
   $q = "SELECT * from zonemap where destzipmn<='$tozip' and destzipmx>='$tozip' ORDER BY SHIPMETH ";

   $sth=$dbh->prepare( $q );
   $sth->execute;
   $num = $sth->rows;

   if ( $num<1 ) {   # no available shipping....
      @methods = ( "ERROR - no shipping available to destination!",
                   "ERROR - $tocntry,$tozip,$weight,$fromcntry,$fromzip" );
      $sth->finish;
      return @methods;
   } # done with nothing found branch
   $old="old";
$old2="old";   
## construct available methods...
   foreach $i ( 1..$num ) {
      $h = $sth->fetchrow_hashref;
     next if ( ! $titles{$h->{'SHIPMETH'}} || ($old eq $h->{'SHIPMETH'} && $old2 eq $h->{'SHIPZONE'} ) );
     $old=$h->{'SHIPMETH'};
$old2=$h->{'SHIPZONE'};
     $q = join "\t", ("$h->{'SHIPMETH'}","$h->{'SHIPZONE'}" );
      push @methods, ( $q );
   } # done constructing list of methods

   ## now get costs for each available method
   foreach $i ( 0..$#methods ) {
     ( $meth,$zone ) = split /\t/, $methods[$i];
      $q = 'SELECT * from zonerate where ';
      $q.= "SHIPMETH='$meth' and SHIPZONE='$zone' and SHIPWT>='$weight' ";
      $q.= "ORDER BY SHIPWT ";
      $sth=$dbh->prepare($q);
      $sth->execute;
      $num = $sth->rows;


      if ( $num>=1 ) {  # just need the first returned record
         $h = $sth->fetchrow_hashref;
         $methods[$i] = join "\t", ( $meth,$h->{'SHIPCOST'},$titles{$meth} );
      } else {          # this isn't available for here
         $methods[$i]="ERROR - method not available for this location";
      } # done with decision on results

   } # done  getting costs
   ## disconnect and cleanupy
   #
   $sth->finish if ( $sth );

   # cleanup error rows from list
   @temp=();
   while ( @methods ) {
      $l = shift @methods;
      next if ( $l =~ /^ERROR/ );
      push @temp, ( $l );
   }
   @methods=@temp;

   return @methods;
} # /list_ship_methods

1;

